package org.atlas.streetgeocoder;


import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

public class DataTest {

    public static void main(String[] args) throws SQLException, ClassNotFoundException, IOException {
        Class.forName("org.postgresql.Driver");
        String url = "jdbc:postgresql://localhost/atlas?user=postgres&password=postgres";
        Connection conn = DriverManager.getConnection(url);
        Statement sta = conn.createStatement();
        String sql = "SELECT atlas27_id, the_geom, name, binmdata, binintersectdata   FROM \"calles pasto\";";
        ResultSet rs = sta.executeQuery(sql);

        ArrayList<StreetData> list = new ArrayList<StreetData>();

        Map<String, StreetData> nameMap = new HashMap<String, StreetData>();
        Map<Integer, StreetData> idMap = new HashMap<Integer, StreetData>();

        while (rs.next()) {
            StreetData sd = new StreetData();
            sd.setBinCrossing(rs.getBytes("binintersectdata"));
            sd.setBinMData(rs.getBytes("binmdata"));
            sd.setId(rs.getInt("atlas27_id"));
            sd.setName(rs.getString("name"));
            nameMap.put(sd.getName(), sd);
            idMap.put(sd.getId(), sd);
        }

        /*StreetData[] streets = new StreetData[nameMap.values().size()];
        nameMap.values().toArray(streets);*/

        String streetName = "cl 9";

        StreetData sd = nameMap.get(streetName);
        for (int j = 0; j < sd.getMData().length; j++) {
            System.out.println(sd.getMData()[j]);
        }

        for (int j = 0; j < sd.getCrossing().length; j++) {
            StreetCrossing sc = sd.getCrossing()[j];
            StreetData sdt = idMap.get(sc.getAgainst());
            System.out.println(sdt.getName() + " " + sc.getM());
        }
    }
}
