package org.atlas.streetgeocoder;

import com.vividsolutions.jts.geom.MultiLineString;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

public class StreetData {
    
    private int id;
    private String name;
    private MultiLineString data ;
    private double[] mData;
    private StreetCrossing[] crossing;
    
    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public MultiLineString getData() {
        return data;
    }

    public void setData(MultiLineString data) {
        this.data = data;
    }

    public double[] getMData() {
        return mData;
    }

    public void setMData(double[] mData) {
        this.mData = mData;
    }

    public StreetCrossing[] getCrossing() {
        return crossing;
    }

    public void setCrossing(StreetCrossing[] crossing) {
        this.crossing = crossing;
    }
    
    public byte[] getBinMData() throws IOException{         
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        ObjectOutputStream oos = new ObjectOutputStream(baos);
        oos.writeObject(mData);
        oos.close();
        return baos.toByteArray();
    }
    
    public void setBinMData(byte[] bin) throws IOException, ClassNotFoundException{
        ByteArrayInputStream bais = new ByteArrayInputStream(bin);
        ObjectInputStream ois = new ObjectInputStream(bais);
        setMData((double[])ois.readObject());
    }
    
    public byte[] getBinCrossing() throws IOException {
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        ObjectOutputStream oos = new ObjectOutputStream(baos);
        oos.writeObject(crossing);
        oos.close();
        return baos.toByteArray();
    }
    
    public void setBinCrossing(byte[] bin) throws IOException, ClassNotFoundException {
        ByteArrayInputStream bais = new ByteArrayInputStream(bin);
        ObjectInputStream ois = new ObjectInputStream(bais);
        setCrossing((StreetCrossing[])ois.readObject());
    }
    
}
