/*
 * Created on 17 de junio de 2007, 23:12 PM
 */
package windows.configuration;

import java.util.Locale;
import javax.swing.JFrame;
import org.atlas.util.Configuration;
import org.atlas.i18n.LocaleUtil;
import org.atlas.util.WindowUtils;
import org.atlas.util.FrmWait;

/**
 * @author Mario R Eraso
 */
public class FrmConfiguration extends javax.swing.JDialog {

    private Configuration config;

    public FrmConfiguration() {
        super((JFrame) null, true);
        initComponents();
        WindowUtils.setFrameIcon(this, "/media/appicon.png");
        WindowUtils.center(this);
        config = Configuration.grantReadConfiguration("config.xml");
        if (config.getLocale().getLanguage().equals("")) {
            this.optLen2.setSelected(true);
        } else {
            this.optLen1.setSelected(true);
        }

    /*if(config.getLookAndFeel()==Configuration.SYSTEMLOOKANDFEEL){
    this.optLook1.setSelected(true);
    }else{
    this.optLook2.setSelected(true);
    }*/
    }

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        optGrpLen = new javax.swing.ButtonGroup();
        optGrpLook = new javax.swing.ButtonGroup();
        jPanel1 = new javax.swing.JPanel();
        optLen1 = new javax.swing.JRadioButton();
        optLen2 = new javax.swing.JRadioButton();
        jPanel2 = new javax.swing.JPanel();
        optLook1 = new javax.swing.JRadioButton();
        optLook2 = new javax.swing.JRadioButton();
        jPanel3 = new javax.swing.JPanel();
        btnCancel = new javax.swing.JButton();
        btnOk = new javax.swing.JButton();
        jPanel4 = new javax.swing.JPanel();
        btnManagePlugins = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("windows/messages",LocaleUtil.getLocale()); // NOI18N
        setTitle(bundle.getString("options")); // NOI18N

        java.util.ResourceBundle bundle1 = java.util.ResourceBundle.getBundle("windows/configuration/messages",LocaleUtil.getLocale()); // NOI18N
        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(bundle1.getString("lenguaje"))); // NOI18N

        optGrpLen.add(optLen1);
        optLen1.setText(bundle1.getString("es_co")); // NOI18N
        optLen1.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        optLen1.setMargin(new java.awt.Insets(0, 0, 0, 0));

        optGrpLen.add(optLen2);
        optLen2.setText(bundle1.getString("en_us")); // NOI18N
        optLen2.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        optLen2.setMargin(new java.awt.Insets(0, 0, 0, 0));

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(optLen1)
                    .addComponent(optLen2))
                .addContainerGap(289, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addComponent(optLen1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(optLen2)
                .addContainerGap())
        );

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(bundle1.getString("lafOptions"))); // NOI18N

        optGrpLook.add(optLook1);
        optLook1.setText(bundle1.getString("sys_laf")); // NOI18N
        optLook1.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        optLook1.setMargin(new java.awt.Insets(0, 0, 0, 0));

        optGrpLook.add(optLook2);
        optLook2.setText(bundle1.getString("java_laf")); // NOI18N
        optLook2.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        optLook2.setMargin(new java.awt.Insets(0, 0, 0, 0));

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(optLook1)
                    .addComponent(optLook2))
                .addContainerGap(293, Short.MAX_VALUE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addComponent(optLook1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(optLook2)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel3.setLayout(new java.awt.GridLayout(1, 0, 5, 0));

        btnCancel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/process-stop.png"))); // NOI18N
        btnCancel.setText(bundle1.getString("cancel")); // NOI18N
        btnCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelActionPerformed(evt);
            }
        });
        jPanel3.add(btnCancel);

        btnOk.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/go-next.png"))); // NOI18N
        btnOk.setText(bundle1.getString("continue")); // NOI18N
        btnOk.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnOkActionPerformed(evt);
            }
        });
        jPanel3.add(btnOk);

        java.util.ResourceBundle bundle2 = java.util.ResourceBundle.getBundle("windows/configuration/messages"); // NOI18N
        jPanel4.setBorder(javax.swing.BorderFactory.createTitledBorder(bundle2.getString("plug_ins"))); // NOI18N

        btnManagePlugins.setText(bundle2.getString("man_geocoder")); // NOI18N
        btnManagePlugins.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnManagePluginsActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(btnManagePlugins, javax.swing.GroupLayout.PREFERRED_SIZE, 256, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(160, Short.MAX_VALUE))
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addComponent(btnManagePlugins, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel3, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 281, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
    private void btnOkActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnOkActionPerformed
        /*if(this.optLook1.isSelected()){
        this.config.setLookAndFeel(Configuration.SYSTEMLOOKANDFEEL);
        }else{
        this.config.setLookAndFeel(Configuration.METALLOOKANDFEEL);
        }*/

        if (this.optLen1.isSelected()) {
            this.config.setLocale(new Locale("es", "co"));
        } else {
            this.config.setLocale(new Locale("", ""));
        }
        try {
            this.config.writeConfiguration("config.xml");
            WindowUtils.msgInfo(this, java.util.ResourceBundle.getBundle("windows/configuration/messages", LocaleUtil.getLocale()).getString("info_chan"));
        } catch (Exception ex) {
            ex.printStackTrace();
            WindowUtils.msgError(this, java.util.ResourceBundle.getBundle("windows/configuration/messages", LocaleUtil.getLocale()).getString("writeErr"));
        }
        this.setVisible(false);
    }//GEN-LAST:event_btnOkActionPerformed

    private void btnCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelActionPerformed
        this.setVisible(false);
    }//GEN-LAST:event_btnCancelActionPerformed

    private void btnManagePluginsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnManagePluginsActionPerformed
        FrmWaitImpl wait = new FrmWaitImpl();
        wait.setVisible(true);
        wait.getFrm().setVisible(true);
}//GEN-LAST:event_btnManagePluginsActionPerformed

    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new FrmConfiguration().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnCancel;
    private javax.swing.JButton btnManagePlugins;
    private javax.swing.JButton btnOk;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.ButtonGroup optGrpLen;
    private javax.swing.ButtonGroup optGrpLook;
    private javax.swing.JRadioButton optLen1;
    private javax.swing.JRadioButton optLen2;
    private javax.swing.JRadioButton optLook1;
    private javax.swing.JRadioButton optLook2;
    // End of variables declaration//GEN-END:variables

    private static class FrmWaitImpl extends FrmWait {
        private FrmManageGeocoderPlugins frm;
        @Override
        public void action() {            
            frm = new FrmManageGeocoderPlugins();
        }

        public FrmManageGeocoderPlugins getFrm() {
            return frm;
        }
    }
}
