package windows.configuration;

import org.atlas.geocoding.Geocoder;
import org.atlas.i18n.LocaleUtil;
import org.atlas.i18n.StringProvider;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;
import java.util.jar.Attributes.Name;
import java.util.jar.JarFile;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.filechooser.FileFilter;
import javax.swing.table.AbstractTableModel;
import org.atlas.util.Configuration;
import org.atlas.util.IOUtils;
import org.atlas.util.Plugins;
import org.atlas.util.WindowUtils;

public class FrmManageGeocoderPlugins extends javax.swing.JDialog {

    private JFileChooser file;                                                      
    private StringProvider prov;
    private pluginsTableModel ptm;

    public FrmManageGeocoderPlugins() {
        super((JFrame) null, true);
        initComponents();
        prov = new StringProvider("windows/configuration/messages");
        ptm = new pluginsTableModel();
        file = new JFileChooser();
        file.setFileSelectionMode(JFileChooser.FILES_ONLY);
        file.setAcceptAllFileFilterUsed(false);
        file.setFileFilter(new FileFilter() {

            public String getDescription() {
                return "JAR Files";
            }

            public boolean accept(File f) {
                return f.isDirectory() || f.getAbsolutePath().toLowerCase().endsWith(".jar");
            }
        });
        WindowUtils.setFrameIcon(this, "/media/appicon.png");
        jTable1.setModel(ptm);
        jTable1.getSelectionModel().addListSelectionListener(new ListSelectionListener() {

            public void valueChanged(ListSelectionEvent e) {
                if (jTable1.getSelectedRow() >= 0) {
                    btnRemove.setEnabled(true);
                    btnAbout.setEnabled(true);
                    return;
                }
                btnRemove.setEnabled(false);
                btnAbout.setEnabled(false);
            }
        });

        CargarLista();
    }

    private void CargarLista() {        
        Geocoder[] l = Plugins.getInstalledPlugins();
        ptm.clear();
        for (int i = 0; i < l.length; i++) {
            ptm.addGeocoder(l[i]);
        }
    }

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        btnAdd = new javax.swing.JButton();
        btnRemove = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        btnAbout = new javax.swing.JButton();
        btnClose = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("windows/configuration/messages"); // NOI18N
        setTitle(bundle.getString("frm_adm_geocoders")); // NOI18N
        setLocationByPlatform(true);

        btnAdd.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/plus.png"))); // NOI18N
        btnAdd.setToolTipText("");
        btnAdd.setIconTextGap(0);
        btnAdd.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnAdd.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAddActionPerformed(evt);
            }
        });

        btnRemove.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/trash.png"))); // NOI18N
        btnRemove.setToolTipText("");
        btnRemove.setDefaultCapable(false);
        btnRemove.setEnabled(false);
        btnRemove.setIconTextGap(0);
        btnRemove.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnRemove.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnRemoveActionPerformed(evt);
            }
        });

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane1.setViewportView(jTable1);

        btnAbout.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/about.png"))); // NOI18N
        btnAbout.setToolTipText("");
        btnAbout.setEnabled(false);
        btnAbout.setIconTextGap(0);
        btnAbout.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnAbout.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAboutActionPerformed(evt);
            }
        });

        btnClose.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/volver.png"))); // NOI18N
        java.util.ResourceBundle bundle1 = java.util.ResourceBundle.getBundle("windows/sources/messages",LocaleUtil.getLocale()); // NOI18N
        btnClose.setText(bundle1.getString("close")); // NOI18N
        btnClose.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCloseActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(btnClose, javax.swing.GroupLayout.PREFERRED_SIZE, 167, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(btnAdd)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnAbout)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnRemove))
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 497, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(btnRemove)
                    .addComponent(btnAbout)
                    .addComponent(btnAdd))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 243, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(btnClose, javax.swing.GroupLayout.PREFERRED_SIZE, 33, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
    private void btnRemoveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnRemoveActionPerformed
        String exit_now   = prov.getString("exit_now");
        String unex_error = prov.getString("unex_error");
        
        Geocoder del = getSelected();

        if (del == null) {
            return;
        }
        
        if (!WindowUtils.msgYesNo(this, prov.getString("want_to_del_plugin"))) {
            return;
        }

        File dir = new File(Configuration.getWorkingDirectory() + "plugins" + File.separator);
        
        File[] plugs = dir.listFiles();
        boolean found = false;
        for (int i = 0; i < plugs.length && !found; i++) {
            try {
                File jfile = plugs[i];
                JarFile jf = new JarFile(jfile);
                String classname = jf.getManifest().getMainAttributes().getValue(Name.MAIN_CLASS);
                jf.close();
                Class cl = Class.forName(classname);
                if (cl.isInstance(del)) {
                    found = true;
                    org.atlas.util.JarFile.editClassPath(org.atlas.util.JarFile.REMOVE_FROM_CLASSPATH, Configuration.getWorkingDirectory() + "admin.jar", "plugins/" + jfile.getName());
                    jfile.delete();
                    WindowUtils.msgInfo(this, exit_now);
                    System.exit(0);
                }
            } catch (Exception ex) {
                Logger.getLogger(FrmManageGeocoderPlugins.class.getName()).log(Level.SEVERE, null, ex);
                WindowUtils.msgError(this, unex_error);
            }
        }
        if (!found) {
            WindowUtils.msgError(this, unex_error);
        }
}//GEN-LAST:event_btnRemoveActionPerformed

    private void btnAddActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAddActionPerformed
        String exit_now   = prov.getString("exit_now");
        String unex_error = prov.getString("unex_error");
        
        if (file.showOpenDialog(null) == JFileChooser.APPROVE_OPTION) {
            FileInputStream fis = null;
            try {
                File arch = file.getSelectedFile();
                fis = new FileInputStream(arch);
                byte[] bin = IOUtils.readFromStream(fis);
                fis.close();

                String dest = Configuration.getWorkingDirectory() + "plugins";
                File dir = new File(dest);
                if (!dir.exists()) {
                    if (!dir.mkdir()) {
                        WindowUtils.msgInfo(this, unex_error);
                        return;
                    }
                }
                dest += (File.separator + arch.getName());
                FileOutputStream fos = new FileOutputStream(dest);
                IOUtils.writeToStream(bin, fos);
                fos.close();
                org.atlas.util.JarFile.editClassPath(org.atlas.util.JarFile.ADD_TO_CLASSPATH, Configuration.getWorkingDirectory() + "admin.jar", "plugins/" + arch.getName());
                WindowUtils.msgInfo(this, exit_now);
                System.exit(0);
            } catch (Exception ex) {
                Logger.getLogger(FrmManageGeocoderPlugins.class.getName()).log(Level.SEVERE, null, ex);
                WindowUtils.msgError(this, unex_error);
            } finally {
                try {
                    fis.close();
                } catch (IOException ex) {
                    Logger.getLogger(FrmManageGeocoderPlugins.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        }
}//GEN-LAST:event_btnAddActionPerformed

    private Geocoder getSelected() {
        int i = jTable1.getSelectedRow();
        if (i >= 0) {
            return ptm.list.get(i);
        }
        return null;
    }

    private void btnAboutActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAboutActionPerformed
        getSelected().getAboutDialog().setVisible(true);
}//GEN-LAST:event_btnAboutActionPerformed

    private void btnCloseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCloseActionPerformed
        this.setVisible(false);
    }//GEN-LAST:event_btnCloseActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new FrmManageGeocoderPlugins().setVisible(true);
            }
        });
    }

    private class pluginsTableModel extends AbstractTableModel {

        private String[] names = {prov.getString("name"), prov.getString("description")};
        private List<Geocoder> list = new ArrayList<Geocoder>();

        private void sort() {
            Collections.sort(list, new Comparator() {

                public int compare(Object o1, Object o2) {
                    return ((Geocoder) o1).getName().compareTo(((Geocoder) o2).getName());
                }
            });
        }

        public void addGeocoder(Geocoder g) {
            list.add(g);
            sort();
            fireTableDataChanged();
        }

        public void removeGeocoder(Geocoder g) {
            list.remove(g);
            sort();
            fireTableDataChanged();
        }

        public void clear() {
            list.clear();
            fireTableDataChanged();
        }

        @Override
        public Class<?> getColumnClass(int columnIndex) {
            return super.getColumnClass(columnIndex);
        }

        @Override
        public String getColumnName(int column) {
            return names[column];
        }

        @Override
        public boolean isCellEditable(int rowIndex, int columnIndex) {
            return false;
        }

        public int getRowCount() {
            return list.size();
        }

        public int getColumnCount() {
            return 2;
        }

        public Object getValueAt(int rowIndex, int columnIndex) {
            Object obj;
            switch (columnIndex) {
                case 0:
                    obj = list.get(rowIndex).getName();
                    break;
                case 1:
                    obj = list.get(rowIndex).getDescription();
                    break;
                default:
                    obj = "";
                    break;
            }
            return obj;
        }
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAbout;
    private javax.swing.JButton btnAdd;
    private javax.swing.JButton btnClose;
    private javax.swing.JButton btnRemove;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTable1;
    // End of variables declaration//GEN-END:variables
}
