package windows.controls;

import org.atlas.hibernatedata.AtlasColor;
import org.atlas.i18n.LocaleUtil;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import javax.swing.BorderFactory;
import javax.swing.JColorChooser;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.colorchooser.ColorSelectionModel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import org.atlas.util.WindowUtils;

/*
 * Created on 15 de junio de 2007, 09:06 AM
 */

public class AtlasColorChooserOpac extends javax.swing.JPanel {
    
    public JColorChooser chooser;
    public AtlasColor    color;
    
    private List<ChangeListener> changeListeners = new ArrayList<ChangeListener>();
    
    public AtlasColorChooserOpac() {
        initComponents();
        drawPreviewPanel();
        chooser = new JColorChooser();
        chooser.setPreviewPanel(new PreviewPanel(chooser));
    }
    
    public void setLabel(String label){
        jLabel2.setText(label);
    }
    
    public void addChangeListener(ChangeListener cl){
        changeListeners.add(cl);
    }
    
    public void removeChangeListener(ChangeListener cl){
        changeListeners.remove(cl);
    }
    
    private void fireChangeListeners(){
        Iterator<ChangeListener> it    = changeListeners.iterator();
        ChangeEvent ev = new ChangeEvent(this);
        while(it.hasNext()){
            it.next().stateChanged(ev);
        }
    }
    
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel2 = new javax.swing.JLabel();
        previewColor = new PreviewColorPanel();
        jButton1 = new javax.swing.JButton();

        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("windows/controls/messages",LocaleUtil.getLocale()); // NOI18N
        jLabel2.setText(bundle.getString("colokey")); // NOI18N

        previewColor.setBackground(new java.awt.Color(238, 20, 238));
        previewColor.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        javax.swing.GroupLayout previewColorLayout = new javax.swing.GroupLayout(previewColor);
        previewColor.setLayout(previewColorLayout);
        previewColorLayout.setHorizontalGroup(
            previewColorLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 118, Short.MAX_VALUE)
        );
        previewColorLayout.setVerticalGroup(
            previewColorLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 21, Short.MAX_VALUE)
        );

        jButton1.setText("...");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 42, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(previewColor, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton1))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jButton1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jLabel2, javax.swing.GroupLayout.DEFAULT_SIZE, 23, Short.MAX_VALUE)
            .addComponent(previewColor, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents
        
    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        JColorChooser.setDefaultLocale(LocaleUtil.getLocale());
        JDialog j =  JColorChooser.createDialog(this,java.util.ResourceBundle.getBundle("windows/controls/messages",LocaleUtil.getLocale()).getString("selcolorkey") ,true , chooser, null,null);
        j.setLocale(LocaleUtil.getLocale());
        chooser.setColor(color.getColor());
        j.setVisible(true);
        Color col = chooser.getColor();
        color.setRed(col.getRed());
        color.setGreen(col.getGreen());
        color.setBlue(col.getBlue());
        drawPreviewPanel();
        fireChangeListeners();
    }//GEN-LAST:event_jButton1ActionPerformed
    
    private void drawPreviewPanel(){
        PreviewColorPanel panel = (PreviewColorPanel)this.previewColor;
        if(color != null){
            panel.setColor(color.getRed(), color.getGreen(), color.getBlue(), color.getAlfa());
        }else{
            panel.setColor(0, 0, 0, 0);
        }
    }
    
    public void setColor(Color color){
        this.color = new AtlasColor();
        this.color.setAlfa(color.getAlpha());
        this.color.setRed(color.getRed());
        this.color.setGreen(color.getGreen());
        this.color.setBlue(color.getBlue());
        this.drawPreviewPanel();
    }
    
    public void setColor(AtlasColor color){
        this.color =  color;
        this.drawPreviewPanel();
    }
    
    public AtlasColor getColor(){
        return color;
    }
    
    @Override
    public void setEnabled(boolean b) {
        super.setEnabled(b);
        WindowUtils.setPanelChildrenEnabled(this, b);
        previewColor.setEnabled(b);
    }
    
    private class PreviewColorPanel extends JPanel{
        
        int r,g,b,a=0;
        
        public void setColor(int r,int g, int b, int a){
            this.r=r;
            this.g=g;
            this.b=b;
            this.a=a;
            this.repaint();
        }
        
        @Override
        public void paint(Graphics g){
            
            boolean ban = true;
            
            g.setColor(new Color(255,255,255,255));
            g.fillRect(0,0,this.getWidth(),this.getHeight());
            
            int i;
            g.setColor(new Color(224,224,224));
            for(int j=0; j<this.getHeight(); j+=5){
                ban = !ban;
                if(ban == true){ i=0; }else{ i=5; }
                while(i<this.getWidth()){
                    g.fillRect(i,j,5,5);
                    i+=10;
                }
            }
            if(isEnabled()){
                g.setColor(new Color(r,this.g,b,a));    
            }else{
                g.setColor(new Color(0,0,0,0));    
            }
            
            g.fillRect(0,0,this.getWidth(),this.getHeight());
        }
        
        @Override
        public void setEnabled(boolean b) {
            super.setEnabled(b);
            WindowUtils.setPanelChildrenEnabled(this, b);
            
        }
    }
    
    private class PreviewPanel extends JComponent {
        Color curColor;
        
        public PreviewPanel(JColorChooser chooser) {
            curColor = chooser.getColor();            
            ColorSelectionModel model = chooser.getSelectionModel();
            model.addChangeListener(new ChangeListener() {
                public void stateChanged(ChangeEvent evt) {
                    ColorSelectionModel model = (ColorSelectionModel)evt.getSource();
                    curColor = model.getSelectedColor();
                }
            }) ;
                        
            setPreferredSize(new Dimension(90, 60));
            setBorder(BorderFactory.createTitledBorder(""));
            
        }
                
        @Override
        public void paint(Graphics g) {
            g.setColor(curColor);
            g.fillRect(0, 0, getWidth()-1, getHeight()-1);
        }
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel previewColor;
    // End of variables declaration//GEN-END:variables
    
}
