/*
 * Created on 16 de junio de 2007, 06:12 PM
 */
package windows.controls;

import org.atlas.exceptions.HTTPRequestException;
import org.atlas.hibernatedata.Layer;
import org.atlas.hibernatedata.Project;
import org.atlas.hibernatedata.Service;
import org.atlas.i18n.LocaleUtil;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.net.ConnectException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;
import javax.swing.DefaultComboBoxModel;
import org.hibernate.classic.Session;
import org.atlas.util.HibernateUtil;
import org.atlas.util.ServiceConnection;
import org.atlas.util.WindowUtils;
import org.atlas.util.FrmWait;
import windows.geocoding.FrmAdminGeocoders;
import windows.projects.FrmNewProyect;
import windows.sources.FrmSources;

public class PnlProjects extends javax.swing.JPanel {

    private HibernateUtil hibernate;
    private Service service;
    private DefaultComboBoxModel model;
    private boolean working;
    private ServiceConnection serviceConnection;
    private List projectChangeListeners = new ArrayList();

    public void addProjectChangeListener(ActionListener al) {
        projectChangeListeners.add(al);
    }

    public void removeProjectChangeListener(ActionListener al) {
        projectChangeListeners.remove(al);
    }

    public void fireListeners(List cl) {
        ActionEvent ae = new ActionEvent(this, 0, "");
        for (int i = 0; i < cl.size(); i++) {
            ((ActionListener) cl.get(i)).actionPerformed(ae);
        }
    }

    public PnlProjects() {
        initComponents();
        WindowUtils.setPanelEnabled(this, false);
        model = new DefaultComboBoxModel();
        this.cmbPytos.setModel(model);
    }

    public HibernateUtil getHibernate() {
        return hibernate;
    }

    public void setHibernate(HibernateUtil hibernate) {
        this.hibernate = hibernate;
    }

    private void cargarArrayProj() throws Exception {
        Session sess = hibernate.begin();
        sess.update(service);
        Object[] projects = service.getProjects().toArray();
        Arrays.sort(projects);
        hibernate.close(sess);
    }

    private void cargarComboProj() {
        model.removeAllElements();
        Object[] projects = service.getProjects().toArray();
        if (projects.length > 0) {
            cmbPytos.setEnabled(true);
            Arrays.sort(projects);
            model.addElement(java.util.ResourceBundle.getBundle("windows/controls/messages", LocaleUtil.getLocale()).getString("sel_proj"));
            for (int i = 0; i < projects.length; i++) {
                model.addElement((Project) projects[i]);
            }
        } else {
            cmbPytos.setEnabled(false);
        }
        this.fireListeners(this.projectChangeListeners);
    }

    public Project getSelectedProject() {
        int index = this.cmbPytos.getSelectedIndex();
        if (index > 0) {
            return (Project) (model.getElementAt(index));
        }
        return null;

    }

    public Service getService() {
        return service;
    }

    public void reset() {
        this.hibernate = null;
        this.service = null;
        this.serviceConnection = null;
        try {
            this.setService(null);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    public void setService(Service service) throws Exception {
        this.service = service;
        if (service == null) {
            WindowUtils.setPanelEnabled(this, false);
            model.removeAllElements();
        } else {
            WindowUtils.setPanelEnabled(this, true);
            cargarArrayProj();
            cargarComboProj();
        }
    }

    public ServiceConnection getServiceConnection() {
        return serviceConnection;
    }

    public void setServiceConnection(ServiceConnection serviceConnection) {
        this.serviceConnection = serviceConnection;
    }

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jLabel1 = new javax.swing.JLabel();
        cmbPytos = new javax.swing.JComboBox();
        btnAddPrj = new javax.swing.JButton();
        btnRemPrj = new javax.swing.JButton();
        btnEditPrj = new javax.swing.JButton();
        btnSource = new javax.swing.JButton();
        btnGeocoders = new javax.swing.JButton();

        setLayout(new java.awt.GridBagLayout());

        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("windows/controls/messages",LocaleUtil.getLocale()); // NOI18N
        jLabel1.setText(bundle.getString("project")); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 10);
        add(jLabel1, gridBagConstraints);

        cmbPytos.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        cmbPytos.setMinimumSize(new java.awt.Dimension(400, 24));
        cmbPytos.setPreferredSize(new java.awt.Dimension(400, 24));
        cmbPytos.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmbPytosActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 20);
        add(cmbPytos, gridBagConstraints);

        btnAddPrj.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/plus.png"))); // NOI18N
        btnAddPrj.setToolTipText("");
        btnAddPrj.setIconTextGap(0);
        btnAddPrj.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnAddPrj.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAddPrjActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        add(btnAddPrj, gridBagConstraints);

        btnRemPrj.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/trash.png"))); // NOI18N
        btnRemPrj.setToolTipText("");
        btnRemPrj.setDefaultCapable(false);
        btnRemPrj.setEnabled(false);
        btnRemPrj.setIconTextGap(0);
        btnRemPrj.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnRemPrj.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnRemPrjActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 6;
        gridBagConstraints.gridy = 0;
        add(btnRemPrj, gridBagConstraints);

        btnEditPrj.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/stock-edit.png"))); // NOI18N
        btnEditPrj.setToolTipText("");
        btnEditPrj.setEnabled(false);
        btnEditPrj.setIconTextGap(0);
        btnEditPrj.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnEditPrj.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnEditPrjActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 10);
        add(btnEditPrj, gridBagConstraints);

        btnSource.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/data.png"))); // NOI18N
        btnSource.setDefaultCapable(false);
        btnSource.setEnabled(false);
        btnSource.setIconTextGap(0);
        btnSource.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnSource.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSourceActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 0;
        add(btnSource, gridBagConstraints);

        btnGeocoders.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/gftp.png"))); // NOI18N
        btnGeocoders.setDefaultCapable(false);
        btnGeocoders.setEnabled(false);
        btnGeocoders.setIconTextGap(0);
        btnGeocoders.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnGeocoders.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnGeocodersActionPerformed(evt);
            }
        });
        add(btnGeocoders, new java.awt.GridBagConstraints());
    }// </editor-fold>//GEN-END:initComponents
    private void btnEditPrjActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnEditPrjActionPerformed
        Project selected = getSelectedProject();
        if (selected != null) {
            try {
                FrmNewProyect frm = new FrmNewProyect(this.hibernate, this.service, selected, this.serviceConnection);
                frm.setVisible(true);
                if (!frm.isUserCancel()) {
                    cargarComboProj();
                }
            } catch (Exception ex) {
                WindowUtils.msgError(this.getRootPane(), java.util.ResourceBundle.getBundle("windows/controls/messages", LocaleUtil.getLocale()).getString("mshError1"));
                ex.printStackTrace();
            }
        } else {
            WindowUtils.msgError(this.getRootPane(), java.util.ResourceBundle.getBundle("windows/controls/messages", LocaleUtil.getLocale()).getString("msgError0"));
        }
    }//GEN-LAST:event_btnEditPrjActionPerformed

    private void btnRemPrjActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnRemPrjActionPerformed
        Project selected = getSelectedProject();
        if (selected != null) {
            if (WindowUtils.msgYesNo(this.getRootPane(), java.util.ResourceBundle.getBundle("windows/controls/messages", LocaleUtil.getLocale()).getString("msgError2"))) {

                try {
                    Session sess = hibernate.begin();
                    sess.update(selected);
                    List layers = new ArrayList();
                    Iterator<Layer> ite = selected.getLayers().iterator();
                    while (ite.hasNext()) {
                        layers.add(ite.next());
                    }
                    hibernate.close(sess);

                    ite = layers.iterator();
                    while (ite.hasNext()) {
                        ite.next().remove(hibernate);
                    }

                    sess = hibernate.begin();
                    sess.update(service);
                    service.getProjects().remove(selected);
                    sess.delete(selected);
                    hibernate.commitAndClose(sess);
                    cargarComboProj();

                    try {
                        service.updateCapabilities(this.hibernate, this.serviceConnection);
                    } catch (ConnectException ex) {
                        WindowUtils.msgError(this, LocaleUtil.getString("windows/proyects/messages", "notlisten"));
                    } catch (HTTPRequestException ex) {
                        LocaleUtil.getString("windows/proyects/messages", "statecode");
                        WindowUtils.msgInfo(this, " " + ex.getStatusCode() + " " + service.getServiceURL());
                    } catch (Exception ex) {
                        ex.printStackTrace();
                    }


                } catch (Exception ex) {
                    WindowUtils.msgError(this.getParent(), java.util.ResourceBundle.getBundle("windows/controls/messages", LocaleUtil.getLocale()).getString("msgError3"));
                    service.getProjects().add(selected);
                    ex.printStackTrace();
                }
            }
        } else {
            WindowUtils.msgError(this.getRootPane(), java.util.ResourceBundle.getBundle("windows/controls/messages", LocaleUtil.getLocale()).getString("msgError0"));
        }
    }//GEN-LAST:event_btnRemPrjActionPerformed

    private void btnAddPrjActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAddPrjActionPerformed
        FrmNewProyect frm = new FrmNewProyect(this.hibernate, this.service, this.serviceConnection);
        frm.setVisible(true);
        if (!frm.isUserCancel()) {
            cargarComboProj();
        }
    }//GEN-LAST:event_btnAddPrjActionPerformed

    private void cmbPytosActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmbPytosActionPerformed
        hilo();
        boolean sta = false;
        if(cmbPytos.getSelectedIndex()>0){
            sta = true;
        }
        btnEditPrj.setEnabled(sta);
        btnGeocoders.setEnabled(sta);
        btnRemPrj.setEnabled(sta);
        btnSource.setEnabled(sta);
    }//GEN-LAST:event_cmbPytosActionPerformed

    private void btnSourceActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSourceActionPerformed
        final Project selected = getSelectedProject();
        if (selected != null) {
            FrmWait frm = new FrmWait() {
                @Override
                public void action() {
                    try {
                        FrmSources frm = new FrmSources(selected, hibernate, serviceConnection);
                        frm.setVisible(true);
                    } catch (Exception ex) {
                        WindowUtils.msgError(this.getRootPane(), java.util.ResourceBundle.getBundle("windows/controls/messages", LocaleUtil.getLocale()).getString("mshError1"));
                        ex.printStackTrace();
                    }
                }
            };
            frm.setVisible(true);
        } else {
            WindowUtils.msgError(this.getRootPane(), java.util.ResourceBundle.getBundle("windows/controls/messages", LocaleUtil.getLocale()).getString("msgError0"));
        }
}//GEN-LAST:event_btnSourceActionPerformed

    private void btnGeocodersActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnGeocodersActionPerformed
        FrmAdminGeocoders frm = new FrmAdminGeocoders(hibernate, getSelectedProject(), serviceConnection);
        frm.setVisible(true);
}//GEN-LAST:event_btnGeocodersActionPerformed

    public void hilo() {
        Thread t = new Thread() {
            @Override
            public void run() {
                fireListeners(projectChangeListeners);
            }
        };
        t.start();
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAddPrj;
    private javax.swing.JButton btnEditPrj;
    private javax.swing.JButton btnGeocoders;
    private javax.swing.JButton btnRemPrj;
    private javax.swing.JButton btnSource;
    private javax.swing.JComboBox cmbPytos;
    private javax.swing.JLabel jLabel1;
    // End of variables declaration//GEN-END:variables
}
