/*
 * Created on 18 de mayo de 2007, 11:44 AM
 */
package windows.icons;

import org.atlas.hibernatedata.Icon;
import java.awt.event.ActionEvent;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import javax.swing.JFrame;
import org.atlas.i18n.LocaleUtil;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import javax.swing.JFileChooser;
import org.atlas.svg.SvgReader;
import org.atlas.util.Configuration;
import org.atlas.util.FrmWait;
import org.atlas.util.WindowUtils;

public class FrmAddIcons extends javax.swing.JDialog {

    private Configuration config;
    private JFileChooser file;

    public FrmAddIcons() {
        super((JFrame) null, true);
        initComponents();
        WindowUtils.center(this);
        WindowUtils.setFrameIcon(this, "/media/appicon.png");
        config = Configuration.grantReadConfiguration("config.xml");

        ActionListener al = new ActionListener() {

            public void actionPerformed(ActionEvent actionEvent) {
                if (iconsPanel.getIconCount() > 0) {
                    btnContinue.setEnabled(true);
                } else {
                    btnContinue.setEnabled(false);
                }
            }
        };

        this.iconsPanel.addItemsAddedListener(al);
        this.iconsPanel.addItemsRemovedListener(al);
    }

    public Object[] getIcons() {
        return iconsPanel.getIcons();
    }

    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        iconsPanel = new windows.icons.IconsPanel();
        jPanel1 = new javax.swing.JPanel();
        txtPath = new javax.swing.JTextField();
        add = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        btnCancel = new javax.swing.JButton();
        btnContinue = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle(java.util.ResourceBundle.getBundle("windows/icons/messages",LocaleUtil.getLocale()).getString("title_add_icons"));

        txtPath.setEditable(false);

        add.setText("...");
        add.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addComponent(txtPath, javax.swing.GroupLayout.DEFAULT_SIZE, 378, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(add, javax.swing.GroupLayout.PREFERRED_SIZE, 43, javax.swing.GroupLayout.PREFERRED_SIZE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(add, javax.swing.GroupLayout.PREFERRED_SIZE, 24, Short.MAX_VALUE)
                    .addComponent(txtPath, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        btnCancel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/process-stop.png")));
        btnCancel.setText(java.util.ResourceBundle.getBundle("windows/spatial_ref_sys/messages",LocaleUtil.getLocale()).getString("cancel_key"));
        btnCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelActionPerformed(evt);
            }
        });

        btnContinue.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/go-next.png")));
        btnContinue.setText(java.util.ResourceBundle.getBundle("windows/spatial_ref_sys/messages",LocaleUtil.getLocale()).getString("next_key"));
        btnContinue.setEnabled(false);
        btnContinue.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnContinueActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addComponent(btnCancel, javax.swing.GroupLayout.PREFERRED_SIZE, 167, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(btnContinue, javax.swing.GroupLayout.PREFERRED_SIZE, 167, javax.swing.GroupLayout.PREFERRED_SIZE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                .addComponent(btnCancel, javax.swing.GroupLayout.PREFERRED_SIZE, 34, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addComponent(btnContinue, javax.swing.GroupLayout.PREFERRED_SIZE, 34, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        jLabel1.setText(java.util.ResourceBundle.getBundle("windows/icons/messages",LocaleUtil.getLocale()).getString("select folder"));

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(iconsPanel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 427, Short.MAX_VALUE)
                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel2, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, 427, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(iconsPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 291, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents
    private void addActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addActionPerformed

        FrmWait frm = new FrmWait() {
            @Override
            public void action() {
                file = new JFileChooser();

                if (!config.getLastIconDirectory().equals("")) {
                    file.setCurrentDirectory(new File(config.getLastIconDirectory()));
                }

                file.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
                file.setAcceptAllFileFilterUsed(false);
                file.setFileFilter(new javax.swing.filechooser.FileFilter() {

                    public String getDescription() {
                        return "Image files (SVG)";
                    }

                    public boolean accept(File f) {
                        return f.isDirectory() || f.getAbsolutePath().toLowerCase().endsWith("svg");
                    }
                });
            }
        };

        frm.setVisible(true);
        int res = file.showOpenDialog(null);
        if (res == JFileChooser.APPROVE_OPTION) {

            File arch = file.getSelectedFile();
            List icons = new ArrayList();

            config.setLastIconDirectory(arch.getAbsolutePath());
            try {
                config.writeConfiguration("config.xml");
            } catch (FileNotFoundException ex) {
                ex.printStackTrace();
            } catch (IOException ex) {
                ex.printStackTrace();
            }

            if (arch.isDirectory()) {
                File[] files = arch.listFiles();
                Arrays.sort(files);
                for (int i = 0; i < files.length; i++) {
                    try {
                        addIcon(files[i], icons);
                    } catch (Exception ex) {
                        System.err.println(files[i].getName() + " " + ex.getMessage());
                    }
                }
            } else {
                try {
                    addIcon(arch, icons);
                } catch (Exception ex) {
                    System.err.println(arch.getName() + " " + ex.getMessage());
                }
            }

            this.txtPath.setText(arch.getPath());
        }
    }//GEN-LAST:event_addActionPerformed

    private void addIcon(File arch, List icons) throws Exception {
        String name = arch.getName().toLowerCase();
        FileInputStream fis = new FileInputStream(arch);
        byte[] bin = SvgReader.simplifySVG(fis, 128).getBytes();
        Icon i = new Icon(bin, "image/svg", arch.getName());
        iconsPanel.addIcon(i);
    }

    private void btnContinueActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnContinueActionPerformed
        this.setVisible(false);
    }//GEN-LAST:event_btnContinueActionPerformed

    private void btnCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelActionPerformed
        this.setVisible(false);
    }//GEN-LAST:event_btnCancelActionPerformed

    public static void main(String[] args) {
        new FrmAddIcons().setVisible(true);
        System.exit(0);
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton add;
    private javax.swing.JButton btnCancel;
    private javax.swing.JButton btnContinue;
    private windows.icons.IconsPanel iconsPanel;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JTextField txtPath;
    // End of variables declaration//GEN-END:variables
}
