/*
 * Created on 18 de mayo de 2007, 11:44 AM
 */
package windows.icons;

import java.util.List;
import org.atlas.hibernatedata.Icon;
import org.atlas.hibernatedata.Service;
import javax.swing.JFrame;
import org.atlas.i18n.LocaleUtil;
import org.hibernate.classic.Session;
import org.atlas.util.Configuration;
import org.atlas.util.HibernateUtil;
import org.atlas.util.WindowUtils;

public class FrmAdminIcons extends javax.swing.JDialog {

    private Service service;
    private Configuration config;
    private HibernateUtil hibernate;

    public FrmAdminIcons(HibernateUtil hu, Service service) {
        super((JFrame) null, true);
        initComponents();
        WindowUtils.center(this);
        WindowUtils.setFrameIcon(this, "/media/appicon.png");

        this.service = service;
        this.hibernate = hu;
        this.config = Configuration.grantReadConfiguration("config.xml");

        Session sess = null;
        try {
            sess = hibernate.begin();
            sess.update(service);
            Object[] obj = service.getIcons().toArray();
            for (int i = 0; i < obj.length; i++) {
                iconsPanel1.addIcon((Icon) obj[i]);
            }
        } catch (Exception ex) {
            ex.printStackTrace();
            this.dispose();
        } finally {
            hibernate.close(sess);
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jButton2 = new javax.swing.JButton();
        btnAddLayer = new javax.swing.JButton();
        iconsPanel1 = new windows.icons.IconsPanel();
        btnRemPrj = new javax.swing.JButton();

        setTitle(java.util.ResourceBundle.getBundle("windows/icons/messages",LocaleUtil.getLocale()).getString("title_admin"));
        jButton2.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/volver.png")));
        jButton2.setText(java.util.ResourceBundle.getBundle("windows/icons/messages",LocaleUtil.getLocale()).getString("exit"));
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        btnAddLayer.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/plus.png")));
        btnAddLayer.setToolTipText("Agregar una Capa");
        btnAddLayer.setIconTextGap(0);
        btnAddLayer.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnAddLayer.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAddLayerActionPerformed(evt);
            }
        });

        btnRemPrj.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/trash.png")));
        btnRemPrj.setToolTipText("Eliminar Capa");
        btnRemPrj.setDefaultCapable(false);
        btnRemPrj.setIconTextGap(0);
        btnRemPrj.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnRemPrj.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnRemPrjActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(iconsPanel1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 415, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(btnRemPrj)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnAddLayer))
                    .addComponent(jButton2, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 109, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(btnAddLayer)
                    .addComponent(btnRemPrj))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(iconsPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, 388, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton2, javax.swing.GroupLayout.PREFERRED_SIZE, 34, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents
    private void btnRemPrjActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnRemPrjActionPerformed

        Object[] ics = iconsPanel1.getSelectedIcons();
        if (ics.length > 0) {
            Session sess = null;
            try {
                sess = hibernate.begin();
                sess.update(service);

                for (int i = 0; i < ics.length; i++) {
                    Icon ic = (Icon) ics[i];
                    if (ic.getDescicon().equals("default.svg")) {
                        String def = java.util.ResourceBundle.getBundle("windows/icons/messages", LocaleUtil.getLocale()).getString("no_del_default");
                        WindowUtils.msgInfo(this, def);
                    } else {
                        List rules = sess.createQuery("from Style where codeicon = " + ic.getCodeicon()).list();
                        if (rules.size() == 0) {
                            service.getIcons().remove(ic);
                            sess.delete(ic);
                            iconsPanel1.removeIcon(ic);
                        } else {
                            String in_use = java.util.ResourceBundle.getBundle("windows/icons/messages", LocaleUtil.getLocale()).getString("icon_in_use");
                            WindowUtils.msgInfo(this, in_use);
                        }
                    }
                }
            } catch (Exception ex) {
                ex.printStackTrace();
            } finally {
                try {
                    hibernate.commitAndClose(sess);
                } catch (Exception ex) {
                    ex.printStackTrace();
                    try {
                        hibernate.close(sess);
                    } catch (Exception ex1) {
                        ex.printStackTrace();
                    }
                }
            }
        }
    }//GEN-LAST:event_btnRemPrjActionPerformed

    private void btnAddLayerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAddLayerActionPerformed
        FrmAddIcons frm = new FrmAddIcons();
        frm.setVisible(true);

        service.getIcons().toArray();
        Object[] ics = frm.getIcons();
        if (ics.length > 0) {
            Session sess = null;
            try {
                sess = hibernate.begin();
                sess.update(service);
                for (int i = 0; i < ics.length; i++) {
                    Icon ic = (Icon) ics[i];
                    List icons = sess.createQuery("from Icon where descicon = '" + ic.getDescicon() + "'").list();
                    if (icons.size() == 0) {
                        sess.save(ic);
                        service.getIcons().add(ic);
                        iconsPanel1.addIcon(ic);
                    } else {
                        String an_icon_called = java.util.ResourceBundle.getBundle("windows/icons/messages", LocaleUtil.getLocale()).getString("duplicate_name");
                        String already = java.util.ResourceBundle.getBundle("windows/icons/messages", LocaleUtil.getLocale()).getString("already");
                        WindowUtils.msgWarning(this, an_icon_called + ic.getDescicon() + " " + already);
                    }
                }
            } catch (Exception ex) {
                ex.printStackTrace();
            } finally {
                try {
                    hibernate.commitAndClose(sess);
                } catch (Exception ex) {
                    try {
                        hibernate.close(sess);
                    } catch (Exception ex1) {
                    }
                }
            }
        }
    }//GEN-LAST:event_btnAddLayerActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        this.setVisible(false);
    }//GEN-LAST:event_jButton2ActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAddLayer;
    private javax.swing.JButton btnRemPrj;
    private windows.icons.IconsPanel iconsPanel1;
    private javax.swing.JButton jButton2;
    // End of variables declaration//GEN-END:variables
}
