/* 
 * Created on 30 de abril de 2007, 07:46 PM
 */

package windows.layers;

import org.atlas.exceptions.HTTPRequestException;
import org.atlas.hibernatedata.Layer;
import org.atlas.hibernatedata.Project;
import org.atlas.hibernatedata.Service;
import org.atlas.hibernatedata.Symbology;
import java.awt.event.WindowEvent;
import java.awt.Frame;
import java.awt.event.WindowAdapter;
import java.net.ConnectException;
import java.util.regex.Pattern;
import javax.swing.DefaultListModel;
import org.hibernate.classic.Session;
import org.atlas.util.HibernateUtil;
import org.atlas.i18n.LocaleUtil;
import java.util.ResourceBundle;
import org.atlas.util.RegexDocument;
import org.atlas.util.ServiceConnection;
import org.atlas.util.WindowUtils;

public class FrmLayerProps extends javax.swing.JDialog {
    
    private boolean userCancel;
    private DefaultListModel wordsModel = new DefaultListModel();
    private HibernateUtil    hibernate;
    private Project          project;
    private Layer            layer;
    private boolean          create;
    private Service          service;
    private ServiceConnection serviceConnection;
    
    public FrmLayerProps(HibernateUtil hibernate, Project project, Layer layer, ServiceConnection serviceConnection) {
        super((Frame)null, true);
        initComponents();
        this.lstWords.setModel(wordsModel);
        this.hibernate = hibernate;
        this.project   = project;
        this.serviceConnection = serviceConnection;
                
        addValidations();
        this.addWindowListener(new WindowAdapter(){
            public void windowClosing(WindowEvent windowEvent) {
                userCancel = true;
            }
        });
        org.atlas.util.WindowUtils.center(this);
        org.atlas.util.WindowUtils.setFrameIcon(this,"/media/appicon.png");
        
        if(layer != null){
            this.layer = layer;
            create = false;
            this.setTitle(LocaleUtil.getString("windows/layers/messages","editLayer"));
            loadLayer();
        }else{
            this.layer = new Layer();
            create = true;
            this.setTitle(LocaleUtil.getString("windows/layers/messages","addLayer"));
        }
    }
    
    public FrmLayerProps(HibernateUtil hibernate, Project project, ServiceConnection serviceConnection){
        this(hibernate, project, null,serviceConnection);
    }
    
    private void addValidations(){
        txtAbstract.setDocument(new RegexDocument("[A-Za-zÑñ0-9ÁÉÍÓÚáéíóú \\Q()[]{}+-*/^\\$|¿?#@.,;:_ !¡\\E]{1,}"));
        txtAttribution.setDocument(new RegexDocument("[A-Za-zÑñ0-9ÁÉÍÓÚáéíóú ]{1,}"));
        txtMaxScale.setDocument(new RegexDocument("[0-9,.]{1,}"));
        txtMinScale.setDocument(new RegexDocument("[0-9,.]{1,}"));
        txtTitle.setDocument(new RegexDocument("[A-Za-zÑñ0-9ÁÉÍÓÚáéíóú ]{1,}"));
        txtWord.setDocument(new RegexDocument("[A-Za-zÑñ0-9ÁÉÍÓÚáéíóú ]{1,}"));
    }
    
    private boolean validateMailAddres(String email){
        String sp = "\\!\\#\\$\\%\\&\\'\\*\\+\\-\\/\\=\\?\\^\\_\\`\\{\\|\\}\\~";
        String atext = "[a-zA-Z0-9" + sp + "]";
        String atom = atext + "+";
        String dotAtom = "\\." + atom;
        String localPart = atom + "(" + dotAtom + ")*";
        String letter = "[a-zA-Z]";
        String letDig = "[a-zA-Z0-9]";
        String letDigHyp = "[a-zA-Z0-9-]";
        String rfcLabel = letDig + "(" + letDigHyp + "{0,61}" + letDig + ")?";
        String domain = rfcLabel + "(\\." + rfcLabel + ")*\\." + letter + "{2,6}";
        //RFC 2822
        String addrSpec = "^" + localPart + "@" + domain + "$";
        Pattern VALID_PATTERN = Pattern.compile(addrSpec);
        return VALID_PATTERN.matcher(email).matches();
    }
    
    private void loadLayer(){
        this.txtAbstract.setText(layer.getSummary());
        this.txtAttribution.setText(layer.getAtribution());
        if(layer.getMaxscaledeno()!=0)
            this.txtMaxScale.setText(String.valueOf(layer.getMaxscaledeno()));
        if(layer.getMinscaledeno()!=0)
            this.txtMinScale.setText(String.valueOf(layer.getMinscaledeno()));
        this.txtTitle.setText(layer.getDesclaye());
        wordsModel = (DefaultListModel)WindowUtils.getListModel(layer.getKeywordList(),",");
        this.lstWords.setModel(wordsModel);
        this.chkQuery.setSelected(layer.isQueryable());
    }
    
    public boolean isUserCancel() {
        return userCancel;
    }
    
    public void setUserCancel(boolean userCancel) {
        this.userCancel = userCancel;
    }
    
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        txtTitle = new javax.swing.JTextField();
        jPanel3 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        txtAbstract = new javax.swing.JTextArea();
        jPanel4 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        jPanel5 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        lstWords = new javax.swing.JList();
        jPanel6 = new javax.swing.JPanel();
        btnAddWord = new javax.swing.JButton();
        btnDelWord = new javax.swing.JButton();
        txtWord = new javax.swing.JTextField();
        jPanel20 = new javax.swing.JPanel();
        jLabel17 = new javax.swing.JLabel();
        txtMaxScale = new javax.swing.JTextField();
        jPanel21 = new javax.swing.JPanel();
        jLabel18 = new javax.swing.JLabel();
        txtMinScale = new javax.swing.JTextField();
        jPanel23 = new javax.swing.JPanel();
        btnCancel = new javax.swing.JButton();
        btnConnect = new javax.swing.JButton();
        jPanel8 = new javax.swing.JPanel();
        jLabel5 = new javax.swing.JLabel();
        txtAttribution = new javax.swing.JTextField();
        jPanel10 = new javax.swing.JPanel();
        jLabel7 = new javax.swing.JLabel();
        chkQuery = new javax.swing.JCheckBox();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle(java.util.ResourceBundle.getBundle("windows/service/messages",LocaleUtil.getLocale()).getString("serviceInfo"));
        setResizable(false);
        jPanel1.setLayout(new java.awt.GridLayout(1, 0, 5, 5));

        jLabel1.setForeground(new java.awt.Color(0, 102, 204));
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel1.setText(java.util.ResourceBundle.getBundle("windows/service/messages",LocaleUtil.getLocale()).getString("title"));
        jPanel1.add(jLabel1);

        jPanel1.add(txtTitle);

        jPanel3.setLayout(new java.awt.GridLayout(1, 0, 5, 5));

        jLabel2.setForeground(new java.awt.Color(0, 102, 204));
        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel2.setText(java.util.ResourceBundle.getBundle("windows/service/messages",LocaleUtil.getLocale()).getString("abstract"));
        jLabel2.setVerticalAlignment(javax.swing.SwingConstants.TOP);
        jPanel3.add(jLabel2);

        txtAbstract.setColumns(20);
        txtAbstract.setRows(5);
        jScrollPane1.setViewportView(txtAbstract);

        jPanel3.add(jScrollPane1);

        jPanel4.setLayout(new java.awt.GridLayout(1, 0, 5, 5));

        jLabel3.setForeground(new java.awt.Color(0, 102, 204));
        jLabel3.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel3.setText(java.util.ResourceBundle.getBundle("windows/service/messages",LocaleUtil.getLocale()).getString("Keyword"));
        jLabel3.setVerticalAlignment(javax.swing.SwingConstants.TOP);
        jPanel4.add(jLabel3);

        jScrollPane2.setViewportView(lstWords);

        btnAddWord.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/gtk-add.png")));
        btnAddWord.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnAddWord.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAddWordActionPerformed(evt);
            }
        });

        btnDelWord.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/gtk-clear.png")));
        btnDelWord.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnDelWord.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnDelWordActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel6Layout = new javax.swing.GroupLayout(jPanel6);
        jPanel6.setLayout(jPanel6Layout);
        jPanel6Layout.setHorizontalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel6Layout.createSequentialGroup()
                .addComponent(txtWord, javax.swing.GroupLayout.DEFAULT_SIZE, 192, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(btnAddWord)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(btnDelWord))
        );
        jPanel6Layout.setVerticalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(btnAddWord)
            .addComponent(btnDelWord)
            .addComponent(txtWord, javax.swing.GroupLayout.DEFAULT_SIZE, 28, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 260, Short.MAX_VALUE)
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addComponent(jPanel6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 65, Short.MAX_VALUE))
        );
        jPanel4.add(jPanel5);

        jPanel20.setLayout(new java.awt.GridLayout(1, 0, 5, 5));

        jLabel17.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel17.setText(java.util.ResourceBundle.getBundle("windows/layers/messages",LocaleUtil.getLocale()).getString("maxScale"));
        jPanel20.add(jLabel17);

        jPanel20.add(txtMaxScale);

        jPanel21.setLayout(new java.awt.GridLayout(1, 0, 5, 5));

        jLabel18.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel18.setText(java.util.ResourceBundle.getBundle("windows/layers/messages",LocaleUtil.getLocale()).getString("minScale"));
        jPanel21.add(jLabel18);

        jPanel21.add(txtMinScale);

        jPanel23.setLayout(new java.awt.GridLayout(1, 0, 5, 5));

        btnCancel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/process-stop.png")));
        btnCancel.setText(java.util.ResourceBundle.getBundle("windows/connections/messages",LocaleUtil.getLocale()).getString("Cancel"));
        btnCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelActionPerformed(evt);
            }
        });

        jPanel23.add(btnCancel);

        btnConnect.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/connect.png")));
        btnConnect.setText(java.util.ResourceBundle.getBundle("windows/connections/messages",LocaleUtil.getLocale()).getString("continue"));
        btnConnect.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnConnectActionPerformed(evt);
            }
        });

        jPanel23.add(btnConnect);

        jPanel8.setLayout(new java.awt.GridLayout(1, 0, 5, 5));

        jLabel5.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel5.setText(java.util.ResourceBundle.getBundle("windows/layers/messages",LocaleUtil.getLocale()).getString("attribution"));
        jPanel8.add(jLabel5);

        jPanel8.add(txtAttribution);

        jPanel10.setLayout(new java.awt.GridLayout(1, 2, 5, 5));

        jLabel7.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel7.setText(java.util.ResourceBundle.getBundle("windows/layers/messages",LocaleUtil.getLocale()).getString("queryable"));
        jPanel10.add(jLabel7);

        chkQuery.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        chkQuery.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel10.add(chkQuery);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jPanel23, javax.swing.GroupLayout.PREFERRED_SIZE, 380, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, 526, Short.MAX_VALUE)
                    .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, 526, Short.MAX_VALUE)
                    .addComponent(jPanel20, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 526, Short.MAX_VALUE)
                    .addComponent(jPanel21, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 526, Short.MAX_VALUE)
                    .addComponent(jPanel4, javax.swing.GroupLayout.DEFAULT_SIZE, 526, Short.MAX_VALUE)
                    .addComponent(jPanel8, javax.swing.GroupLayout.PREFERRED_SIZE, 526, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jPanel10, javax.swing.GroupLayout.PREFERRED_SIZE, 526, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel20, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel21, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, 99, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel8, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel10, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel23, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    private void btnDelWordActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnDelWordActionPerformed
        if(this.lstWords.getSelectedIndex()>=0){
            this.wordsModel.remove(this.lstWords.getSelectedIndex());
        }
    }//GEN-LAST:event_btnDelWordActionPerformed
    
    private void btnAddWordActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAddWordActionPerformed
        if(!this.txtWord.getText().trim().equals("")){
            this.wordsModel.addElement(this.txtWord.getText());
            WindowUtils.sortListModel(this.wordsModel);
            this.txtWord.setText("");
            this.txtWord.grabFocus();
        }
    }//GEN-LAST:event_btnAddWordActionPerformed
    
    private void btnCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelActionPerformed
        this.userCancel = true;
        this.setVisible(false);
    }//GEN-LAST:event_btnCancelActionPerformed
    
    private void btnConnectActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnConnectActionPerformed
        ResourceBundle b = ResourceBundle.getBundle("windows/layers/messages", LocaleUtil.getLocale());
        
        String title = this.txtTitle.getText().trim();
        if(title.equals("")){
            WindowUtils.msgError(this, b.getString("titleReq"));
            this.txtTitle.grabFocus();
            return;
        }
        
        String sumary = this.txtAbstract.getText().trim();
        if(sumary.equals("")){
            WindowUtils.msgError(this, b.getString("abstrReq"));
            this.txtAbstract.grabFocus();
            return;
        }
        
        if(this.wordsModel.getSize()==0){
            WindowUtils.msgError(this, b.getString("wordsReq"));
            this.txtWord.grabFocus();
            return;
        }
        
        String attribution = this.txtAttribution.getText().trim();
        String kwString = WindowUtils.getItemsString(this.wordsModel,",");
        
        String scale = "";
        double minScale;
        double maxScale;
        try {
            scale = this.txtMaxScale.getText();
            if(!scale.equals("")){
                maxScale = Double.parseDouble(scale);
            }else{
                maxScale = 0;
            }
            
            scale = this.txtMinScale.getText();
            if(!scale.equals("")){
                minScale = Double.parseDouble(scale);
            }else{
                minScale = 0;
            }
        } catch (NumberFormatException ex) {
            WindowUtils.msgError(this.getRootPane(),scale+" "+b.getString("invNumber"));
            return;
        }
        
        
        layer.setAtribution(attribution);
        layer.setKeywordList(kwString);
        layer.setSummary(sumary);
        layer.setDesclaye(title);
        layer.setQueryable(this.chkQuery.isSelected());
        layer.setMaxscaledeno(maxScale);
        layer.setMinscaledeno(minScale);
        
        
        Session sess = null;
        try {
            sess = hibernate.begin();
            service = Service.getService(this.hibernate);
            
            if(create==true){
                layer.setZorder(project.getLayers().size());
                project.getLayers().add(layer);
                layer.setProject(project);
                sess.save(layer);
            }else{
                sess.update(layer);
            }
            hibernate.commitAndClose(sess);
          
            try {
                service.updateCapabilities(this.hibernate, serviceConnection);
            } catch (ConnectException ex) {
                WindowUtils.msgError(this, b.getString("notlisten"));
            } catch (HTTPRequestException ex) {
                LocaleUtil.getString("windows/service/messages","statecode");
                WindowUtils.msgInfo(this," " + ex.getStatusCode() + " " + service.getServiceURL() );
            } catch (Exception ex) {
                ex.printStackTrace();
            }
            
            this.setVisible(false);
            this.dispose();
        } catch (Exception ex) {
            WindowUtils.msgError(this, b.getString("unexpected_error"));
            ex.printStackTrace();
            project.getLayers().remove(layer);
            layer.setProject(null);
            try {
                hibernate.close(sess);
            } catch (Exception ex1) {
                ex1.printStackTrace();
            }
        }
    }//GEN-LAST:event_btnConnectActionPerformed
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAddWord;
    private javax.swing.JButton btnCancel;
    private javax.swing.JButton btnConnect;
    private javax.swing.JButton btnDelWord;
    private javax.swing.JCheckBox chkQuery;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel10;
    private javax.swing.JPanel jPanel20;
    private javax.swing.JPanel jPanel21;
    private javax.swing.JPanel jPanel23;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JList lstWords;
    private javax.swing.JTextArea txtAbstract;
    private javax.swing.JTextField txtAttribution;
    private javax.swing.JTextField txtMaxScale;
    private javax.swing.JTextField txtMinScale;
    private javax.swing.JTextField txtTitle;
    private javax.swing.JTextField txtWord;
    // End of variables declaration//GEN-END:variables
    
}
