/* 
 * Created on 30 de abril de 2007, 09:24 AM
 */
package windows;

import org.atlas.hibernatedata.Service;
import org.atlas.i18n.LocaleUtil;
import org.atlas.util.HibernateUtil;
import org.atlas.util.ServiceConnection;
import org.atlas.util.WindowUtils;
import windows.about.FrmAbout;
import windows.configuration.FrmConfiguration;
import windows.connections.FrmConnectionProps;
import windows.icons.FrmAdminIcons;
import windows.service.FrmServiceProps;
import windows.servicetest.FrmServerTest;
import windows.wartool.WebArchive;

public class main extends javax.swing.JFrame {

    private HibernateUtil hibernate;
    private Service service;
    private ServiceConnection serviceConnection;

    public main() {
        initComponents();
        org.atlas.util.WindowUtils.center(this);
        org.atlas.util.WindowUtils.setFrameIcon(this, "/media/appicon.png");
        this.pnlLayers.setPnlProyect(this.pnlProjects);
        this.pnlViewer.setPnlLayers(this.pnlLayers);
        initForm();
    }

    private void clearToolBar() {
        this.toolBar.removeAll();
    }

    private void updateToolBar() {
        this.toolBar.setVisible(false);
        this.toolBar.setVisible(true);
    }

    private void initForm() {
        clearToolBar();
        this.toolBar.add(this.btnConnect);
        this.toolBar.add(this.btnOptions);
        this.toolBar.add(this.btnWarTool);
        this.toolBar.add(this.btnAbout);
        this.toolBar.add(this.btnExit);
        this.hibernate = null;
        this.service = null;
        this.pnlProjects.reset();
        this.pnlLayers.reset();
        updateToolBar();
    }

    private void checkTableStatus() {
        FrmWait frm = new FrmWait() {

            public void action() {
                try {
                    clearToolBar();
                    toolBar.add(btnService);
                    toolBar.add(btnOptions);
                    //toolBar.add(btnUninstall);
                    toolBar.add(btnIconsManager);
                    toolBar.add(btnDisconnect);
                    toolBar.add(btnWarTool);
                    toolBar.add(btnAbout);
                    toolBar.add(btnExit);
                    pnlProjects.setServiceConnection(serviceConnection);
                    pnlLayers.setServiceConnection(serviceConnection);
                    service = Service.getService(hibernate);
                    pnlProjects.setHibernate(hibernate);
                    pnlLayers.setHibernate(hibernate);
                    pnlProjects.setService(service);
                    pnlLayers.setService(service);
                    updateToolBar();
                } catch (Exception ex) {
                    initForm();
                    ex.printStackTrace();
                }
            }
        };
        frm.setVisible(true);
    }

    private void salir() {
        System.exit(0);
    }

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        btnService = new javax.swing.JButton();
        btnConnect = new javax.swing.JButton();
        btnExit = new javax.swing.JButton();
        btnDisconnect = new javax.swing.JButton();
        btnOptions = new javax.swing.JButton();
        btnUninstall = new javax.swing.JButton();
        btnIconsManager = new javax.swing.JButton();
        btnWarTool = new javax.swing.JButton();
        btnAbout = new javax.swing.JButton();
        toolBar = new javax.swing.JToolBar();
        pnlProjects = new windows.controls.PnlProjects();
        pnlViewer = new windows.controls.PnlViewer();
        pnlLayers = new windows.controls.PnlLayers();

        btnService.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/service.png"))); // NOI18N
        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("windows/messages",LocaleUtil.getLocale()); // NOI18N
        btnService.setText(bundle.getString("service")); // NOI18N
        btnService.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnService.setIconTextGap(0);
        btnService.setMargin(new java.awt.Insets(5, 5, 5, 5));
        btnService.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnService.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnServiceActionPerformed(evt);
            }
        });

        btnConnect.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/connect.png"))); // NOI18N
        btnConnect.setText(bundle.getString("conectar")); // NOI18N
        btnConnect.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnConnect.setIconTextGap(0);
        btnConnect.setMargin(new java.awt.Insets(5, 5, 5, 5));
        btnConnect.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnConnect.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnConnectActionPerformed(evt);
            }
        });

        btnExit.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/exit.png"))); // NOI18N
        btnExit.setText(bundle.getString("salir")); // NOI18N
        btnExit.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnExit.setIconTextGap(0);
        btnExit.setMargin(new java.awt.Insets(5, 5, 5, 5));
        btnExit.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnExit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnExitActionPerformed(evt);
            }
        });

        btnDisconnect.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/connect_no.png"))); // NOI18N
        btnDisconnect.setText(bundle.getString("desconectar")); // NOI18N
        btnDisconnect.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnDisconnect.setIconTextGap(0);
        btnDisconnect.setMargin(new java.awt.Insets(5, 5, 5, 5));
        btnDisconnect.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnDisconnect.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnDisconnectActionPerformed(evt);
            }
        });

        btnOptions.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/config.png"))); // NOI18N
        btnOptions.setText(bundle.getString("options")); // NOI18N
        btnOptions.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnOptions.setIconTextGap(0);
        btnOptions.setMargin(new java.awt.Insets(5, 5, 5, 5));
        btnOptions.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnOptions.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnOptionsActionPerformed(evt);
            }
        });

        btnUninstall.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/install.png"))); // NOI18N
        btnUninstall.setText(bundle.getString("uninstalar")); // NOI18N
        btnUninstall.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnUninstall.setIconTextGap(0);
        btnUninstall.setMargin(new java.awt.Insets(5, 5, 5, 5));
        btnUninstall.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnUninstall.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnUninstallActionPerformed(evt);
            }
        });

        btnIconsManager.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/icons.png"))); // NOI18N
        btnIconsManager.setText(bundle.getString("icons")); // NOI18N
        btnIconsManager.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnIconsManager.setIconTextGap(0);
        btnIconsManager.setMargin(new java.awt.Insets(5, 5, 5, 5));
        btnIconsManager.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnIconsManager.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnIconsManagerActionPerformed(evt);
            }
        });

        btnWarTool.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/wtool.png"))); // NOI18N
        btnWarTool.setText(bundle.getString("wartool")); // NOI18N
        btnWarTool.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnWarTool.setIconTextGap(0);
        btnWarTool.setMargin(new java.awt.Insets(5, 5, 5, 5));
        btnWarTool.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnWarTool.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnWarToolActionPerformed(evt);
            }
        });

        btnAbout.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/about.png"))); // NOI18N
        btnAbout.setText(bundle.getString("about")); // NOI18N
        btnAbout.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnAbout.setIconTextGap(0);
        btnAbout.setMargin(new java.awt.Insets(5, 5, 5, 5));
        btnAbout.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnAbout.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAboutActionPerformed(evt);
            }
        });

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle(bundle.getString("Panel_de_Control_ATLAS")); // NOI18N
        setIconImage(getIconImage());
        setLocationByPlatform(true);
        setMinimumSize(new java.awt.Dimension(800, 600));

        toolBar.setFloatable(false);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(pnlLayers, javax.swing.GroupLayout.PREFERRED_SIZE, 357, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(pnlViewer, javax.swing.GroupLayout.DEFAULT_SIZE, 605, Short.MAX_VALUE)
                .addContainerGap())
            .addComponent(toolBar, javax.swing.GroupLayout.DEFAULT_SIZE, 988, Short.MAX_VALUE)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(pnlProjects, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(355, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(toolBar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(pnlProjects, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(pnlLayers, javax.swing.GroupLayout.DEFAULT_SIZE, 517, Short.MAX_VALUE)
                    .addComponent(pnlViewer, javax.swing.GroupLayout.DEFAULT_SIZE, 517, Short.MAX_VALUE))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
    private void btnIconsManagerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnIconsManagerActionPerformed
        FrmAdminIcons frm = new FrmAdminIcons(this.hibernate, this.service);
        frm.setVisible(true);
    }//GEN-LAST:event_btnIconsManagerActionPerformed

    private void btnServiceActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnServiceActionPerformed
        try {
            FrmServiceProps frm = new FrmServiceProps(this.hibernate, this.serviceConnection);
            frm.setVisible(true);
            this.checkTableStatus();
        } catch (Exception ex) {
            ex.printStackTrace();
            WindowUtils.msgError(this, LocaleUtil.getString("windows/messages", "unexError"));
        }
    }//GEN-LAST:event_btnServiceActionPerformed

    private void btnUninstallActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnUninstallActionPerformed
        if (WindowUtils.msgYesNo(this, "Esta acción eliminará tablas en su base de datos\n¿Realmente desea continuar?")) {
            this.hibernate.dropSchema();
            try {
                checkTableStatus();
            } catch (Exception ex) {
                ex.printStackTrace();
            }
        }
    }//GEN-LAST:event_btnUninstallActionPerformed

    private void btnOptionsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnOptionsActionPerformed
        new FrmConfiguration().setVisible(true);
    }//GEN-LAST:event_btnOptionsActionPerformed

    private void btnDisconnectActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnDisconnectActionPerformed
        this.hibernate = null;
        this.initForm();
    }//GEN-LAST:event_btnDisconnectActionPerformed

    private void btnExitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnExitActionPerformed
        this.salir();
    }//GEN-LAST:event_btnExitActionPerformed

    private void btnConnectActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnConnectActionPerformed
        final FrmConnectionProps frmCon = new FrmConnectionProps();
        boolean end = false;
        do {
            frmCon.setVisible(true);
            if (!frmCon.isUserCancel()) {
                serviceConnection = frmCon.getServiceConnection();                
                FrmServerTest frm = new FrmServerTest(serviceConnection);
                frm.setVisible(true);
                if (!frm.isUserCancel()) {
                    hibernate = frm.getHibernate();
                    checkTableStatus();
                    end = true;
                }
            } else {
                end = true;
            }
        } while (!end);
    }//GEN-LAST:event_btnConnectActionPerformed

    private void btnWarToolActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnWarToolActionPerformed
        WebArchive.start(this);
}//GEN-LAST:event_btnWarToolActionPerformed

    private void btnAboutActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAboutActionPerformed
        new FrmAbout().setVisible(true);
}//GEN-LAST:event_btnAboutActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAbout;
    private javax.swing.JButton btnConnect;
    private javax.swing.JButton btnDisconnect;
    private javax.swing.JButton btnExit;
    private javax.swing.JButton btnIconsManager;
    private javax.swing.JButton btnOptions;
    private javax.swing.JButton btnService;
    private javax.swing.JButton btnUninstall;
    private javax.swing.JButton btnWarTool;
    private windows.controls.PnlLayers pnlLayers;
    private windows.controls.PnlProjects pnlProjects;
    private windows.controls.PnlViewer pnlViewer;
    private javax.swing.JToolBar toolBar;
    // End of variables declaration//GEN-END:variables
}

