/*
 * Created on 18 de mayo de 2007, 09:02 AM
 */

package windows.projects;

import org.atlas.exceptions.HTTPRequestException;
import org.atlas.hibernatedata.Project;
import org.atlas.hibernatedata.Service;
import org.atlas.hibernatedata.Spatial_ref_sys;
import java.net.ConnectException;
import javax.swing.JFrame;
import org.hibernate.classic.Session;
import org.atlas.util.HibernateUtil;
import org.atlas.i18n.LocaleUtil;
import org.atlas.util.ServiceConnection;
import org.atlas.util.WindowUtils;
import windows.spatial_ref_sys.FrmSelectRefSys;

public class FrmNewProyect extends javax.swing.JDialog {
    
    private int     srid       = -1;
    private boolean userCancel =  true;
    private HibernateUtil hibernate;
    private Service       service;
    private Project       project;
    private boolean       create;
    private ServiceConnection serviceConnection;
    
    
    public FrmNewProyect(HibernateUtil hibernate, Service service, Project project, ServiceConnection serviceConnection) throws Exception{
        super((JFrame)null, true);
        this.setHibernate(hibernate);
        this.setService(service);
        this.project   = project;
        this.create    = false;
        this.serviceConnection = serviceConnection;
        
        initComponents();
        Session sess = hibernate.begin();
        sess.update(project);
        this.txtDescProy.setText(project.getDescproj());
        this.txtSRS.setText(project.getSpatial_ref_sys().getCRS().getName().getCode());
        this.srid = project.getSpatial_ref_sys().getSrid();
        if(project.getLayers().size()>0){
            this.btnShowSRID.setEnabled(false);
       }else{
            this.btnShowSRID.setEnabled(true);
        }
        sess.close();
        WindowUtils.center(this);
        WindowUtils.setFrameIcon(this,"/media/appicon.png");        
        setTitle(LocaleUtil.getString("windows/projects/messages","edit"));
    }
    
    public FrmNewProyect(HibernateUtil hibernate, Service service, ServiceConnection serviceConnection) {
        super((JFrame)null, true);
        this.setHibernate(hibernate);
        this.setService(service);
        this.project   = new Project();
        this.create    = true;
        this.serviceConnection = serviceConnection;
        initComponents();
        WindowUtils.center(this);
        WindowUtils.setFrameIcon(this,"/media/appicon.png");
        setTitle(LocaleUtil.getString("windows/projects/messages","new"));
    }
    
    
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        txtDescProy = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        jPanel3 = new javax.swing.JPanel();
        btnShowSRID = new javax.swing.JButton();
        txtSRS = new javax.swing.JTextField();
        jPanel2 = new javax.swing.JPanel();
        btnCancel = new javax.swing.JButton();
        btnContinue = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setResizable(false);

        jPanel1.setLayout(new java.awt.GridLayout(2, 2, 3, 3));

        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("windows/projects/messages",LocaleUtil.getLocale()); // NOI18N
        jLabel2.setText(bundle.getString("projName")); // NOI18N
        jPanel1.add(jLabel2);
        jPanel1.add(txtDescProy);

        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel1.setText(bundle.getString("spatial_ref_sys")); // NOI18N
        jPanel1.add(jLabel1);

        btnShowSRID.setText("...");
        btnShowSRID.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnShowSRIDActionPerformed(evt);
            }
        });

        txtSRS.setEditable(false);

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                .addComponent(txtSRS, javax.swing.GroupLayout.DEFAULT_SIZE, 212, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(btnShowSRID, javax.swing.GroupLayout.PREFERRED_SIZE, 43, javax.swing.GroupLayout.PREFERRED_SIZE))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                .addComponent(txtSRS, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addComponent(btnShowSRID))
        );

        jPanel1.add(jPanel3);

        jPanel2.setLayout(new java.awt.GridLayout(1, 2, 5, 5));

        btnCancel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/process-stop.png"))); // NOI18N
        btnCancel.setText(bundle.getString("Cancel")); // NOI18N
        btnCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelActionPerformed(evt);
            }
        });
        jPanel2.add(btnCancel);

        btnContinue.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/go-next.png"))); // NOI18N
        btnContinue.setText(bundle.getString("Continue")); // NOI18N
        btnContinue.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnContinueActionPerformed(evt);
            }
        });
        jPanel2.add(btnContinue);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, 525, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(12, Short.MAX_VALUE))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(200, Short.MAX_VALUE)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, 337, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(16, 16, 16)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    private void btnShowSRIDActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnShowSRIDActionPerformed
        
        FrmSelectRefSys frm = new FrmSelectRefSys(this.txtSRS.getText().trim());
        frm.setVisible(true);
        if(!frm.getSpatialRefenceSystemName().equals("")){
            this.txtSRS.setText(frm.getSpatialRefenceSystemName());
            this.setSrid(frm.getSrid());
        }else{
            this.txtSRS.setText("");
            this.setSrid(-1);
        }
    }//GEN-LAST:event_btnShowSRIDActionPerformed
    
    private void btnContinueActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnContinueActionPerformed
        
        if(this.getSrid()<0){
            WindowUtils.msgError(this.getRootPane(),LocaleUtil.getString("windows/projects/messages","sel_ers"));            
            return;
        }
        if(this.txtDescProy.getText().trim().equals("")){
            WindowUtils.msgError(this.getRootPane(),LocaleUtil.getString("windows/projects/messages","writ_name"));
            return;
        }
        project.setDescproj(this.txtDescProy.getText().trim());
        project.setService(service);
        
        try {
            Session sess = hibernate.begin();
            Spatial_ref_sys srs = (Spatial_ref_sys)sess.createQuery("from Spatial_ref_sys where srid = "+this.getSrid()).list().get(0);
            project.setSpatial_ref_sys(srs);
            
            if(create){
                sess.update(service);
                service.getProjects().add(project);
                sess.save(project);
            }else{
                sess.update(project);
            }
            hibernate.commitAndClose(sess);
            this.setUserCancel(false);
            
            try {
                service.updateCapabilities(this.hibernate, this.serviceConnection);
            } catch (ConnectException ex) {
                WindowUtils.msgError(this,LocaleUtil.getString("windows/projects/messages","notlisten"));
            } catch (HTTPRequestException ex) {
                LocaleUtil.getString("windows/projects/messages","statecode");
                WindowUtils.msgInfo(this," " + ex.getStatusCode() + " " + service.getServiceURL() );
            } catch (Exception ex) {
                ex.printStackTrace();
            }
            
            this.setVisible(false);
        } catch (Exception ex) {
            ex.printStackTrace();
            WindowUtils.msgError(this,"Unexpected data base connection error while trying to save the project");
        }
    }//GEN-LAST:event_btnContinueActionPerformed
    
    private void btnCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelActionPerformed
        this.setUserCancel(true);
        this.setVisible(false);
    }//GEN-LAST:event_btnCancelActionPerformed
    
    
    public boolean isUserCancel() {
        return userCancel;
    }
    
    public void setUserCancel(boolean userCancel) {
        this.userCancel = userCancel;
    }
    
    public int getSrid() {
        return srid;
    }
    
    public void setSrid(int srid) {
        this.srid = srid;
    }
    
    public void setHibernate(HibernateUtil hibernate) {
        this.hibernate = hibernate;
    }
    
    public void setService(Service service) {
        this.service = service;
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnCancel;
    private javax.swing.JButton btnContinue;
    private javax.swing.JButton btnShowSRID;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JTextField txtDescProy;
    private javax.swing.JTextField txtSRS;
    // End of variables declaration//GEN-END:variables
    
}
