/*
 * Created on 30 de abril de 2007, 07:46 PM
 */
package windows.service;

import org.atlas.exceptions.HTTPRequestException;
import org.atlas.hibernatedata.Icon;
import org.atlas.hibernatedata.Service;
import org.atlas.i18n.StringProvider;
import java.awt.event.WindowEvent;
import java.net.ConnectException;
import java.net.MalformedURLException;
import java.awt.Frame;
import java.awt.event.WindowAdapter;
import java.net.URL;
import java.util.regex.Pattern;
import javax.swing.DefaultListModel;
import org.hibernate.classic.Session;
import org.atlas.util.HibernateUtil;
import org.atlas.i18n.LocaleUtil;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.net.HttpURLConnection;
import java.net.InetSocketAddress;
import java.net.Socket;
import org.atlas.util.Configuration;
import org.atlas.util.IOUtils;
import org.atlas.util.RegexDocument;
import org.atlas.util.ServiceConnection;
import org.atlas.util.WindowUtils;
import org.atlas.util.FrmWait;

public class FrmServiceProps extends javax.swing.JDialog {

    private boolean userCancel;
    private DefaultListModel wordsModel = new DefaultListModel();
    private HibernateUtil hibernate;
    private Service service;
    private boolean create;
    private ServiceConnection serviceConnection;

    public FrmServiceProps(HibernateUtil hibernate, ServiceConnection serviceConnection) throws Exception {
        super((Frame) null, true);
        initComponents();
        this.lstWords.setModel(wordsModel);
        this.hibernate = hibernate;
        this.serviceConnection = serviceConnection;

        this.txtAbstract.setDocument(new RegexDocument("[A-Za-zÑñ0-9ÁÉÍÓÚáéíóú \\Q()[]{}+-*/^\\$|¿?#@.,;:_ !¡\\E]{1,}"));
        this.txtLayerLimit.setDocument(new RegexDocument("[0-9]{1,}"));
        this.txtMail.setDocument(new RegexDocument("[a-zA-Z0-9\\!\\#\\$\\%\\&\\'\\*\\+\\-\\/\\=\\?\\^\\_\\`\\{\\|\\}\\~\\.@]{1,}"));
        this.txtMaxHeight.setDocument(new RegexDocument("[0-9]{1,}"));
        this.txtMaxWidth.setDocument(new RegexDocument("[0-9]{1,}"));
        this.txtPerson.setDocument(new RegexDocument("[A-Za-zÑñ0-9ÁÉÍÓÚáéíóú ]{1,}"));
        this.txtTitle.setDocument(new RegexDocument("[A-Za-zÑñ0-9ÁÉÍÓÚáéíóú ]{1,}"));
        this.txtWord.setDocument(new RegexDocument("[A-Za-zÑñ0-9ÁÉÍÓÚáéíóú ]{1,}"));

        loadService();

        this.addWindowListener(new WindowAdapter() {

            @Override
            public void windowClosing(WindowEvent windowEvent) {
                userCancel = true;
            }
        });
        org.atlas.util.WindowUtils.center(this);
        org.atlas.util.WindowUtils.setFrameIcon(this, "/media/appicon.png");
    }

    private boolean validateMailAddres(String email) {
        String sp = "\\!\\#\\$\\%\\&\\'\\*\\+\\-\\/\\=\\?\\^\\_\\`\\{\\|\\}\\~";
        String atext = "[a-zA-Z0-9" + sp + "]";
        String atom = atext + "+";
        String dotAtom = "\\." + atom;
        String localPart = atom + "(" + dotAtom + ")*";
        String letter = "[a-zA-Z]";
        String letDig = "[a-zA-Z0-9]";
        String letDigHyp = "[a-zA-Z0-9-]";
        String rfcLabel = letDig + "(" + letDigHyp + "{0,61}" + letDig + ")?";
        String domain = rfcLabel + "(\\." + rfcLabel + ")*\\." + letter + "{2,6}";
        String addrSpec = "^" + localPart + "@" + domain + "$";

        Pattern VALID_PATTERN = Pattern.compile(addrSpec);
        return VALID_PATTERN.matcher(email).matches();
    }

    private void loadService() throws Exception {
        service = Service.getService(hibernate);
        if (service != null) {
            create = false;
            this.txtAbstract.setText(service.getSummary());
            this.txtLayerLimit.setText(service.getLayerLimit());
            this.txtMail.setText(service.getContactElectronicMailAddress());
            this.txtMaxHeight.setText(service.getMaxHeight());
            this.txtMaxWidth.setText(service.getMaxWidth());
            this.txtOrganization.setText(service.getContactOrganization());
            this.txtPerson.setText(service.getContactPerson());
            this.txtServerURL.setText(service.getServiceURL());
            this.txtTitle.setText(service.getTitle());
            this.txtURL.setText(service.getProviderURL());
            wordsModel = (DefaultListModel) WindowUtils.getListModel(service.getKeywordList(), ",");
            this.lstWords.setModel(wordsModel);
            this.chkPublicAccess.setSelected(service.isPublicaccess());
        } else {
            service = new Service();
            service.setServiceURL(serviceConnection.getAppUrl());
            this.txtServerURL.setText(serviceConnection.getAppUrl());
            create = true;
        }
    }

    public boolean isUserCancel() {
        return userCancel;
    }

    public void setUserCancel(boolean userCancel) {
        this.userCancel = userCancel;
    }

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        txtTitle = new javax.swing.JTextField();
        jPanel3 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        txtAbstract = new javax.swing.JTextArea();
        jPanel4 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        jPanel5 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        lstWords = new javax.swing.JList();
        jPanel6 = new javax.swing.JPanel();
        btnAddWord = new javax.swing.JButton();
        btnDelWord = new javax.swing.JButton();
        txtWord = new javax.swing.JTextField();
        jPanel7 = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        txtURL = new javax.swing.JTextField();
        jPanel19 = new javax.swing.JPanel();
        jLabel16 = new javax.swing.JLabel();
        txtLayerLimit = new javax.swing.JTextField();
        jPanel20 = new javax.swing.JPanel();
        jLabel17 = new javax.swing.JLabel();
        txtMaxWidth = new javax.swing.JTextField();
        jPanel21 = new javax.swing.JPanel();
        jLabel18 = new javax.swing.JLabel();
        txtMaxHeight = new javax.swing.JTextField();
        jPanel23 = new javax.swing.JPanel();
        btnUpdate = new javax.swing.JButton();
        btnCancel = new javax.swing.JButton();
        btnContinue = new javax.swing.JButton();
        jPanel16 = new javax.swing.JPanel();
        jLabel13 = new javax.swing.JLabel();
        txtMail = new javax.swing.JTextField();
        jPanel8 = new javax.swing.JPanel();
        jLabel5 = new javax.swing.JLabel();
        txtPerson = new javax.swing.JTextField();
        jPanel9 = new javax.swing.JPanel();
        jLabel6 = new javax.swing.JLabel();
        txtServerURL = new javax.swing.JTextField();
        jPanel10 = new javax.swing.JPanel();
        jLabel7 = new javax.swing.JLabel();
        txtOrganization = new javax.swing.JTextField();
        jPanel11 = new javax.swing.JPanel();
        jLabel8 = new javax.swing.JLabel();
        chkPublicAccess = new javax.swing.JCheckBox();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("windows/service/messages",LocaleUtil.getLocale()); // NOI18N
        setTitle(bundle.getString("serviceInfo")); // NOI18N
        setResizable(false);

        jPanel1.setLayout(new java.awt.GridLayout(1, 0, 5, 5));

        jLabel1.setForeground(new java.awt.Color(0, 102, 204));
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel1.setText(bundle.getString("title")); // NOI18N
        jPanel1.add(jLabel1);
        jPanel1.add(txtTitle);

        jPanel3.setLayout(new java.awt.GridLayout(1, 0, 5, 5));

        jLabel2.setForeground(new java.awt.Color(0, 102, 204));
        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel2.setText(bundle.getString("abstract")); // NOI18N
        jLabel2.setVerticalAlignment(javax.swing.SwingConstants.TOP);
        jPanel3.add(jLabel2);

        txtAbstract.setColumns(20);
        txtAbstract.setRows(5);
        jScrollPane1.setViewportView(txtAbstract);

        jPanel3.add(jScrollPane1);

        jPanel4.setLayout(new java.awt.GridLayout(1, 0, 5, 5));

        jLabel3.setForeground(new java.awt.Color(0, 102, 204));
        jLabel3.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel3.setText(bundle.getString("Keyword")); // NOI18N
        jLabel3.setVerticalAlignment(javax.swing.SwingConstants.TOP);
        jPanel4.add(jLabel3);

        jScrollPane2.setViewportView(lstWords);

        btnAddWord.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/gtk-add.png"))); // NOI18N
        btnAddWord.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnAddWord.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAddWordActionPerformed(evt);
            }
        });

        btnDelWord.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/gtk-clear.png"))); // NOI18N
        btnDelWord.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnDelWord.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnDelWordActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel6Layout = new javax.swing.GroupLayout(jPanel6);
        jPanel6.setLayout(jPanel6Layout);
        jPanel6Layout.setHorizontalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel6Layout.createSequentialGroup()
                .addComponent(txtWord, javax.swing.GroupLayout.DEFAULT_SIZE, 194, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(btnAddWord)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(btnDelWord))
        );
        jPanel6Layout.setVerticalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(btnAddWord)
            .addComponent(btnDelWord)
            .addComponent(txtWord, javax.swing.GroupLayout.DEFAULT_SIZE, 28, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 260, Short.MAX_VALUE)
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addComponent(jPanel6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 65, Short.MAX_VALUE))
        );

        jPanel4.add(jPanel5);

        jPanel7.setLayout(new java.awt.GridLayout(1, 0, 5, 5));

        jLabel4.setForeground(new java.awt.Color(0, 102, 204));
        jLabel4.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel4.setText(bundle.getString("url")); // NOI18N
        jPanel7.add(jLabel4);
        jPanel7.add(txtURL);

        jPanel19.setLayout(new java.awt.GridLayout(1, 0, 5, 5));

        jLabel16.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel16.setText(bundle.getString("layerLimit")); // NOI18N
        jPanel19.add(jLabel16);
        jPanel19.add(txtLayerLimit);

        jPanel20.setLayout(new java.awt.GridLayout(1, 0, 5, 5));

        jLabel17.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel17.setText(bundle.getString("maxWidth")); // NOI18N
        jPanel20.add(jLabel17);
        jPanel20.add(txtMaxWidth);

        jPanel21.setLayout(new java.awt.GridLayout(1, 0, 5, 5));

        jLabel18.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel18.setText(bundle.getString("maxHeight")); // NOI18N
        jPanel21.add(jLabel18);
        jPanel21.add(txtMaxHeight);

        jPanel23.setLayout(new java.awt.GridLayout(1, 0, 5, 5));

        btnUpdate.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/refresh.png"))); // NOI18N
        btnUpdate.setText(bundle.getString("update_key")); // NOI18N
        btnUpdate.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnUpdateActionPerformed(evt);
            }
        });
        jPanel23.add(btnUpdate);

        btnCancel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/process-stop.png"))); // NOI18N
        java.util.ResourceBundle bundle1 = java.util.ResourceBundle.getBundle("windows/connections/messages",LocaleUtil.getLocale()); // NOI18N
        btnCancel.setText(bundle1.getString("Cancel")); // NOI18N
        btnCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelActionPerformed(evt);
            }
        });
        jPanel23.add(btnCancel);

        btnContinue.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/connect.png"))); // NOI18N
        btnContinue.setText(bundle1.getString("continue")); // NOI18N
        btnContinue.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnContinueActionPerformed(evt);
            }
        });
        jPanel23.add(btnContinue);

        jPanel16.setLayout(new java.awt.GridLayout(1, 0, 5, 5));

        jLabel13.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel13.setText(bundle.getString("mail")); // NOI18N
        jPanel16.add(jLabel13);
        jPanel16.add(txtMail);

        jPanel8.setLayout(new java.awt.GridLayout(1, 0, 5, 5));

        jLabel5.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel5.setText(bundle.getString("contactPerson")); // NOI18N
        jPanel8.add(jLabel5);
        jPanel8.add(txtPerson);

        jPanel9.setLayout(new java.awt.GridLayout(1, 0, 5, 5));

        jLabel6.setForeground(new java.awt.Color(0, 102, 204));
        jLabel6.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel6.setText(bundle.getString("serviceURL")); // NOI18N
        jPanel9.add(jLabel6);
        jPanel9.add(txtServerURL);

        jPanel10.setLayout(new java.awt.GridLayout(1, 2, 5, 5));

        jLabel7.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel7.setText(bundle.getString("contactOrganization")); // NOI18N
        jPanel10.add(jLabel7);
        jPanel10.add(txtOrganization);

        jPanel11.setLayout(new java.awt.GridLayout(1, 2, 5, 5));

        jLabel8.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel8.setText(bundle.getString("Publicc_Access:")); // NOI18N
        jPanel11.add(jLabel8);

        chkPublicAccess.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        chkPublicAccess.setMargin(new java.awt.Insets(0, 0, 0, 0));
        chkPublicAccess.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chkPublicAccessActionPerformed(evt);
            }
        });
        jPanel11.add(chkPublicAccess);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, 526, Short.MAX_VALUE)
                    .addComponent(jPanel1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 526, Short.MAX_VALUE)
                    .addComponent(jPanel7, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 526, Short.MAX_VALUE)
                    .addComponent(jPanel19, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 526, Short.MAX_VALUE)
                    .addComponent(jPanel20, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 526, Short.MAX_VALUE)
                    .addComponent(jPanel21, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 526, Short.MAX_VALUE)
                    .addComponent(jPanel4, javax.swing.GroupLayout.DEFAULT_SIZE, 526, Short.MAX_VALUE)
                    .addComponent(jPanel9, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 526, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jPanel16, javax.swing.GroupLayout.PREFERRED_SIZE, 526, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jPanel8, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 526, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jPanel10, javax.swing.GroupLayout.PREFERRED_SIZE, 526, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jPanel23, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 526, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jPanel11, javax.swing.GroupLayout.PREFERRED_SIZE, 526, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel19, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel20, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel21, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, 99, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel16, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel8, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel10, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel11, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 36, Short.MAX_VALUE)
                .addComponent(jPanel23, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
    private void chkPublicAccessActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chkPublicAccessActionPerformed
// TODO add your handling code here:
    }//GEN-LAST:event_chkPublicAccessActionPerformed

    private void btnUpdateActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnUpdateActionPerformed
        save();
    }//GEN-LAST:event_btnUpdateActionPerformed

    private void btnDelWordActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnDelWordActionPerformed
        if (this.lstWords.getSelectedIndex() >= 0) {
            this.wordsModel.remove(this.lstWords.getSelectedIndex());
        }
    }//GEN-LAST:event_btnDelWordActionPerformed

    private void btnAddWordActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAddWordActionPerformed
        if (!this.txtWord.getText().trim().equals("")) {
            this.wordsModel.addElement(this.txtWord.getText());
            WindowUtils.sortListModel(this.wordsModel);
            this.txtWord.setText("");
            this.txtWord.grabFocus();
        }
    }//GEN-LAST:event_btnAddWordActionPerformed

    private void btnCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelActionPerformed
        this.userCancel = true;
        this.setVisible(false);
    }//GEN-LAST:event_btnCancelActionPerformed

    private boolean validateForm() {
        StringProvider sp = new StringProvider("windows/service/messages");


        String title = this.txtTitle.getText().trim();
        if (title.equals("")) {
            WindowUtils.msgError(this, sp.getString("titleReq"));
            this.txtTitle.grabFocus();
            return false;
        }

        String sumary = this.txtAbstract.getText().trim();
        if (sumary.equals("")) {
            WindowUtils.msgError(this, sp.getString("abstrReq"));
            this.txtAbstract.grabFocus();
            return false;
        }

        if (this.wordsModel.getSize() == 0) {
            WindowUtils.msgError(this, sp.getString("wordsReq"));
            this.txtWord.grabFocus();
            return false;
        }

        String URL = this.txtURL.getText().trim();
        if (URL.equals("")) {
            WindowUtils.msgError(this, sp.getString("urlReq"));
            this.txtURL.grabFocus();
            return false;
        }

        String servURL = this.txtServerURL.getText().trim();
        if (servURL.equals("")) {
            WindowUtils.msgError(this, sp.getString("servUrlReq"));
            this.txtServerURL.grabFocus();
            return false;
        } else {
            URL dir = null;
            try {
                dir = new URL(servURL);
            } catch (MalformedURLException ex) {
                WindowUtils.msgError(this, sp.getString("invServURL"));
                this.txtServerURL.grabFocus();
                return false;
            }
        }

        String mail = this.txtMail.getText().trim();
        if (!mail.equals("")) {
            if (!validateMailAddres(mail)) {
                WindowUtils.msgError(this, sp.getString("invMail"));
                this.txtMail.grabFocus();
                return false;
            }
        }


        String contactPerson = this.txtPerson.getText().trim();
        String contactOrganization = this.txtOrganization.getText().trim();

        if ((contactOrganization.equals("") && !contactPerson.equals("")) || (!contactOrganization.equals("") && contactPerson.equals(""))) {
            WindowUtils.msgError(this, sp.getString("fillError"));
            this.txtPerson.grabFocus();
            return false;
        }

        try {
            URL dir = new URL(URL);
        } catch (MalformedURLException ex) {
            WindowUtils.msgError(this, sp.getString("invURL"));
            this.txtURL.grabFocus();
            return false;
        }

        if (!this.chkPublicAccess.isSelected()) {
            chkPublicAccess.setSelected(WindowUtils.msgYesNo(null, sp.getString("war_acc_pub")));
        }

        if (!isValidAddress(servURL)) {
            this.txtServerURL.grabFocus();
            return false;
        }

        return true;
    }

    private void saveService(Session sess) throws Exception {
        service.setContactElectronicMailAddress(this.txtMail.getText().trim());
        service.setContactPerson(this.txtPerson.getText().trim());
        service.setContactOrganization(this.txtOrganization.getText().trim());
        service.setKeywordList(WindowUtils.getItemsString(this.wordsModel, ","));
        service.setLayerLimit(this.txtLayerLimit.getText());
        service.setMaxHeight(this.txtMaxHeight.getText());
        service.setMaxWidth(this.txtMaxWidth.getText());
        service.setServiceURL(this.txtServerURL.getText().trim());
        service.setProviderURL(this.txtURL.getText().trim());
        service.setSummary(this.txtAbstract.getText().trim());
        service.setTitle(this.txtTitle.getText().trim());
        service.setPublicaccess(this.chkPublicAccess.isSelected());

        sess = hibernate.begin();
        if (create == true) {
            sess.save(service);
            String path = Configuration.getWorkingDirectory()+"icons";
            String[] nl = new File(path).list();

            for (int i = 0; i < nl.length; i++) {
                File f = new File(path + File.separator + nl[i]);
                if (!f.isDirectory()) {
                    Icon icon = new Icon();
                    icon.setTypeicon("image/svg");
                    icon.setDescicon(f.getName());
                    FileInputStream fis = new FileInputStream(f);
                    icon.setBinaicon(IOUtils.readFromStream(fis));
                    icon.createThumb();
                    
                    fis.close();
                    sess.save(icon);
                    service.getIcons().add(icon);
                }
            }
        } else {
            sess.update(service);
        }
        hibernate.commitAndClose(sess);
    }

    private void save() {
        FrmWait frm = new FrmWait() {

            @Override
            public void action() {
                if (validateForm()) {
                    Session sess = null;
                    try {
                        saveService(sess);
                        try {
                            service.updateCapabilities(hibernate, serviceConnection);
                        } catch (ConnectException ex) {
                            ex.printStackTrace();
                            WindowUtils.msgError(this, LocaleUtil.getString("windows/service/messages", "notlisten"));
                        } catch (HTTPRequestException ex) {
                            LocaleUtil.getString("windows/service/messages", "statecode");
                            WindowUtils.msgInfo(this, " " + ex.getStatusCode() + " " + service.getServiceURL());
                        } catch (Exception ex) {
                            ex.printStackTrace();
                        }
                        destroy();
                    } catch (Exception ex) {
                        ex.printStackTrace();
                        WindowUtils.msgError(this, LocaleUtil.getString("windows/service/messages", "UnexError"));
                        try {
                            hibernate.close(sess);
                        } catch (Exception ex1) {
                            ex1.printStackTrace();
                        }
                    }
                }
            }
        };
        frm.setMessage(org.atlas.i18n.LocaleUtil.getString("windows/service/messages", "wait"));
        frm.setVisible(true);
    }

    private void btnContinueActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnContinueActionPerformed
        save();
}//GEN-LAST:event_btnContinueActionPerformed

    private void destroy() {
        dispose();
    }

    private boolean isValidAddress(String urlcad) {
        //test for a valid URL
        URL url = null;
        StringProvider sp = new StringProvider("windows/service/messages");
        try {
            url = new URL(urlcad);
        } catch (MalformedURLException ex) {
            WindowUtils.msgError(this, sp.getString("invalid_url"));
            return false;
        }

        //testing matching
        try {
            URL surl = new URL(serviceConnection.getAppUrl());
            boolean match = true;
            if (!url.getProtocol().equals(surl.getProtocol())) {
                match = false;
            }
            if (!(url.getPort() == surl.getPort())) {
                match = false;
            }
            if (!url.getPath().equals(surl.getPath())) {
                match = false;
            }
            if (!match) {
                WindowUtils.msgError(this, sp.getString("no_match") + " " + serviceConnection.getAppUrl());
                return false;
            }
        } catch (MalformedURLException ex) {
            WindowUtils.msgError(this, sp.getString("unex_error") + " " + url.getHost());
            ex.printStackTrace();
            return false;
        }

        ////TPCIP TEST////

        FrmTCPTest frm = new FrmTCPTest(url);
        frm.setMessage(sp.getString("creat_tcp"));
        frm.setVisible(true);
        if (!frm.isRes()) {
            WindowUtils.msgError(this, sp.getString("tcpip_error") + " " + url.getHost() + ":" + url.getPort());
            return false;
        }

        //looking for HTTP Server
        try {
            int port = url.getPort();
            if (port <= 0) {
                port = url.getDefaultPort();
            }
            URL basURL = new URL(url.getProtocol() + "://" + url.getHost() + ":" + port);
            HttpURLConnection urlCon = (HttpURLConnection) basURL.openConnection();
            urlCon.getResponseCode();
        } catch (MalformedURLException ex) {
            WindowUtils.msgError(this, sp.getString("unex_error") + " " + url.toString());
            ex.printStackTrace();
            return false;
        } catch (IOException ex) {
            ex.printStackTrace();
            WindowUtils.msgError(this, sp.getString("no_http") + " " + url.toString());
            return false;
        }

        return true;
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAddWord;
    private javax.swing.JButton btnCancel;
    private javax.swing.JButton btnContinue;
    private javax.swing.JButton btnDelWord;
    private javax.swing.JButton btnUpdate;
    private javax.swing.JCheckBox chkPublicAccess;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel10;
    private javax.swing.JPanel jPanel11;
    private javax.swing.JPanel jPanel16;
    private javax.swing.JPanel jPanel19;
    private javax.swing.JPanel jPanel20;
    private javax.swing.JPanel jPanel21;
    private javax.swing.JPanel jPanel23;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JList lstWords;
    private javax.swing.JTextArea txtAbstract;
    private javax.swing.JTextField txtLayerLimit;
    private javax.swing.JTextField txtMail;
    private javax.swing.JTextField txtMaxHeight;
    private javax.swing.JTextField txtMaxWidth;
    private javax.swing.JTextField txtOrganization;
    private javax.swing.JTextField txtPerson;
    private javax.swing.JTextField txtServerURL;
    private javax.swing.JTextField txtTitle;
    private javax.swing.JTextField txtURL;
    private javax.swing.JTextField txtWord;
    // End of variables declaration//GEN-END:variables
    private class FrmTCPTest extends FrmWait {

        private URL iurl;
        private boolean res;

        public FrmTCPTest(URL iurl) {
            this.iurl = iurl;
        }

        public void action() {
            Socket socket = null;
            try {
                int port = iurl.getPort();
                String host = iurl.getHost();
                if (port <= 0) {
                    port = iurl.getDefaultPort();
                }
                socket = new Socket();
                socket.connect(new InetSocketAddress(host, port), 5000);
                setRes(true);
            } catch (Exception ex) {
                ex.printStackTrace();
                setRes(false);
            } finally {
                try {
                    if (socket != null) {
                        socket.close();
                    }
                } catch (IOException ex) {
                    ex.printStackTrace();
                }
            }
        }

        public boolean isRes() {
            return res;
        }

        private void setRes(boolean res) {
            this.res = res;
        }
    }
}
