package windows.servicetest;

import org.atlas.i18n.StringProvider;


// End of variables declaration                   

class Problem{
    
    public static final int TYPE_INFO = 1;
    public static final int TYPE_WARN = 2;
    public static final int TYPE_ERROR = 3;
    
    private String description;
    private String cause;
    private String solution;
    private String message;
    private int    type;
            
    public Problem(int id, int type, StringProvider sp){
        this(sp.getString("des"+id), sp.getString("cau"+id),sp.getString("sol"+id), type);
    }
     
    public Problem(int id, String message, int type, StringProvider sp){
        this(sp.getString("des"+id), sp.getString("cau"+id),sp.getString("sol"+id), message, type);
    }
       
    
    public Problem(String description, String cause, String solution, int type){
        this.description = description;
        this.cause       = cause;
        this.solution    = solution;
    }
    
    public Problem(String description, String cause, String solution, String message, int type){
        this.description = description;
        this.cause       = cause;
        this.solution    = solution;
        this.message     = message;
    }
    
    public String getDescription() {
        return description;
    }
    
    public void setDescription(String description) {
        this.description = description;
    }
    
    public String getCause() {
        return cause;
    }
    
    public void setCause(String cause) {
        this.cause = cause;
    }
    
    public String getSolution() {
        return solution;
    }
    
    public void setSolution(String solution) {
        this.solution = solution;
    }

    public int getType() {
        return type;
    }

    public void setType(int type) {
        this.type = type;
    }

    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }
}