/*
 * Created on 31 de mayo de 2007, 09:37 AM
 */

package windows.sources;

import org.atlas.exceptions.HTTPRequestException;
import org.atlas.hibernatedata.Project;
import org.atlas.hibernatedata.Service;
import org.atlas.hibernatedata.Source;
import org.geotools.feature.AttributeType;
import java.awt.Frame;
import java.io.File;
import java.io.IOException;
import java.net.ConnectException;
import java.sql.SQLException;
import javax.swing.table.AbstractTableModel;
import org.atlas.util.DataBaseUtils;
import org.atlas.util.HibernateUtil;
import org.atlas.i18n.LocaleUtil;
import org.atlas.i18n.StringProvider;
import org.atlas.util.ServiceConnection;
import org.atlas.util.ShapeFileUtils;
import org.atlas.util.WindowUtils;
import org.atlas.util.FrmWait;

public class FrmAddShapeFile extends javax.swing.JDialog {
    
    private File            shapeFile;
    private typesModel      model;
    private HibernateUtil   hu;
    private AttributeType[] tipos;
    private ServiceConnection serviceConnection;
    private Project project;
    private StringProvider provider = new StringProvider("windows/layers/messages");    
    
    public FrmAddShapeFile(Project project, File f, HibernateUtil hu, ServiceConnection serviceConnection){
        super((Frame)null, true);
        this.shapeFile = f;
        this.hu        = hu;
        this.serviceConnection = serviceConnection;
        this.project = project;
        
        initComponents();
        WindowUtils.center(this);
        WindowUtils.setFrameIcon(this,"/media/appicon.png");
        tipos = new AttributeType[0];
        model = new typesModel();
        model.setTypes(tipos);
        tbltypes.setModel(this.model);
    }
    
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        tbltypes = new javax.swing.JTable();
        jPanel2 = new javax.swing.JPanel();
        btnCancel = new javax.swing.JButton();
        btnOk = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        txtSrcName = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Importación de un ShapeFile");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowOpened(java.awt.event.WindowEvent evt) {
                formWindowOpened(evt);
            }
        });

        tbltypes.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane1.setViewportView(tbltypes);

        jPanel2.setLayout(new java.awt.GridLayout(1, 0, 10, 0));

        btnCancel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/process-stop.png"))); // NOI18N
        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("windows/layers/messages",LocaleUtil.getLocale()); // NOI18N
        btnCancel.setText(bundle.getString("cancel")); // NOI18N
        btnCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelActionPerformed(evt);
            }
        });
        jPanel2.add(btnCancel);

        btnOk.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/go-next.png"))); // NOI18N
        btnOk.setText(bundle.getString("import")); // NOI18N
        btnOk.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnOkActionPerformed(evt);
            }
        });
        jPanel2.add(btnOk);

        jLabel1.setText(bundle.getString("file_fields")); // NOI18N

        java.util.ResourceBundle bundle1 = java.util.ResourceBundle.getBundle("windows/sources/messages"); // NOI18N
        jLabel2.setText(bundle1.getString("source_name")); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 477, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 116, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(txtSrcName, javax.swing.GroupLayout.DEFAULT_SIZE, 357, Short.MAX_VALUE))
                    .addComponent(jLabel1)
                    .addComponent(jPanel2, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 325, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(txtSrcName, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 19, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 279, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    private void formWindowOpened(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowOpened
        FrmAnalisys frm = new FrmAnalisys(shapeFile);
        frm.setVisible(true);
        if(frm.getTypes()==null){
            this.dispose();
        }else{
            model.setTypes(frm.getTypes());
            txtSrcName.setText(frm.getTableName());
        }
    }//GEN-LAST:event_formWindowOpened
    
    private void btnCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelActionPerformed
        this.dispose();
    }//GEN-LAST:event_btnCancelActionPerformed
    
    private void btnOkActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnOkActionPerformed
        final String tabName = txtSrcName.getText().toLowerCase();
        boolean importar = false;
        
        try {
            Source[] sources = new Source[project.getSources().size()];
            project.getSources().toArray(sources);
            for (int i = 0; i < sources.length; i++) {
                Source source = sources[i];
                if(source.getTablsour().toLowerCase().equals(tabName)){
                    WindowUtils.msgInfo(this, provider.getString("source_already"));
                    return;
                }
            }

            if(DataBaseUtils.getTableExists(tabName,hu.getConnection())){
                String msg = provider.getString("del_req")+" "+tabName+".\n";
                msg = msg+provider.getString("continue");
                
                if(WindowUtils.msgYesNo(this,msg)){
                    DataBaseUtils.removeTable(tabName, this.hu.getConnection());
                                        
                    importar = true;
                }
            }else{
                importar = true;
            }
        } catch (SQLException ex) {
            ex.printStackTrace();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        
        if(importar){
            FrmWait wait = new FrmWait(){
                public void action() {
                    try {
                        
                        setMessage(provider.getString("importing"));
                        ShapeFileUtils.importShapeFile(shapeFile, tabName, model.imp,project,hu);                        
                        Service service = null;
                        try {
                            service = Service.getService(hu);
                            service.updateCapabilities(hu, serviceConnection);
                        } catch (ConnectException ex) {
                            WindowUtils.msgError(this,provider.getString("notlisten"));
                            ex.printStackTrace();
                        } catch (HTTPRequestException ex) {
                            WindowUtils.msgInfo(this," " + ex.getStatusCode() + " " + service.getServiceURL() );
                        } catch (Exception ex) {
                            ex.printStackTrace();
                        }
                    } catch (SQLException ex) {
                        WindowUtils.msgError(null,"Error SQL durante la importación del ShapeFile");
                        ex.printStackTrace();
                    } catch (IOException ex) {
                        WindowUtils.msgError(null,"Error I/O durante la importación del ShapeFile");
                        ex.printStackTrace();
                    } catch (Exception ex) {
                        WindowUtils.msgError(null,"Error inesperado durante la impotación del ShapeFile");
                        ex.printStackTrace();
                    }
                }
            };
            wait.setVisible(true);
            this.dispose();
        }
    }//GEN-LAST:event_btnOkActionPerformed
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnCancel;
    private javax.swing.JButton btnOk;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable tbltypes;
    private javax.swing.JTextField txtSrcName;
    // End of variables declaration//GEN-END:variables
    
    private class typesModel extends AbstractTableModel{
        
        private AttributeType[] tipos;
        private Boolean[]       imp;
        
        public void setTypes(AttributeType[] tipos){
            this.tipos = tipos;
            this.fireTableDataChanged();
            this.imp = new Boolean[tipos.length];
            for (int i = 0; i < tipos.length; i++) {
                imp[i] = new Boolean(true);
            }
        }
        
        @Override
        public boolean isCellEditable(int row, int column){
            if(column>1){
                if(!tipos[row].getType().getPackage().getName().toLowerCase().equals("com.vividsolutions.jts.geom")){
                    return true;
                }
            }
            return false;
        }
        
        @Override
        public String getColumnName(int column){
            String[] titulos = {LocaleUtil.getString("windows/layers/messages","name"), LocaleUtil.getString("windows/layers/messages","type"), LocaleUtil.getString("windows/layers/messages","import")};
            return titulos[column];
        }
        public int getRowCount(){ return tipos.length; }
        public int getColumnCount(){ return 3; }
        @Override
        public Class getColumnClass(int c) {
            return getValueAt(0, c).getClass();
        }
                
        public Object getValueAt(int row, int column){
            if(column == 0){
                return tipos[row].getName();
            }else if(column == 1){
                return tipos[row].getType().getSimpleName().toUpperCase();
            }else{
                return imp[row];
            }
        }
        
        @Override
        public void setValueAt(Object object, int row, int column) {
            if(column==2){
                this.imp[row] = (Boolean)object;
            }
        }
        
        public Boolean[] getSelectionArray(){
            return this.imp;
        }
    }
        
    private class FrmAnalisys extends FrmWait{
        private AttributeType[] types;
        private File file;
        private String tableName;
        
        public FrmAnalisys(File file){
            this.file = file;
        }
        
        public AttributeType[] getTypes() {
            return types;
        }
        
        public String getTableName() {
            return tableName;
        }

        public void setTableName(String tableName) {
            this.tableName = tableName;
        }
        
        public void action(){
            setMessage(java.util.ResourceBundle.getBundle("windows/controls/messages",LocaleUtil.getLocale()).getString("analyz_shape"));
            try {
                types = ShapeFileUtils.readAttributes(file);
                int i = file.getName().lastIndexOf(".");
                tableName = file.getName().substring(0, i);
            } catch (Exception ex) {
                WindowUtils.msgError(null,java.util.ResourceBundle.getBundle("windows/controls/messages",LocaleUtil.getLocale()).getString("error_analyz_shape")+"\n"+ex.getMessage());
            }
        }
    }
}
