package windows.style;

import org.atlas.hibernatedata.AtlasStroke;
import org.atlas.hibernatedata.Style;
import org.atlas.i18n.LocaleUtil;
import java.awt.SystemColor;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import javax.swing.border.TitledBorder;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import org.atlas.util.WindowUtils;

public class PnlEditLineStyl extends javax.swing.JPanel implements StyleEditor{
    
    private Style style;
    private List<ChangeListener> changeListeners = new ArrayList<ChangeListener>();
    
    public PnlEditLineStyl() {
        initComponents();
        
        lineColor.addChangeListener(new ChangeListener(){
            public void stateChanged(ChangeEvent ce) {
                fireChangeListeners();
            }
        });
        
        jspinner.addChangeListener(new ChangeListener(){
            public void stateChanged(ChangeEvent ce) {
                fireChangeListeners();
            }
        });
        
        setEnabled(false);
        
        ActionListener al = new ActionListener(){
            public void actionPerformed(ActionEvent actionEvent) {
                asignarStroke();
            }
        };
        
        jtb1.addActionListener(al);
        jtb2.addActionListener(al);
        jtb3.addActionListener(al);
        jtb4.addActionListener(al);
        jtb5.addActionListener(al);
        jtb6.addActionListener(al);
        
    }
    
    @Override
    public void setEnabled(boolean b) {
        super.setEnabled(b);
        lineColor.setEnabled(b);
        lblWidth.setEnabled(b);
        lblStyle.setEnabled(b);
        jspinner.setEnabled(b);
        pnlLineStyles.setEnabled(b);
        WindowUtils.setPanelChildrenEnabled(pnlLineStyles, b);
                
        TitledBorder title2 = new TitledBorder(LocaleUtil.getString("windows/style/messages","line_key"));
        
        if(!b){            
            title2.setTitleColor(SystemColor.inactiveCaption);
        }
        pnlLine.setBorder(title2);
    }
    
    public void setStyle(Style style) {
        this.style = style;
        if(style!=null){
            setEnabled(true);
            
            float[] dash = style.getLinestyl().getDash();
            float width  = style.getLinestyl().getWidth();
            
            jspinner.setValue(width);
            
            switch(dash.length){
                case 0:
                    if(width > 0){
                        jtb1.setSelected(true);
                        
                        lineColor.setEnabled(true);
                        jspinner.setEnabled(true);
                        lblWidth.setEnabled(true);
                    }else{
                        jtb6.setSelected(true);
                        
                        lineColor.setEnabled(false);
                        jspinner.setEnabled(false);
                        lblWidth.setEnabled(false);
                    }
                    break;
                case 1:  jtb2.setSelected(true); break;
                case 4:  jtb3.setSelected(true); break;
                case 2:  jtb4.setSelected(true); break;
                case 6:  jtb5.setSelected(true); break;
            }
            
            lineColor.setColor(style.getLinecolo());
        }else{
            setEnabled(false);
            lineColor.setColor(null);
            jspinner.setValue(0);
            buttonGroup1.clearSelection();
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        pnlLine = new javax.swing.JPanel();
        lineColor = new windows.controls.AtlasColorChooser();
        jspinner = new javax.swing.JSpinner();
        lblWidth = new javax.swing.JLabel();
        lblStyle = new javax.swing.JLabel();
        pnlLineStyles = new javax.swing.JPanel();
        jtb1 = new javax.swing.JToggleButton();
        jtb2 = new javax.swing.JToggleButton();
        jtb3 = new javax.swing.JToggleButton();
        jtb4 = new javax.swing.JToggleButton();
        jtb5 = new javax.swing.JToggleButton();
        jtb6 = new javax.swing.JToggleButton();

        setEnabled(false);

        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("windows/style/messages",LocaleUtil.getLocale()); // NOI18N
        pnlLine.setBorder(javax.swing.BorderFactory.createTitledBorder(bundle.getString("line_key"))); // NOI18N

        lineColor.setBorder(null);

        jspinner.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jspinnerStateChanged(evt);
            }
        });

        lblWidth.setText(bundle.getString("widt_key")); // NOI18N

        lblStyle.setText(bundle.getString("styl_key")); // NOI18N

        pnlLineStyles.setLayout(new java.awt.GridLayout(2, 3, 5, 5));

        buttonGroup1.add(jtb1);
        jtb1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/strokestyles/stroke1.png"))); // NOI18N
        jtb1.setMargin(new java.awt.Insets(2, 2, 2, 2));
        pnlLineStyles.add(jtb1);

        buttonGroup1.add(jtb2);
        jtb2.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/strokestyles/stroke2.png"))); // NOI18N
        jtb2.setMargin(new java.awt.Insets(2, 2, 2, 2));
        pnlLineStyles.add(jtb2);

        buttonGroup1.add(jtb3);
        jtb3.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/strokestyles/stroke3.png"))); // NOI18N
        jtb3.setMargin(new java.awt.Insets(2, 2, 2, 2));
        pnlLineStyles.add(jtb3);

        buttonGroup1.add(jtb4);
        jtb4.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/strokestyles/stroke4.png"))); // NOI18N
        jtb4.setMargin(new java.awt.Insets(2, 2, 2, 2));
        pnlLineStyles.add(jtb4);

        buttonGroup1.add(jtb5);
        jtb5.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/strokestyles/stroke5.png"))); // NOI18N
        jtb5.setMargin(new java.awt.Insets(2, 2, 2, 2));
        pnlLineStyles.add(jtb5);

        buttonGroup1.add(jtb6);
        jtb6.setMargin(new java.awt.Insets(2, 2, 2, 2));
        pnlLineStyles.add(jtb6);

        javax.swing.GroupLayout pnlLineLayout = new javax.swing.GroupLayout(pnlLine);
        pnlLine.setLayout(pnlLineLayout);
        pnlLineLayout.setHorizontalGroup(
            pnlLineLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlLineLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlLineLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(pnlLineLayout.createSequentialGroup()
                        .addComponent(lineColor, javax.swing.GroupLayout.DEFAULT_SIZE, 305, Short.MAX_VALUE)
                        .addContainerGap())
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, pnlLineLayout.createSequentialGroup()
                        .addComponent(lblStyle, javax.swing.GroupLayout.PREFERRED_SIZE, 61, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(pnlLineStyles, javax.swing.GroupLayout.DEFAULT_SIZE, 238, Short.MAX_VALUE)
                        .addGap(12, 12, 12))
                    .addGroup(pnlLineLayout.createSequentialGroup()
                        .addComponent(lblWidth)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jspinner, javax.swing.GroupLayout.PREFERRED_SIZE, 65, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap(218, Short.MAX_VALUE))))
        );
        pnlLineLayout.setVerticalGroup(
            pnlLineLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlLineLayout.createSequentialGroup()
                .addGroup(pnlLineLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(lblStyle, javax.swing.GroupLayout.DEFAULT_SIZE, 76, Short.MAX_VALUE)
                    .addComponent(pnlLineStyles, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(lineColor, javax.swing.GroupLayout.PREFERRED_SIZE, 70, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlLineLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jspinner, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(lblWidth, javax.swing.GroupLayout.PREFERRED_SIZE, 19, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(pnlLine, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(pnlLine, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        );
    }// </editor-fold>//GEN-END:initComponents
    
    private void jspinnerStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jspinnerStateChanged
        if(style!=null){
            AtlasStroke as = style.getLinestyl();
            as.setWidth(Float.parseFloat(jspinner.getValue().toString()));
            fireChangeListeners();
        }
    }//GEN-LAST:event_jspinnerStateChanged
    
    private void asignarStroke(){
        AtlasStroke as = style.getLinestyl();
        
        if(as.getWidth()==0){
            as.setWidth(1);
            jspinner.setValue(1);
        }
        
        if(jtb1.isSelected() == true){ as.setDash(null); }
        if(jtb2.isSelected() == true){ as.setDash(new float[]{4f}); }
        if(jtb3.isSelected() == true){ as.setDash(new float[]{4f,4f,12f,4f}); }
        if(jtb4.isSelected() == true){ as.setDash(new float[]{12f,4f}); }
        if(jtb5.isSelected() == true){ as.setDash(new float[]{4f,4f,12f,4f,4f,4f}); }
        if(jtb6.isSelected() == true){
            as.setDash(null);
            as.setWidth(0);
            jspinner.setValue(0);
            lineColor.setEnabled(false);
            jspinner.setEnabled(false);
            lblWidth.setEnabled(false);
        }else{
            lineColor.setEnabled(true);
            jspinner.setEnabled(true);
            lblWidth.setEnabled(true);
        }
        
        fireChangeListeners();
    }
    
    public void addStyleChangeListener(ChangeListener cl) {
        changeListeners.add(cl);
    }
    
    public void removeStyleChangeListener(ChangeListener cl) {
        changeListeners.remove(cl);
    }
    
    private void fireChangeListeners(){
        Iterator<ChangeListener> it    = changeListeners.iterator();
        ChangeEvent ev = new ChangeEvent(this);
        while(it.hasNext()){
            it.next().stateChanged(ev);
        }
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JSpinner jspinner;
    private javax.swing.JToggleButton jtb1;
    private javax.swing.JToggleButton jtb2;
    private javax.swing.JToggleButton jtb3;
    private javax.swing.JToggleButton jtb4;
    private javax.swing.JToggleButton jtb5;
    private javax.swing.JToggleButton jtb6;
    private javax.swing.JLabel lblStyle;
    private javax.swing.JLabel lblWidth;
    private windows.controls.AtlasColorChooser lineColor;
    private javax.swing.JPanel pnlLine;
    private javax.swing.JPanel pnlLineStyles;
    // End of variables declaration//GEN-END:variables
    
}
