package windows.symbology;

import com.vividsolutions.jts.geom.MultiPoint;
import com.vividsolutions.jts.geom.Point;
import org.atlas.hibernatedata.AtlasColor;
import org.atlas.hibernatedata.Icon;
import org.atlas.hibernatedata.Rule;
import org.atlas.hibernatedata.Style;
import org.atlas.hibernatedata.Symbology;
import java.awt.Font;
import org.atlas.util.ColorsList;
import org.atlas.util.HibernateUtil;
import windows.style.StyleEditor;

public class FixedRuleGenerator extends javax.swing.JPanel implements RuleGenerator {

    private Rule rule;
    private Symbology symbology;
    private HibernateUtil hibernate;
    private StyleEditor editor;
    private Icon defaultIcon;

    public FixedRuleGenerator() {
        initComponents();
    }

    private void loadInterface() {
        if (getSymbology().getTypeSymb() == Symbology.TYPE_FIXED_SYMB) {
            rule = (Rule) symbology.getRules().toArray()[0];
            editor.setStyle(rule.getStyle());
        } else {
            rule = null;
            editor.setStyle(null);
        }
    }

    public Symbology getSymbology() {
        return symbology;
    }

    public void setSymbology(Symbology symbology) {
        this.symbology = symbology;
        loadInterface();
    }

    public HibernateUtil getHibernate() {
        return hibernate;
    }

    public void setHibernate(HibernateUtil hibernate) {
        this.hibernate = hibernate;
    }

    public StyleEditor getEditor() {
        return editor;
    }

    public void setEditor(StyleEditor editor) {
        this.editor = editor;
    }

    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        btnGenerate = new javax.swing.JButton();

        btnGenerate.setText("Generate");
        btnGenerate.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnGenerateActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(btnGenerate, javax.swing.GroupLayout.PREFERRED_SIZE, 117, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(btnGenerate)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents
    public static void attachFixedSymbology(Symbology symbology, Icon defaultIcon) {
                
                
        Rule rule = new Rule();
        rule.setStyle(Style.getDefaultRandomStyle(defaultIcon));
        rule.setDescrule(symbology.getLayer().getDesclaye());        
        ColorsList colors = new ColorsList();
        AtlasColor at;

        int nc = (int) (Math.random() * 1024);

        at = new AtlasColor();
        at.setColor(colors.getColor(nc));
        rule.getStyle().setFillcolo(at);

        at = new AtlasColor();
        
        rule.getStyle().setLinecolo(at);

        Class geom = symbology.getLayer().getSource().getGeomClass();
        if (geom.equals(Point.class) || geom.equals(MultiPoint.class)) {
            rule.getStyle().getLinestyl().setWidth(Icon.DEFAULT_SIZE);
            at.setColor(ColorsList.getDarkenColor(colors.getDarkenColor(nc)));
            rule.getStyle().setLinecolo(at);
            
        }else{
            at.setColor(colors.getDarkenColor(nc));    
            rule.getStyle().setLinecolo(at);
        }
        

        symbology.getRules().clear();
        symbology.getRules().add(rule);
        symbology.setTypeSymb(Symbology.TYPE_FIXED_SYMB);

    }

    private void btnGenerateActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnGenerateActionPerformed
        FixedRuleGenerator.attachFixedSymbology(symbology, defaultIcon);
        loadInterface();
    }//GEN-LAST:event_btnGenerateActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnGenerate;
    // End of variables declaration//GEN-END:variables
    public Icon getDefaultIcon() {
        return defaultIcon;
    }

    public void setDefaultIcon(Icon defaultIcon) {
        this.defaultIcon = defaultIcon;
    }
}

