
package windows.symbology;

import org.atlas.hibernatedata.Layer;
import org.atlas.hibernatedata.Rule;
import org.atlas.hibernatedata.Symbology;
import org.atlas.i18n.LocaleUtil;
import java.sql.Connection;
import java.sql.SQLException;
import javax.swing.JFrame;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import org.hibernate.HibernateException;
import org.hibernate.classic.Session;
import org.atlas.util.HibernateUtil;
import org.atlas.util.WindowUtils;
import windows.style.PnlEditPolygonStyle;

public class FrmSymbPoly extends javax.swing.JDialog {
    
    private Layer         layer;
    private HibernateUtil hibernate;
    private Symbology     clone;
    
    public FrmSymbPoly(Layer layerp, HibernateUtil hibernate) throws Exception{
        super((JFrame)null, true);
        initComponents();
        
        classRuleGenerator1.setEditor(polygonStyle1);
        fixedRuleGenerator1.setEditor(polygonStyle2);
        rangeRuleGenerator1.setEditor(polygonStyle3);
        
        WindowUtils.setFrameIcon(this,"/media/appicon.png");
               
        layer = layerp;
        this.hibernate = hibernate;
        
        classRuleGenerator1.setHibernate(hibernate);
        rangeRuleGenerator1.setHibernate(hibernate);
        fixedRuleGenerator1.setHibernate(hibernate);
        
        Session sess   = null;        
        Connection con = null;
        try {    
            con = hibernate.getConnection();
            layer.getSource().loadFieldMetadata(con);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw ex;
        } finally {
            try {
                con.close();
            } catch (SQLException ex) {
                ex.printStackTrace();
                throw ex;
            }
        }
        
        try {
            sess = hibernate.begin();
            sess.update(layer);
            Symbology sym = layer.getSymbology();
            sess.update(sym);
            Object[] rules = sym.getRules().toArray();
            for (int i = 0; i < rules.length; i++) {
                sess.update((Rule)rules[i]);
                sess.update(((Rule)rules[i]).getStyle());
            }
            
            clone = (Symbology)layer.getSymbology().clone();
            
            tabPanel.addChangeListener(new ChangeListener(){
                public void stateChanged(ChangeEvent changeEvent) {
                    int index = tabPanel.getSelectedIndex();
                    if(index==0){
                        fixedRuleGenerator1.setSymbology(clone);
                    }else if(index==1){
                        rangeRuleGenerator1.setSymbology(clone);
                    }else if(index==2){
                        classRuleGenerator1.setSymbology(clone);
                    }
                }
            });
                        
            if(sym.getTypeSymb()==Symbology.TYPE_FIXED_SYMB){
                tabPanel.setSelectedIndex(0);
                fixedRuleGenerator1.setSymbology(clone);
            }else if(sym.getTypeSymb()==Symbology.TYPE_CLASS_SYMB){
                classRuleGenerator1.setSymbology(clone);
                tabPanel.setSelectedIndex(2);
            }else if(sym.getTypeSymb()==Symbology.TYPE_RANGE_SYMB){
                rangeRuleGenerator1.setSymbology(clone);
                tabPanel.setSelectedIndex(1);
            }   
        } catch (Exception ex) {
            ex.printStackTrace();
            throw ex;
        } finally{
            hibernate.close(sess);
        }        
    }
    
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        tabPanel = new javax.swing.JTabbedPane();
        jPanel3 = new javax.swing.JPanel();
        polygonStyle2 = new windows.style.PnlEditPolygonStyle();
        fixedRuleGenerator1 = new windows.symbology.FixedRuleGenerator();
        jPanel2 = new javax.swing.JPanel();
        rangeRuleGenerator1 = new windows.symbology.RangeRuleGenerator();
        polygonStyle3 = new windows.style.PnlEditPolygonStyle();
        jPanel1 = new javax.swing.JPanel();
        classRuleGenerator1 = new windows.symbology.ClassRuleGenerator();
        polygonStyle1 = new windows.style.PnlEditPolygonStyle();
        jPanel4 = new javax.swing.JPanel();
        btnCancel = new javax.swing.JButton();
        btnOk = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle(java.util.ResourceBundle.getBundle("windows/symbology/messages",LocaleUtil.getLocale()).getString("frm_poly"));
        setLocationByPlatform(true);
        setModal(true);
        jPanel3.setBorder(javax.swing.BorderFactory.createEmptyBorder(1, 50, 1, 50));

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(fixedRuleGenerator1, javax.swing.GroupLayout.PREFERRED_SIZE, 291, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(polygonStyle2, javax.swing.GroupLayout.DEFAULT_SIZE, 611, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addComponent(fixedRuleGenerator1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(polygonStyle2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(26, Short.MAX_VALUE))
        );
        tabPanel.addTab("Fixed", jPanel3);

        rangeRuleGenerator1.setPreferredSize(new java.awt.Dimension(339, 411));

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addComponent(rangeRuleGenerator1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(polygonStyle3, javax.swing.GroupLayout.DEFAULT_SIZE, 378, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(rangeRuleGenerator1, javax.swing.GroupLayout.DEFAULT_SIZE, 421, Short.MAX_VALUE)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGap(12, 12, 12)
                .addComponent(polygonStyle3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        tabPanel.addTab("Range", jPanel2);

        classRuleGenerator1.setPreferredSize(new java.awt.Dimension(339, 300));

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addComponent(classRuleGenerator1, javax.swing.GroupLayout.PREFERRED_SIZE, 342, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(polygonStyle1, javax.swing.GroupLayout.PREFERRED_SIZE, 375, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(12, 12, 12)
                .addComponent(polygonStyle1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(71, 71, 71))
            .addComponent(classRuleGenerator1, javax.swing.GroupLayout.DEFAULT_SIZE, 421, Short.MAX_VALUE)
        );
        tabPanel.addTab("Class", jPanel1);

        jPanel4.setLayout(new java.awt.GridLayout(1, 2, 5, 0));

        btnCancel.setText(java.util.ResourceBundle.getBundle("windows/symbology/messages",LocaleUtil.getLocale()).getString("cancel"));
        btnCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelActionPerformed(evt);
            }
        });

        jPanel4.add(btnCancel);

        btnOk.setText(java.util.ResourceBundle.getBundle("windows/symbology/messages",LocaleUtil.getLocale()).getString("Save"));
        btnOk.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnOkActionPerformed(evt);
            }
        });

        jPanel4.add(btnOk);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, 313, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(tabPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 740, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(tabPanel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btnOkActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnOkActionPerformed
        Session sess = null;
        try {
            sess = hibernate.begin();
            sess.update(layer);
            layer.getSymbology().delete(sess);
            hibernate.commit(sess);
            
            hibernate.begin(sess);
            clone.save(sess);
            layer.setSymbology(clone);
            hibernate.commit(sess);
            dispose();           
        } catch (Exception ex) {
            ex.printStackTrace();
        } finally{
            try {
                hibernate.close(sess);
            } catch (Exception ex) {
                ex.printStackTrace();
            }
        }
    }//GEN-LAST:event_btnOkActionPerformed

    private void btnCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelActionPerformed
        dispose();
    }//GEN-LAST:event_btnCancelActionPerformed
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnCancel;
    private javax.swing.JButton btnOk;
    private windows.symbology.ClassRuleGenerator classRuleGenerator1;
    private windows.symbology.FixedRuleGenerator fixedRuleGenerator1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private windows.style.PnlEditPolygonStyle polygonStyle1;
    private windows.style.PnlEditPolygonStyle polygonStyle2;
    private windows.style.PnlEditPolygonStyle polygonStyle3;
    private windows.symbology.RangeRuleGenerator rangeRuleGenerator1;
    private javax.swing.JTabbedPane tabPanel;
    // End of variables declaration//GEN-END:variables
    
}
