package windows.symbology;

import org.atlas.hibernatedata.Style;
import java.awt.Color;
import java.awt.Component;
import java.awt.SystemColor;
import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.table.TableCellRenderer;

class StyleCellRenderer implements TableCellRenderer {

    public Component getTableCellRendererComponent(JTable jTable, Object object, boolean b, boolean b0, int i, int col) {
        JLabel label = new JLabel();
        if (object != null) {
            Style styl = (Style) object;
            Color fill;
            Color stroke;
            if (styl.getFillcolo() != null) {
                fill   = styl.getFillcolo().getColor();
                stroke = styl.getLinecolo().getColor();
            } else {
                fill   = SystemColor.inactiveCaption;
                stroke = SystemColor.inactiveCaption;
            }

            if (fill == null) {
                fill = new Color(255, 255, 255);
            }
            if (stroke == null) {
                stroke = new Color(255, 255, 255);
            }
            label.setBorder(BorderFactory.createLineBorder(stroke, 3));
            label.setBackground(fill);
            label.setOpaque(true);
        }
        return label;
    }
}
