/*
 * Created on 14 de febrero de 2008, 12:43
 */
package windows.wartool;

import org.atlas.geocoding.Geocoder;
import java.io.File;
import java.net.URL;
import java.net.URLClassLoader;
import java.util.Locale;
import java.util.Vector;
import java.util.jar.Attributes.Name;
import java.util.jar.JarFile;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileFilter;
import javax.swing.table.DefaultTableModel;
import org.atlas.i18n.LocaleUtil;
import org.atlas.util.WindowUtils;
import org.atlas.util.FrmWait;
import org.atlas.util.PathGeocoder;

public class DialogGeocoder extends javax.swing.JDialog {

    private JFileChooser jfcw;
    private JFileChooser jfcg;
    private WebArchive info;    
    private DefaultTableModel tablemodel;
    private Vector listG;
    private Token token;    
       
    public DialogGeocoder(java.awt.Frame parent, boolean modal, WebArchive info) {
        super(parent, modal);
        setInfo(info);
        setLocale(Locale.US);
        listG = new Vector();
        initComponents();

        tablemodel = (DefaultTableModel) jTable.getModel();

        jfcw = new JFileChooser(new File(System.getProperty("user.dir")));
        jfcw.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        jfcw.setDialogTitle("Select directory to save war file");
        jfcw.setLocale(Locale.US);

        jfcg = new JFileChooser(new File(System.getProperty("user.dir")));
        jfcg.setDialogTitle("Select Geocoder Jar file ");
        jfcg.setLocale(Locale.US);
        jfcg.setFileFilter(new FileFilter() {

            @Override
            public boolean accept(File f) {
                if (f.getName().endsWith(".jar") || f.isDirectory()) {
                    return true;
                }
                return false;
            }

            @Override
            public String getDescription() {
                return "Jar File *.jar";
            }
        });


    }

    public WebArchive getInfo() {
        return info;
    }

    public void setInfo(WebArchive info) {
        this.info = info;
    }

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jBadd = new javax.swing.JButton();
        jBremove = new javax.swing.JButton();
        jBgenerate = new javax.swing.JButton();
        jBback = new javax.swing.JButton();
        jBexit = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTable = new javax.swing.JTable();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("windows/wartool/messages",LocaleUtil.getLocale()); // NOI18N
        setTitle(bundle.getString("file_generation")); // NOI18N

        jPanel1.setLayout(new java.awt.GridLayout(5, 1, 10, 10));

        jBadd.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/plus.png"))); // NOI18N
        jBadd.setText(bundle.getString("add")); // NOI18N
        jBadd.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBaddActionPerformed(evt);
            }
        });
        jPanel1.add(jBadd);

        jBremove.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/trash.png"))); // NOI18N
        jBremove.setText(bundle.getString("remove")); // NOI18N
        jBremove.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBremoveActionPerformed(evt);
            }
        });
        jPanel1.add(jBremove);

        jBgenerate.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/service.png"))); // NOI18N
        jBgenerate.setText(bundle.getString("generate")); // NOI18N
        jBgenerate.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBgenerateActionPerformed(evt);
            }
        });
        jPanel1.add(jBgenerate);

        jBback.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/go-previous.png"))); // NOI18N
        jBback.setText(bundle.getString("back")); // NOI18N
        jBback.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBbackActionPerformed(evt);
            }
        });
        jPanel1.add(jBback);

        jBexit.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/exit.png"))); // NOI18N
        jBexit.setText(bundle.getString("exit")); // NOI18N
        jBexit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBexitActionPerformed(evt);
            }
        });
        jPanel1.add(jBexit);

        jTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Main Class", "Description"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane1.setViewportView(jTable);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 337, Short.MAX_VALUE)
                .addGap(18, 18, 18)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 205, Short.MAX_VALUE)
                    .addComponent(jPanel1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
    private void jBgenerateActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBgenerateActionPerformed
        if (jfcw.showSaveDialog(this) == JFileChooser.APPROVE_OPTION) {
            boolean res = true;
            final String name = info.getDeploypath().substring(1, info.getDeploypath().length()) + ".war";
            final String warpath = jfcw.getSelectedFile().getAbsolutePath() + File.separator + name;
            if (new File(warpath).exists()) {
                res = WindowUtils.msgYesNo(this, "This folder already contains a file named " + name + "\nDo you want to replace the existing file?");
            }

            if (res) {
                FrmWait wait = new FrmWait() {

                    @Override
                    public void action() {
                        try {
                            
                            String the_war_file = java.util.ResourceBundle.getBundle("windows/wartool/messages",LocaleUtil.getLocale()).getString("the_war_file");
                            String has_been = java.util.ResourceBundle.getBundle("windows/wartool/messages",LocaleUtil.getLocale()).getString("has_been_succ_created");
                            
                            StringBuffer template = new StringBuffer(System.getProperty("user.dir"));
                            template.append(File.separator);
                            template.append("files");
                            template.append(File.separator);
                            info.generateWar(template.toString(), warpath, listG);
                            WindowUtils.msgInfo(this, the_war_file + name + has_been);
                        } catch (Exception ex) {
                            WindowUtils.msgError(this, "Unexpected error "+ex.getMessage());
                            Logger.getLogger(DialogGeocoder.class.getName()).log(Level.SEVERE, null, ex);
                        }
                    }
                };
                
                String creating = java.util.ResourceBundle.getBundle("windows/wartool/messages",LocaleUtil.getLocale()).getString("creating_war_file");
                
                wait.setMessage(creating);
                wait.setVisible(true);
                jfcw.setSelectedFile(null);
            }
        }    
}//GEN-LAST:event_jBgenerateActionPerformed

    private void jBbackActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBbackActionPerformed
        getToken().setState(Token.FRM_DB);
        setVisible(false);
}//GEN-LAST:event_jBbackActionPerformed

    private void jBexitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBexitActionPerformed
        String exit = java.util.ResourceBundle.getBundle("windows/wartool/messages",LocaleUtil.getLocale()).getString("leave");
        boolean res = WindowUtils.msgYesNo(this, exit);
        if (res) {
           getToken().setState(Token.EXIT);
           setVisible(false);
        }
}//GEN-LAST:event_jBexitActionPerformed

    private void jBaddActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBaddActionPerformed
        if (jfcg.showSaveDialog(this) == JFileChooser.APPROVE_OPTION) {
            try {
                File f = jfcg.getSelectedFile();
                JarFile jf = null;
                String mainClass;

                jf = new JarFile(f);
                mainClass = jf.getManifest().getMainAttributes().getValue(Name.MAIN_CLASS);
                jf.close();

                if (mainClass != null) {

                    PathGeocoder geo = new PathGeocoder(f.getName(), f.getPath(), mainClass);
                    for (int i = 0; i < tablemodel.getRowCount(); i++) {
                        if (geo.getMainClass().equals((String) tablemodel.getValueAt(i, 0))) {
                            WindowUtils.msgError(this, "Geocoder class main duplicate");
                            return;
                        }
                    }

                    URLClassLoader urlcl = new URLClassLoader(new URL[]{new URL(("file:/" + geo.getPath()))});
                    Class cl = Class.forName(geo.getMainClass(), true, urlcl);
                    Geocoder g = (Geocoder) cl.newInstance();
                    tablemodel.addRow(new String[]{geo.getMainClass(), g.getDescription()});
                    listG.add(geo);
                } else {
                    WindowUtils.msgError(this, "No class Main");
                }

            } catch (Exception ex) {
                WindowUtils.msgError(this, "Unexpected Error loading geocoder, please check or consult the guide to add plugins");
                //Logger.getLogger(DialogGeocoder.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
}//GEN-LAST:event_jBaddActionPerformed

    private void jBremoveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBremoveActionPerformed
        if (tablemodel.getRowCount() > 0) {
            int row = jTable.getSelectedRow();
            if (row >= 0) {
                String main = (String) tablemodel.getValueAt(row, 0);
                tablemodel.removeRow(row);
                for (int i = 0; i < listG.size(); i++) {
                    PathGeocoder pg = (PathGeocoder) listG.get(i);
                    if (pg.getMainClass().equals(main)) {
                        listG.remove(pg);
                    }
                }
            } else {                
                String please = java.util.ResourceBundle.getBundle("windows/wartool/messages",LocaleUtil.getLocale()).getString("select_a_row");
                WindowUtils.msgWarning(this, please);
            }
        }
    }//GEN-LAST:event_jBremoveActionPerformed

    public static void main(String[] args) {
        new DialogGeocoder(null, true, new WebArchive()).setVisible(true);
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jBadd;
    private javax.swing.JButton jBback;
    private javax.swing.JButton jBexit;
    private javax.swing.JButton jBgenerate;
    private javax.swing.JButton jBremove;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTable;
    // End of variables declaration//GEN-END:variables

    public Token getToken() {
        return token;
    }

    public void setToken(Token token) {
        this.token = token;
    }
}
