/* 
 * Created on 15 de noviembre de 2007, 11:50
 */
package windows.wartool;

import java.util.regex.Pattern;
import org.atlas.i18n.LocaleUtil;
import org.atlas.util.RegexDocument;
import org.atlas.util.WindowUtils;

public class DialogWMS extends javax.swing.JDialog {

    private WebArchive info;
    private Token token;

    public DialogWMS(java.awt.Frame parent, boolean modal, WebArchive info) {
        super(parent, modal);
        setInfo(info);
        initComponents();

        deploy.setDocument(new RegexDocument("[/A-Za-z0-9_]{1,}"));
        deploy.setText("/server");
        url.setDocument(new RegexDocument("[/A-Za-z0-9_]{1,}"));
        url.setText("/wms");
        geocoder.setDocument(new RegexDocument("[/A-Za-z0-9_]{1,}"));
        geocoder.setText("/geocoder");
        user.setDocument(new RegexDocument("[A-Za-z0-9_]{1,}"));
        user.setText("admin");
        pass.setDocument(new RegexDocument("[A-Za-z0-9]{1,}"));

        loadUrlService();
    }

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jLabel9 = new javax.swing.JLabel();
        deploy = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        url = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        geocoder = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        user = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        pass = new javax.swing.JPasswordField();
        jPanel2 = new javax.swing.JPanel();
        jButton3 = new javax.swing.JButton();
        jButton1 = new javax.swing.JButton();
        lb = new javax.swing.JLabel();
        cache = new javax.swing.JSpinner();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("windows/wartool/messages",LocaleUtil.getLocale()); // NOI18N
        setTitle(bundle.getString("service_info")); // NOI18N
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        jLabel9.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel9.setText(bundle.getString("path")); // NOI18N

        deploy.setText("/");

        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel2.setText(bundle.getString("servurl")); // NOI18N

        url.setEditable(false);
        url.setText("/wms");
        url.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                urlFocusLost(evt);
            }
        });

        jLabel8.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel8.setText(bundle.getString("geoc_url")); // NOI18N

        geocoder.setEditable(false);
        geocoder.setText("/geocoder");

        jLabel4.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel4.setText(bundle.getString("user_name")); // NOI18N

        jLabel5.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel5.setText(bundle.getString("pass_wd")); // NOI18N

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(jLabel5, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel4, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel9, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel8, javax.swing.GroupLayout.Alignment.LEADING))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(geocoder, javax.swing.GroupLayout.DEFAULT_SIZE, 402, Short.MAX_VALUE)
                    .addComponent(url, javax.swing.GroupLayout.DEFAULT_SIZE, 402, Short.MAX_VALUE)
                    .addComponent(deploy, javax.swing.GroupLayout.DEFAULT_SIZE, 402, Short.MAX_VALUE)
                    .addComponent(user, javax.swing.GroupLayout.DEFAULT_SIZE, 402, Short.MAX_VALUE)
                    .addComponent(pass, javax.swing.GroupLayout.DEFAULT_SIZE, 402, Short.MAX_VALUE)))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                .addGroup(jPanel1Layout.createSequentialGroup()
                    .addComponent(deploy, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGap(10, 10, 10)
                    .addComponent(url, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGap(10, 10, 10)
                    .addComponent(geocoder, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGap(10, 10, 10)
                    .addComponent(user, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGap(10, 10, 10)
                    .addComponent(pass, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGroup(jPanel1Layout.createSequentialGroup()
                    .addComponent(jLabel9, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGap(10, 10, 10)
                    .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGap(10, 10, 10)
                    .addComponent(jLabel8, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGap(10, 10, 10)
                    .addComponent(jLabel4, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGap(10, 10, 10)
                    .addComponent(jLabel5, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)))
        );

        jPanel2.setLayout(new java.awt.GridLayout(1, 2, 10, 10));

        jButton3.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/exit.png"))); // NOI18N
        jButton3.setText(bundle.getString("exit")); // NOI18N
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });
        jPanel2.add(jButton3);

        jButton1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/go-next.png"))); // NOI18N
        jButton1.setText(bundle.getString("next")); // NOI18N
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jPanel2.add(jButton1);

        lb.setText("Url Service  http://");

        cache.setModel(new javax.swing.SpinnerNumberModel(32, 0, 1024, 32));

        jLabel6.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel6.setText(bundle.getString("cache")); // NOI18N

        jLabel7.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel7.setText("MB");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(63, 63, 63)
                        .addComponent(lb, javax.swing.GroupLayout.PREFERRED_SIZE, 433, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jLabel6, javax.swing.GroupLayout.PREFERRED_SIZE, 117, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(10, 10, 10)
                        .addComponent(cache, javax.swing.GroupLayout.PREFERRED_SIZE, 68, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel7)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 29, Short.MAX_VALUE)
                        .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, 268, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(lb, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(11, 11, 11)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jLabel7, javax.swing.GroupLayout.DEFAULT_SIZE, 33, Short.MAX_VALUE)
                        .addComponent(cache, javax.swing.GroupLayout.PREFERRED_SIZE, 22, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(jLabel6, javax.swing.GroupLayout.PREFERRED_SIZE, 24, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
    private void urlFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_urlFocusLost
        loadUrlService();
    }//GEN-LAST:event_urlFocusLost

    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
        this.setVisible(false);
        System.exit(0);
    }//GEN-LAST:event_formWindowClosing

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        String exit = java.util.ResourceBundle.getBundle("windows/wartool/messages",LocaleUtil.getLocale()).getString("leave");
        boolean res = WindowUtils.msgYesNo(this, exit);
                
        if (res) {
            token.setState(Token.EXIT);
            setVisible(false);
        }
    }//GEN-LAST:event_jButton3ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        if (validateInfo()) {
            loadInfo();
            getToken().setState(Token.FRM_DB);
            setVisible(false);
        }        
    }//GEN-LAST:event_jButton1ActionPerformed

    private void loadUrlService() {
        String t;
        t = "Url Service  http://[Address Host:port]";
        t += deploy.getText().trim();
        this.lb.setText(t);
    }

    public WebArchive getInfo() {
        return info;
    }

    public void setInfo(WebArchive info) {
        this.info = info;
    }

    private boolean validateInfo() {

        String field;

        String ins_deploy = java.util.ResourceBundle.getBundle("windows/wartool/messages", LocaleUtil.getLocale()).getString("Write_a_deploy_path");

        field = deploy.getText().trim();
        if (field.equals("") || field.equals(ins_deploy)) {
            deploy.setText(ins_deploy);
            deploy.selectAll();
            deploy.grabFocus();
            return false;
        } else {
            if (!field.startsWith("/")) {
                field = "/" + field;
                deploy.setText(field);
                loadUrlService();
            }
            String pattern = "/[A-Za-z0-9]{1,}";
            Pattern VALID_PATTERN = Pattern.compile(pattern);
            if (!VALID_PATTERN.matcher(field).matches()) {
                url.selectAll();
                url.grabFocus();
                return false;
            }
        }


        field = url.getText().trim();

        if (!field.startsWith("/")) {
            field = "/" + field;
            url.setText(field);
            loadUrlService();
        }

        String pattern = "/[A-Za-z0-9]{1,}";
        Pattern VALID_PATTERN = Pattern.compile(pattern);
        if (!VALID_PATTERN.matcher(field).matches()) {
            url.selectAll();
            url.grabFocus();
            return false;
        }


        String ins_user = java.util.ResourceBundle.getBundle("windows/wartool/messages", LocaleUtil.getLocale()).getString("Write_a_user_name");

        field = user.getText().trim();
        if (field.equals("") || field.equals(ins_user)) {
            user.setText(ins_user);
            user.selectAll();
            user.grabFocus();
            return false;
        }

        if (pass.getPassword().length <= 0) {
            String ins_pass = java.util.ResourceBundle.getBundle("windows/wartool/messages", LocaleUtil.getLocale()).getString("ins_pass");
            WindowUtils.msgWarning(this, ins_pass);
            pass.grabFocus();
            return false;
        }

        return true;
    }

    private void loadInfo() {
        info.setDeploypath(deploy.getText().trim());
        info.setURL_WMS(url.getText().trim());
        info.setURL_GEOCODER(geocoder.getText().trim());
        info.setAppUser(user.getText().trim());
        info.setAppPass(pass.getPassword());
        info.setSizecache(((Integer) cache.getValue()).intValue());

        info.setWMSServletName("wms");
        info.setGeocoderServletName("geocoder");
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JSpinner cache;
    private javax.swing.JTextField deploy;
    private javax.swing.JTextField geocoder;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton3;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JLabel lb;
    private javax.swing.JPasswordField pass;
    private javax.swing.JTextField url;
    private javax.swing.JTextField user;
    // End of variables declaration//GEN-END:variables
    public Token getToken() {
        return token;
    }

    public void setToken(Token token) {
        this.token = token;
    }
}
