package org.atlas.desk.events;

import org.atlas.clientdata.BBox;
import org.atlas.clientdata.EpsgCRS;
import java.awt.event.ActionEvent;
import org.atlas.desk.gui.MapPanel;

/**
 * Evento disparado cuando cambia la escala o el bounding box que 
 * describe lo que se está presentando. 
 * @author Mario
 */
public class DisplayEvent extends ActionEvent{
    
    private MapPanel isource;
    private BBox     visibleBBox;
    private double   wmsScale;
    private EpsgCRS  crs;
    
    /**     
     * @param source
     * @param bbox
     * @param crs
     * @param id
     */
    public DisplayEvent(MapPanel source, BBox bbox, EpsgCRS crs, int id){
        super(source,id,"");
        this.setSource(source);
        this.setVisibleBBox(bbox);
        this.setCrs(crs);
        setWmsScale(source.getWMScale());
    }

    @Override
    public MapPanel getSource() {
        return isource;
    }
    
    private void setSource(MapPanel source) {
        this.isource = source;
    }

    /**
     * 
     * @return
     */
    public BBox getVisibleBBox() {
        return visibleBBox;
    }

    private void setVisibleBBox(BBox visibleBBox) {
        this.visibleBBox = visibleBBox;
    }

    /**
     * 
     * @return
     */
    public double getWmsScale() {
        return wmsScale;
    }
    
    private void setWmsScale(double wmsScale) {
        this.wmsScale = wmsScale;
    }

    /**
     * 
     * @return
     */
    public EpsgCRS getCrs() {
        return crs;
    }
    
    private void setCrs(EpsgCRS crs) {
        this.crs = crs;
    }
}
