package org.atlas.desk.events;


import java.awt.event.ActionEvent;
import org.atlas.desk.gui.MapPanel;

/**
 * Evento que dispara cuando el servidor responde a una petición
 * GetFeatureInfo realizada desde el MapPanel.
 * @author Mario
 */
public class FeatureInfoEvent extends ActionEvent{
    
    private MapPanel  sourceF;
    private String    featureInfo;
    private String    url;
    
    /**
     * 
     * @param source
     * @param featureInfo
     * @param url
     * @param id
     */
    public FeatureInfoEvent(MapPanel source, String featureInfo, String url, int id){
        super(source,id,"");
        this.sourceF = source;
        this.featureInfo = featureInfo;
        this.url = url;
    }    

    @Override
    public MapPanel getSource() {
        return sourceF;
    }

    /**
     * 
     * @return
     */
    public String getFeatureInfo() {
        return featureInfo;
    }

    /**
     * 
     * @return
     */
    public String getUrl() {
        return url;
    }
        
}
