package org.atlas.desk.events;

import org.atlas.geocoding.Result;
import java.awt.event.ActionEvent;
import org.atlas.desk.gui.MapPanel;

/**
 * Evento que dispara cuando el servidor responde a una petición
 * de geocodificación realizada desde el MapPanel. 
 * @author Mario
 */
public class GeocodingEvent extends ActionEvent{
    
    private MapPanel mapSource;    
    private Result[] addresses;
    private String project;
    private String request;
    
    /**
     * 
     * @param source
     * @param project
     * @param request
     * @param addresses
     */
    public GeocodingEvent(MapPanel source, String project, String request, Result[] addresses){
        super(source,-1,"");
        setMapSource(source);
        setAddresses(addresses);
        setProject(project);
        setRequest(request);
    }
 
    /**
     * 
     * @return
     */
    public MapPanel getMapSource() {
        return mapSource;
    }

    private void setMapSource(MapPanel mapSource) {
        this.mapSource = mapSource;
    }

    /**
     * 
     * @return
     */
    public Result[] getAddresses() {
        return addresses;
    }

    private void setAddresses(Result[] addresses) {
        this.addresses = addresses;
    }

    /**
     * 
     * @return
     */
    public String getProject() {
        return project;
    }

    private void setProject(String project) {
        this.project = project;
    }

    /**
     * 
     * @return
     */
    public String getRequest() {
        return request;
    }

    private void setRequest(String request) {
        this.request = request;
    }
}
