package org.atlas.desk.events;


import java.awt.event.ActionEvent;
import org.atlas.desk.gui.MapPanel;

public class HttpRequestEvent extends ActionEvent{
    
    public static final int MAP_IMAGE    = 1;
    public static final int FEATURE_INFO = 2;
    public static final int CAPABILITIES = 3;
    
    private MapPanel mapSource;
    private String   url;
    private int  statusCode;
    private long start;
    private long end;
    private int  resquestType;    
    
    public HttpRequestEvent(MapPanel source, String url, int id){
        super(source,id,"");
        this.setSource(source);
        this.setUrl(url);
    }

    @Override
    public MapPanel getSource() {
        return mapSource;
    }

    public void setSource(MapPanel source) {
        this.mapSource = source;
    }

    public String getUrl() {
        return url;
    }

    public void setUrl(String url) {
        this.url = url;
    }

    public int getStatusCode() {
        return statusCode;
    }

    public void setStatusCode(int statusCode) {
        this.statusCode = statusCode;
    }

    public long getStart() {
        return start;
    }

    public void setStart(long start) {
        this.start = start;
    }

    public long getEnd() {
        return end;
    }

    public void setEnd(long end) {
        this.end = end;
    }

    public int getResquestType() {
        return resquestType;
    }

    public void setResquestType(int resquestType) {
        this.resquestType = resquestType;
    }

    
}
