package org.atlas.desk.events;


import java.awt.event.ActionEvent;
import java.awt.geom.Point2D;
import org.atlas.desk.gui.MapPanel;

/**
 * Evento que dispara cuando usuario hace clic sobre una areá del mapa y 
 * el modo está fijado en MODEGETCOORD.
 * @author Mario
 */
public class MouseClickEvent extends ActionEvent{
    
    private Point2D screen;
    private Point2D map;
    
    /**
     * 
     * @param mapPanel
     * @param id
     * @param screen
     * @param map
     */
    public MouseClickEvent(MapPanel mapPanel, int id, Point2D screen, Point2D map){
        super(mapPanel, id, "");
        this.setMap(map);
        this.setScreen(screen);
    }

    /**
     * 
     * @return
     */
    public Point2D getScreen() {
        return screen;
    }

    private void setScreen(Point2D screen) {
        this.screen = screen;
    }

    /**
     * 
     * @return
     */
    public Point2D getMap() {
        return map;
    }

    private void setMap(Point2D map) {
        this.map = map;
    }
    
}
