package org.atlas.desk.events;


import java.awt.event.ActionEvent;
import java.awt.geom.Point2D;
import org.atlas.desk.gui.MapPanel;

/**
 * Evento disparado cuando el usuario mueve el mouse sobre el mapa.
 * @author Mario
 */
public class MouseMoveEvent extends ActionEvent{
    
    private MapPanel isource;
    private Point2D xyCoordinate;
    private Point2D ijCoordinate;
    
    /**
     * 
     * @param source
     * @param map
     * @param image
     * @param id
     */
    public MouseMoveEvent(MapPanel source, Point2D map, Point2D image, int id){
        super(source,id,"");
        setSource(source);
        setXYCoordinate(map);
        setIJCoordinate(image);
    }    

    @Override
    public MapPanel getSource() {
        return isource;
    }

    private void setSource(MapPanel source) {
        this.isource = source;
    }

    /**
     * 
     * @return
     */
    public Point2D getXYCoordinate() {
        return xyCoordinate;
    }

    private void setXYCoordinate(Point2D xyCoordinate) {
        this.xyCoordinate = xyCoordinate;
    }

    /**
     * 
     * @return
     */
    public Point2D getIJCoordinate() {
        return ijCoordinate;
    }

    private void setIJCoordinate(Point2D ijCoordinate) {
        this.ijCoordinate = ijCoordinate;
    }

}
