package org.atlas.desk.gui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.Timer;
import java.util.TimerTask;
import javax.imageio.ImageIO;

/**
 * 
 * @author Mario
 */
public class Cache {
    
    private ArrayList<Square> pending = new ArrayList<Square>();
    private ArrayList<ActionListener> imageArrivalListeners = new ArrayList<ActionListener>();
    private long interval;
    private boolean repeat;
    private Timer t = new Timer();
    Object lock = new Object();
    
    /**
     * 
     * @param al
     */
    public void addImageArrivalListener(ActionListener al){
        imageArrivalListeners.add(al);
    }
    
    /**
     * 
     * @param al
     */
    public void removeImageArrivalListener(ActionListener al){
        imageArrivalListeners.remove(al);
    }
    
    /**
     * 
     */
    public void fireImageArrivalListeners(){
        ActionEvent ae = new ActionEvent(this, -1, "");
        for (int i = 0; i < imageArrivalListeners.size(); i++) {
            imageArrivalListeners.get(i).actionPerformed(ae);
        }
    }
    
    /**
     * 
     * @param sq
     */
    public void addPending(Square sq){
        pending.add(sq);
    }
    
    private TimerTask getTask(){
        return new TimerTask(){
            public void run() {
                synchronized (lock){
                    while(pending.size()>0){
                        try {
                            URL dir = new URL(pending.get(0).getUrl());
                            System.out.println(dir);
                            HttpURLConnection con = (HttpURLConnection)dir.openConnection();
                            //con.setReadTimeout(timeout);
                            if(con.getResponseCode() == HttpURLConnection.HTTP_OK){
                                if(con.getContentType().startsWith("image/")){
                                    InputStream is = con.getInputStream();
                                    //f = File.createTempFile("atlas","temp");
                                    //f.deleteOnExit();
                                    //FileOutputStream fos = new FileOutputStream(f);
                                    //fos.write(imgbytes);
                                    //fos.close();
                                    //is.close();
                                    //t.put(square.getUrl(), f.getAbsolutePath());
                                    BufferedImage img = ImageIO.read(is);
                                    pending.get(0).setImg(img);
                                    //square.setImg();
                                    //error = false;
                                }
                            }
                            pending.remove(0);
                        } catch (MalformedURLException ex) {
                            ex.printStackTrace();
                        } catch (IOException ex) {
                            ex.printStackTrace();
                        }
                        fireImageArrivalListeners();
                    }
                    
                    if(repeat){
                        Timer t = new Timer();
                        t.schedule(getTask(), interval);
                    }
                }
            }
        };
    }
    
    /**
     * 
     * @param interval
     * @param repeat
     */
    public void activate(long interval, boolean repeat){
        synchronized(lock){
            this.repeat   = repeat;
            this.interval = interval;
            t.cancel();
            t = new Timer();
            t.schedule(getTask(), interval);
        }
    }
    
    /**
     * 
     */
    public void deactivate(){
        this.repeat = false;
    }
    
    
    /*
    private final Hashtable t       = new Hashtable();
    private int             retries   = 6;
    private int             timeout = 5000;
    private int             delay   = 2000;
     
    private Buffer buffer;
     
    public Cache(Buffer buffer) {
        this.buffer = buffer;
    }
     
    public void clear(){
        t.clear();
    }
     
    public void getImage(final Square square) throws Exception{
        File f = null;
        Object r = t.get(square.getUrl());
        if(r!=null){
            try {
                f = new File((String)r);
                FileInputStream fis = new FileInputStream(f);
                square.setImg(ImageIO.read(fis));
                fis.close();
            } catch (Exception ex) {
                ex.printStackTrace();
                return;
            }
        }else{
            boolean error = true;
            int tries     = 0;
            do{
                tries++;
                if(tries>1){
                    try {
                        Thread.sleep(delay);
                    } catch (InterruptedException ex) {
                        ex.printStackTrace();
                    }
                }
                HttpRequestEvent ev = new HttpRequestEvent(this.buffer.getMapPanel(), square.getUrl(), -1);
                ev.setStart(System.currentTimeMillis());
                ev.setResquestType(HttpRequestEvent.MAP_IMAGE);
                try {
                    URL dir = new URL(square.getUrl());
                    HttpURLConnection con = (HttpURLConnection)dir.openConnection();
                    //con.setReadTimeout(timeout);
                    int status = con.getResponseCode();
                    ev.setStatusCode(status);
                    if(status == con.HTTP_OK){
                        if(con.getContentType().startsWith("image/")){
                            InputStream is = con.getInputStream();
                            f = File.createTempFile("atlas","temp");
                            f.deleteOnExit();
                            FileOutputStream fos = new FileOutputStream(f);
                            byte[] imgbytes = IOUtils.readFromStream(is);
                            fos.write(imgbytes);
                            fos.close();
                            is.close();
                            t.put(square.getUrl(), f.getAbsolutePath());
                            square.setImg(ImageIO.read(new ByteArrayInputStream(imgbytes)));
                            error = false;
                        }
                    }
                } catch (MalformedURLException ex) {
                    ex.printStackTrace();
                } catch (FileNotFoundException ex) {
                    ex.printStackTrace();
                } catch (IOException ex) {
                    ex.printStackTrace();
                } finally {
                    ev.setEnd(System.currentTimeMillis());
                    buffer.getMapPanel().getEventManager().fireHttpRequestEvent(ev);
                }
            }while(error&&tries<retries);
        }
    }*/
}
