/*
 * Created on 3 de diciembre de 2007, 03:10 PM
 */

package org.atlas.desk.viewers;

import org.atlas.i18n.LocaleUtil;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.List;
import javax.swing.JFileChooser;
import javax.swing.JTree;
import javax.swing.table.DefaultTableModel;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreeSelectionModel;
import org.jdom.Document;
import org.jdom.Element;
import org.jdom.JDOMException;
import org.jdom.input.SAXBuilder;
import org.atlas.util.IOUtils;
import org.atlas.util.WindowUtils;

/**
 *
 * @author  karfart
 */
public class GMLViewer extends javax.swing.JDialog {
    
    
    private DefaultMutableTreeNode root = new DefaultMutableTreeNode(new DataTree("FeatureCollection",""));
    private DefaultTreeModel treeModel = new DefaultTreeModel(root);
    
    private String url;
    private String GML;
    
    public GMLViewer(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        GMLTree.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
    }
    
    public void getChields(DefaultMutableTreeNode parentTree, Element parentElement){
        List childs = parentElement.getChildren();
        for (int i = 0; i < parentElement.getChildren().size(); i++) {
            Element elementChild = ((Element)childs.get(i));
            String content = elementChild.getText().trim();
            DefaultMutableTreeNode chield = new DefaultMutableTreeNode(new DataTree(elementChild.getName() , content));
            parentTree.add(chield);
            
            if( elementChild.getChildren().size() > 0 ){
                getChields(chield, elementChild );
            }
        }
    }
    
    public String  getUrlGML() {
        return url;
    }
    
    public void setUrlGML(String url) {
        this.url = url;        
        root.removeAllChildren();        
        DefaultTableModel tablemodel = (DefaultTableModel)TableContent.getModel();
        for (int i = 0; i < tablemodel.getRowCount(); i++) {
            tablemodel.removeRow(i);
            i--;
        }
        ListContent.setListData(new String[]{""});
                
        try {
            
            byte[] b = IOUtils.readFromURL(url);
            ByteArrayInputStream ba = new ByteArrayInputStream(b);
            GML = new String(b);
            
            SAXBuilder builder = new SAXBuilder();
            
            Document doc = builder.build(ba);
            getChields(root, doc.getRootElement());
            treeModel.reload();
            ba.close();
            
        } catch (JDOMException ex) {
            ex.printStackTrace();
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        GMLTree = new JTree(treeModel);
        jPanel3 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        TableContent = new javax.swing.JTable();
        jPanel2 = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jScrollPane3 = new javax.swing.JScrollPane();
        ListContent = new javax.swing.JList();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("null");

        jPanel1.setLayout(new java.awt.GridLayout(1, 2, 10, 10));

        GMLTree.addTreeSelectionListener(new javax.swing.event.TreeSelectionListener() {
            public void valueChanged(javax.swing.event.TreeSelectionEvent evt) {
                GMLTreeValueChanged(evt);
            }
        });
        jScrollPane1.setViewportView(GMLTree);

        jPanel1.add(jScrollPane1);

        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("org/atlas/desk/viewers/messages"); // NOI18N
        jLabel1.setText(bundle.getString("metadata_key")); // NOI18N

        jScrollPane2.setBorder(null);

        TableContent.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Coordinate X", "Coordinate Y"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane2.setViewportView(TableContent);

        jPanel2.setLayout(new java.awt.GridLayout(1, 0, 5, 0));

        jButton1.setText(bundle.getString("close_key")); // NOI18N
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jPanel2.add(jButton1);

        jButton2.setText(bundle.getString("save_key")); // NOI18N
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });
        jPanel2.add(jButton2);

        jScrollPane3.setViewportView(ListContent);

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, 317, Short.MAX_VALUE)
            .addComponent(jPanel2, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 317, Short.MAX_VALUE)
            .addComponent(jScrollPane3, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 317, Short.MAX_VALUE)
            .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 317, Short.MAX_VALUE)
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 205, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, 73, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        jPanel1.add(jPanel3);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, 645, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, 333, Short.MAX_VALUE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        
        JFileChooser fc = new JFileChooser();
        fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        
        if(fc.showSaveDialog(this) == JFileChooser.APPROVE_OPTION){
            
            final String nameFile = fc.getSelectedFile().getAbsolutePath() + "/feature_info.xml";
            boolean res = true;
            System.out.println(nameFile);
            boolean exists = new File(nameFile).exists();
            if(exists){
                res =  WindowUtils.msgYesNo(this, LocaleUtil.getString("org/atlas/desk/viewers/messages","overwrite_key") );
            }
            
            if(res){
                File file = new File(nameFile);
                try {
                    FileOutputStream fos = new FileOutputStream(file);
                    fos.write(GML.getBytes());
                    fos.close();
                    
                    WindowUtils.msgInfo(this,LocaleUtil.getString("viewers/messages","oksave_key"));
                    
                } catch (FileNotFoundException ex) {
                    ex.printStackTrace();
                } catch (IOException ex) {
                    ex.printStackTrace();
                }
            }
        }
    }//GEN-LAST:event_jButton2ActionPerformed
    
    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        this.setVisible(false);
    }//GEN-LAST:event_jButton1ActionPerformed
    
    private void GMLTreeValueChanged(javax.swing.event.TreeSelectionEvent evt) {//GEN-FIRST:event_GMLTreeValueChanged
        DefaultMutableTreeNode node = (DefaultMutableTreeNode)GMLTree.getLastSelectedPathComponent();
        if (node == null) return;
        DataTree data = (DataTree)node.getUserObject();
        
        DefaultTableModel tablemodel = (DefaultTableModel)TableContent.getModel();
        for (int i = 0; i < tablemodel.getRowCount(); i++) {
            tablemodel.removeRow(i);
            i--;
        }
        
        String content = "";
        if (node.isLeaf()) {
            content = data.getContent();
            if(data.getLabel().equals("coordinates")){
                ListContent.setListData(new String[]{""});
                String[] point = content.split(" ");
                for (int i = 0; i < point.length; i++) {
                    String[] coordinate = point[i].split(",");
                    tablemodel.addRow(coordinate);
                }
            }else{
                ListContent.setListData(new String[]{content});
            }
        }else{
            ListContent.setListData(new String[]{""});
        }
    }//GEN-LAST:event_GMLTreeValueChanged
    
    private class DataTree{
        
        private String label;
        private String content;
        
        public DataTree(String label, String content){
            setLabel(label);
            setContent(content);
        }
        
        public String getLabel() {
            return label;
        }
        
        public void setLabel(String label) {
            this.label = label;
        }
        
        public String getContent() {
            return content;
        }
        
        public void setContent(String content) {
            this.content = content;
        }
        
        public String toString() {
            return getLabel();
        }
    }
    
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTree GMLTree;
    private javax.swing.JList ListContent;
    private javax.swing.JTable TableContent;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    // End of variables declaration//GEN-END:variables
    
}
