package org.atlas.exceptions;

import java.io.IOException;
import java.net.HttpURLConnection;
import org.atlas.util.IOUtils;

public class HTTPRequestException extends Exception{
    
    private int statusCode;
    private String   message;
    private String   document;
    
    public HTTPRequestException(HttpURLConnection con){
        try {
            statusCode = con.getResponseCode();
        } catch (IOException ex) {
            ex.printStackTrace();
            statusCode = -1;
        }
        
        try {
            document = new String(IOUtils.readFromStream(con.getErrorStream()));
        } catch (IOException ex) {
            document = null;
        }
        try {
            message = con.getResponseMessage();
        } catch (IOException ex) {
            ex.printStackTrace();
            message = null;
        }
    }

    public int getStatusCode() {
        return statusCode;
    }

    public String getMessage() {
        return message;
    }

    public String getDocument() {
        return document;
    }
    
}