/*
 * Created on 7 de febrero de 2008, 11:51 AM
 */
package org.atlas.hibernatedata;

import org.hibernate.Session;

/**
 * Representa la configuración de un geocoder para un proyecto en particular. El contenido de la
 * cadena configuratión depende el desarrollador del plugin de geocoder.
 * @author Mario
 */
public class GeocoderConfig{

    private int codegeoc;
    private String classname;
    private String configuration;
    private Project project;
    
    /**
     * Contruye un objeto sin valores
     */
    public GeocoderConfig() {
    }

    /**
     * Proyecto al que pertence esta configuración
     * @return
     */
    public Project getProject() {
        return project;
    }

    /**
     * Proyecto al que pertence esta configuración 
     * @param project
     */
    public void setProject(Project project) {
        this.project = project;
    }

    /**
     * Código del objeto en el sistema de persistencia 
     * @return
     */
    public int getCodegeoc() {
        return codegeoc;
    }

    /**
     * Código del objeto en el sistema de persistencia  
     * @param codegeoc
     */
    public void setCodegeoc(int codegeoc) {
        this.codegeoc = codegeoc;
    }

    /**
     * Nombre de la clase principal de geocoder
     * @return
     */
    public String getClassname() {
        return classname;
    }

    /**
     * Nombre de la clase principal de geocoder 
     * @param classname
     */
    public void setClassname(String classname) {
        this.classname = classname;
    }

    /**
     * Cadena de configuración del geocoder
     * @return
     */
    public String getConfiguration() {
        return configuration;
    }

    /**
     * Cadena de configuración del geocoder 
     * @param configuration
     */
    public void setConfiguration(String configuration) {
        this.configuration = configuration;
    }
    
    /**
     * Envia este objeto al almacenamiento persistente
     * @param sess
     * @throws java.lang.Exception
     */
    public void save(Session sess) throws Exception{
        sess.save(this);
    }
    
    /**
     * Remueve este objeto del almacenamiento persistente 
     * @param sess
     * @throws java.lang.Exception
     */
    public void delete(Session sess) throws Exception{
        sess.delete(this);
    }
    
}
