/*
 * Created on 27 de mayo de 2007, 10:59 AM
 */

package org.atlas.hibernatedata;

import org.geotools.referencing.CRS;
import org.opengis.referencing.crs.CoordinateReferenceSystem;

/**
 * Sistema de refencia espacial según el EPSG
 * @author Mario
 */
public class Spatial_ref_sys {
    
    private int srid;
    private String srtext;
        
    /**
     * Construye un objeto sin valores
     */
    public Spatial_ref_sys() {
    }
    
    /**
     * Código del sistema espacial de referencia según el EPSG
     * @return
     */
    public int getSrid() {
        return srid;
    }
    
    /**
     * Código del sistema espacial de referencia según el EPSG 
     * @param srid
     */
    public void setSrid(int srid) {
        this.srid = srid;
    }
    
    /**
     * Descripción WKT del sistema espacial de referencia según el EPSG
     * @return
     */
    public String getSrtext() {
        return srtext;
    }
    
    /**
     * Descripción WKT del sistema espacial de referencia según el EPSG 
     * @param srtext
     */
    public void setSrtext(String srtext) {
        this.srtext = srtext;
    }
    
    /**
     * Retorna un CoordinateReferenceSystem con base en este objeto
     * @return
     * @throws java.lang.Exception
     */
    public CoordinateReferenceSystem getCRS() throws Exception{
        return CRS.parseWKT(this.getSrtext());
    }
}
