package org.atlas.service;

import com.vividsolutions.jts.geom.Envelope;
import java.awt.geom.Point2D;
import org.jfree.ui.TextAnchor;

public class Label {
    private String text;
    private double angle;
    private TextAnchor anchor1;
    private TextAnchor anchor2;
    private Point2D basePoint;
    private Envelope envolope;
    private boolean active = true;
    
    public Label(String text, double angle, TextAnchor anchor1, TextAnchor anchor2, Point2D basePoint, Envelope envolope){
        setText(text);
        setAngle(angle);
        setAnchor1(anchor1);
        setAnchor2(anchor2);
        setBasePoint(basePoint);
        setEnvolope(envolope);
    }

    public String getText() {
        return text;
    }

    public void setText(String text) {
        this.text = text;
    }

    public double getAngle() {
        return angle;
    }

    public void setAngle(double angle) {
        this.angle = angle;
    }

    public TextAnchor getAnchor1() {
        return anchor1;
    }

    public void setAnchor1(TextAnchor anchor1) {
        this.anchor1 = anchor1;
    }

    public TextAnchor getAnchor2() {
        return anchor2;
    }

    public void setAnchor2(TextAnchor anchor2) {
        this.anchor2 = anchor2;
    }

    public Point2D getBasePoint() {
        return basePoint;
    }

    public void setBasePoint(Point2D basePoint) {
        this.basePoint = basePoint;
    }

    public Envelope getEnvolope() {
        return envolope;
    }

    public void setEnvolope(Envelope envolope) {
        this.envolope = envolope;
    }

    public boolean isActive() {
        return active;
    }

    public void setActive(boolean active) {
        this.active = active;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        
        if (getClass() != obj.getClass()) {
            return false;
        }
        
        final Label other = (Label) obj;
        
        if (!this.text.equals(other.text)  && (this.text == null || !this.text.equals(other.text))) {
            return false;
        }
        if (this.basePoint != other.basePoint && (this.basePoint == null || !this.basePoint.equals(other.basePoint))) {
            return false;
        }
        return true;
    }

    @Override
    public int hashCode() {
        int hash = 5;
        return hash;
    }
    
    
    
}
