/*
 * ConnectionProperties.java
 * Created on 1 de mayo de 2007, 10:17 AM
 */

package org.atlas.util;

/**
 * @author Mario R Eraso
 */

public class ConnectionProperties {
    
    private String name;
    private String driver;
    private String host;
    private String port;
    private String data;
    private String user;
    private String pass;
        
    public static final String DRIVER_MYSQL_5_0_6  = "com.mysql.jdbc.Driver";
    public static final String DRIVER_POSTGRES_8_2 = "org.postgresql.Driver";
    
    public ConnectionProperties(){
    }
    
    public ConnectionProperties(String driver,  String host,  String port,  String data,  String user,  String pass){
        setDriver(driver);
        setHost(host);
        setPort(port);
        setData(data);
        setUser(user);
        setPass(pass);
    }
    
    public String getURL(){
        if(getDriver().equals(ConnectionPropertiesHb.DRIVER_POSTGRES_8_2)){
            if(getPort().equals(""))setPort("5432");
            return "jdbc:postgresql://"+getHost()+":"+getPort()+"/"+getData();
        } else if(getDriver().equals(ConnectionPropertiesHb.DRIVER_MYSQL_5_0_6)){
            if(getPort().equals(""))setPort("3306");
            return "jdbc:mysql://"+getHost()+":"+getPort()+"/"+getData();
        }
        return null;
    }
    
    public String getDriver() {
        return driver;
    }
    
    public void setDriver(String driver) {
        this.driver = driver;
    }
    
    public String getHost() {
        return host;
    }
    
    public void setHost(String host) {
        this.host = host;
    }
    
    public String getPort() {
        return port;
    }
    
    public void setPort(String port) {
        this.port = port;
    }
    
    public String getData() {
        return data;
    }
    
    public void setData(String data) {
        this.data = data;
    }
    
    public String getUser() {
        return user;
    }
    
    public void setUser(String user) {
        this.user = user;
    }
    
    public String getPass() {
        return pass;
    }
    
    public void setPass(String pass) {
        this.pass = pass;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }
    
    @Override
    public String toString(){
        return getName();
    }

    public boolean equalParams(ConnectionPropertiesHb cp) {
        if(!cp.getData().equals(this.getData()))return false;
        if(!cp.getDriver().equals(this.getDriver()))return false;
        if(!cp.getHost().equals(this.getHost()))return false;
        if(!cp.getName().equals(this.getName()))return false;
        if(!cp.getPass().equals(this.getPass()))return false;
        if(!cp.getPort().equals(this.getPort()))return false;
        if(!cp.getURL().equals(this.getURL()))return false;
        if(!cp.getUser().equals(this.getUser()))return false;
        return true;
    }
}