package org.atlas.util;

import com.vividsolutions.jts.io.ByteOrderValues;
import com.vividsolutions.jts.io.WKBConstants;

public class EWKB {

    public static byte[] WKTtoEWKT(byte[] wkb, int srid) {
        byte[] ewkb = new byte[wkb.length+4];
        ewkb[0] = wkb[0];
        System.arraycopy(wkb, 5, ewkb, 9, wkb.length-5);
                
        int  order     = ByteOrderValues.BIG_ENDIAN;
        if (wkb[0] == WKBConstants.wkbNDR) {
            order = ByteOrderValues.LITTLE_ENDIAN;
        }
        
        byte[] b4 = new byte[4];
        System.arraycopy(wkb, 1, b4, 0, 4);
        int type = ByteOrderValues.getInt(b4, order);
        type = type | 0x20000000;
        ByteOrderValues.putInt(type, b4, order);
        System.arraycopy(b4,0,ewkb,1,4);
        ByteOrderValues.putInt(srid, b4, order);
        System.arraycopy(b4,0,ewkb,5,4);
        return ewkb;
    }
}
