/*
 * Created on 30 de mayo de 2007, 04:32 PM
 */

package org.atlas.util;

import java.awt.Frame;
import org.atlas.i18n.LocaleUtil;
import org.atlas.util.WindowUtils;

public abstract class FrmWait extends javax.swing.JDialog{
    
    public FrmWait() {
        super((Frame)null, true);
        initComponents();
        WindowUtils.center(this);
        WindowUtils.setFrameIcon(this, "/media/appicon.png");
    }

    public boolean isIndeterminate() {
        return this.prog.isIndeterminate();
    }

    public void setIndeterminate(boolean indeterminate) {
        this.prog.setIndeterminate(indeterminate);
    }

    public int getMax() {
        return this.prog.getMaximum();
    }

    public void setMax(int max) {
        this.prog.setMaximum(max);
    }

    public int getMin() {
        return this.prog.getMinimum();
    }

    public void setMin(int min) {
        this.prog.setMinimum(min);
    }

    public int getValue() {
        return this.prog.getValue();
    }

    public void setValue(int value) {
        this.prog.setValue(value);
    }

    public String getMessage() {
        return this.lblMsg.getText();
    }

    public void setMessage(String message) {
        this.lblMsg.setText(message);
    }
    
    public abstract void action();
           
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        prog = new javax.swing.JProgressBar();
        jLabel1 = new javax.swing.JLabel();
        lblMsg = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("org/atlas/util/messages",LocaleUtil.getLocale()); // NOI18N
        setTitle(bundle.getString("tit_wait")); // NOI18N
        setModal(true);
        setResizable(false);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowActivated(java.awt.event.WindowEvent evt) {
                formWindowActivated(evt);
            }
            public void windowOpened(java.awt.event.WindowEvent evt) {
                formWindowOpened(evt);
            }
        });

        prog.setIndeterminate(true);

        java.util.ResourceBundle bundle1 = java.util.ResourceBundle.getBundle("org/atlas/util/messages"); // NOI18N
        lblMsg.setText(bundle1.getString("wait")); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(lblMsg, javax.swing.GroupLayout.DEFAULT_SIZE, 300, Short.MAX_VALUE)
                    .addComponent(prog, javax.swing.GroupLayout.DEFAULT_SIZE, 300, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel1)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 73, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addComponent(prog, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(lblMsg, javax.swing.GroupLayout.PREFERRED_SIZE, 53, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void formWindowOpened(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowOpened
        
        Thread t = new Thread(new Runnable(){
            public void run() {
                action();
                dispose();
            }
        });
        t.start();
    }//GEN-LAST:event_formWindowOpened
        
    private void formWindowActivated(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowActivated
        
      
    }//GEN-LAST:event_formWindowActivated
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel lblMsg;
    private javax.swing.JProgressBar prog;
    // End of variables declaration//GEN-END:variables
    
}
