package org.atlas.util;

import org.atlas.geocoding.Geocoder;
import java.io.File;
import java.util.ArrayList;
import java.util.jar.Attributes.Name;
import java.util.logging.Level;
import java.util.logging.Logger;

public class Plugins {

    public static Geocoder[] getInstalledPlugins() {

        ArrayList<Geocoder> list = new ArrayList<Geocoder>();

        File dir = new File(Configuration.getWorkingDirectory() + "plugins" + File.separator);
        if (!dir.exists()) {
            return null;
        }

        File[] plugs = dir.listFiles();
        for (int i = 0; i < plugs.length; i++) {
            try {
                File jfile = plugs[i];
                java.util.jar.JarFile jf = new java.util.jar.JarFile(jfile);
                String classname = jf.getManifest().getMainAttributes().getValue(Name.MAIN_CLASS);
                Class cl = Class.forName(classname);
                Geocoder g = (Geocoder) cl.newInstance();
                list.add(g);
            } catch (Exception ex) {
                Logger.getLogger(Plugins.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
        Geocoder[] rta = new Geocoder[list.size()];
        list.toArray(rta);
        return rta;
    }
}
