/*
 * Created on 30 de abril de 2007, 04:33 PM
 */
package org.atlas.util;

import org.atlas.i18n.LocaleUtil;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.Window;
import java.util.Arrays;
import javax.swing.DefaultListModel;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;
import javax.swing.ListModel;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;

public class WindowUtils {

    public WindowUtils() {
    }

    public static void center(Window w) {
        Toolkit toolkit = Toolkit.getDefaultToolkit();
        Dimension screenSize = toolkit.getScreenSize();
        int x = (screenSize.width - w.getWidth()) / 2;
        int y = (screenSize.height - w.getHeight()) / 2;
        w.setLocation(x, y);
    }

    public static void SystemLookAndFeel() {
        //try {

        //UIManager.setLookAndFeel("com.sun.java.swing.plaf.gtk.GTKLookAndFeel");
        //UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        System.out.println("System Look and Feel");
        System.out.println(UIManager.getSystemLookAndFeelClassName());
        System.out.println(UIManager.getInstalledLookAndFeels().length);
        System.out.println(UIManager.getInstalledLookAndFeels()[0]);
        System.out.println(UIManager.getInstalledLookAndFeels()[1]);
        System.out.println(UIManager.getInstalledLookAndFeels()[2]);
    /*  } catch (UnsupportedLookAndFeelException e) {
    e.printStackTrace();
    System.out.println(e.getMessage());
    } catch (ClassNotFoundException e) {
    e.printStackTrace();
    System.out.println(e.getMessage());
    } catch (InstantiationException e) {
    e.printStackTrace();
    System.out.println(e.getMessage());
    } catch (IllegalAccessException e) {
    e.printStackTrace();
    System.out.println(e.getMessage());
    }*/
    }

    public static void metalLookAndFeel() {
        try {
            UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
        } catch (UnsupportedLookAndFeelException e) {
            e.printStackTrace();
            System.out.println(e.getMessage());
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
            System.out.println(e.getMessage());
        } catch (InstantiationException e) {
            e.printStackTrace();
            System.out.println(e.getMessage());
        } catch (IllegalAccessException e) {
            e.printStackTrace();
            System.out.println(e.getMessage());
        }
    }

    public static void setFrameIcon(Window w, String classpath) {
        w.setIconImage(new ImageIcon(w.getClass().getResource(classpath)).getImage());
    }

    public static void setPanelEnabled(Container panel, boolean enabled) {
        Component[] comps = panel.getComponents();
        for (int i = 0; i < comps.length; i++) {
            comps[i].setEnabled(enabled);
        }
        panel.setEnabled(enabled);
    }

    public static void setPanelChildrenEnabled(Container panel, boolean enabled) {
        Component[] comps = panel.getComponents();
        for (int i = 0; i < comps.length; i++) {
            comps[i].setEnabled(enabled);
        }
    }

    public static void msgError(Component parent, String msg) {
        JOptionPane.setDefaultLocale(LocaleUtil.getLocale());
        JOptionPane.showMessageDialog(parent, msg, java.util.ResourceBundle.getBundle("org/atlas/util/messages", LocaleUtil.getLocale()).getString("error"), JOptionPane.ERROR_MESSAGE);

    }

    public static void msgInfo(Component parent, String msg) {
        JOptionPane.setDefaultLocale(LocaleUtil.getLocale());
        JOptionPane.showMessageDialog(parent, msg, java.util.ResourceBundle.getBundle("org/atlas/util/messages", LocaleUtil.getLocale()).getString("info"), JOptionPane.INFORMATION_MESSAGE);
    }
    
    public static void msgWarning(Component parent, String msg) {
        JOptionPane.setDefaultLocale(LocaleUtil.getLocale());
        JOptionPane.showMessageDialog(parent, msg, java.util.ResourceBundle.getBundle("org/atlas/util/messages", LocaleUtil.getLocale()).getString("warning"), JOptionPane.WARNING_MESSAGE);
    }

    public static boolean msgYesNo(Component parent, String msg) {
        JOptionPane.setDefaultLocale(LocaleUtil.getLocale());
        int res = JOptionPane.showConfirmDialog(parent, msg, java.util.ResourceBundle.getBundle("org/atlas/util/messages", LocaleUtil.getLocale()).getString("question"), JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
        if (res == JOptionPane.YES_OPTION) {
            return true;
        }
        return false;
    }

    public static ListModel getListModel(String items, String delimiter) {
        DefaultListModel listModel = new DefaultListModel();
        if (items != null) {
            String[] listitems = items.split(delimiter);
            for (int i = 0; i < listitems.length; i++) {
                listModel.addElement(listitems[i]);
            }
        }
        return listModel;
    }

    public static String getItemsString(ListModel listModel, String delimiter) {
        String itemstring = "";
        int i = 0;
        for (i = 0; i < listModel.getSize() - 1; i++) {
            itemstring += listModel.getElementAt(i) + delimiter;
        }
        itemstring += listModel.getElementAt(i);
        return itemstring;
    }

    public static void sortListModel(ListModel listModel) {
        Object[] listSort = ((DefaultListModel) listModel).toArray();
        Arrays.sort(listSort);
        ((DefaultListModel) listModel).clear();

        for (int i = 0; i < listSort.length; i++) {
            ((DefaultListModel) listModel).addElement(listSort[i]);
        }
    }
}
