package demo;

import java.io.IOException;
import java.util.Vector;
import javax.microedition.io.Connector;
import javax.microedition.io.HttpConnection;
import javax.microedition.lcdui.Image;
import org.atlas.mobile.mashup.Marker;
import org.atlas.mobile.util.IO;
import org.atlas.mobile.util.Network;
import org.atlas.mobile.util.Point;

public class TextMarker extends Marker {


    private String label;
    
        
    public TextMarker(Point coordinate, Image defaultImage, Image selectedImage) {
        super(coordinate, defaultImage, selectedImage);
    }

    public TextMarker(Point coordinate, Image defaultImage) {
        super(coordinate, defaultImage, defaultImage);
    }

    public String getLabel() {
        return label;
    }

    public void setLabel(String label) {
        this.label = label;
    }

    public boolean save(String url) throws IOException {
        StringBuffer request = new StringBuffer(url);
        request.append("?code=save&px=");
        request.append(this.getCoordinate().getX());
        request.append("&py=");
        request.append(this.getCoordinate().getY());
        request.append("&label=");
        request.append(Network.urlEncode(this.getLabel()));

        HttpConnection con = (HttpConnection) Connector.open(request.toString());
        if (con.getResponseCode() == HttpConnection.HTTP_OK) {
            return true;
        }

        return false;
    }

    public static Vector load(String url, Image defaultImage, Image selectImage) {
        try {

            StringBuffer request = new StringBuffer(url);
            request.append("?code=load");
            byte[] bytes = IO.readFromURL(request.toString());
            Vector res = new Vector();
            Vector rmar = Util.split(new String(bytes), ',');

            for (int i = 0; i < rmar.size(); i++) {
                Vector cmar = Util.split((String) rmar.elementAt(i), '|');
                double x = Double.parseDouble((String) cmar.elementAt(0));
                double y = Double.parseDouble((String) cmar.elementAt(1));
                TextMarker mar = new TextMarker(new Point(x, y), defaultImage, selectImage);
                mar.setLabel((String) cmar.elementAt(2));
                res.addElement(mar);
            }
            return res;
        } catch (IOException ex) {
            return null;
        }
    }

    
}
