/*
 * Created on 6 de agosto de 2007, 06:33 PM
 */
package org.atlas.mobile.data;

import java.io.IOException;
import java.io.InputStreamReader;
import java.io.Reader;
import javax.microedition.io.Connector;
import javax.microedition.io.HttpConnection;
import org.kxml.kdom.Document;
import org.kxml.kdom.Element;
import org.kxml.parser.XmlParser;

public class CRS {

    public static final int UNIT_LINEAR = 1;
    public static final int UNIT_ANGULAR = 2;
    private String code;
    private String name;
    private String axis1;
    private String axis2;
    private int type;
    private double conversionFactor;
    private String unitName;

    public CRS(String code, String urlService) throws IOException{
        
        if(code.startsWith("EPSG:")){
            code = code.substring("EPSG:".length(), code.length());
        }
        
        String crsURL = urlService + "?request=GetEPSGCodeInfo&epsg_code=" + code;        

        HttpConnection con = (HttpConnection) Connector.open(crsURL);
        Reader reader = new InputStreamReader(con.openInputStream());
        XmlParser parser = new XmlParser(reader);

        Document doc = new Document();
        doc.parse(parser);        
        Element crs = doc.getRootElement();
        
        setCode(crs.getAttribute("id").getValue());
        setName(crs.getAttribute("name").getValue());
        setAxis1(crs.getElement("axis1").getAttribute("name").getValue());
        setAxis2(crs.getElement("axis2").getAttribute("name").getValue());
        setUnitName(crs.getElement("unit").getAttribute("name").getValue());
        setConversionFactor(Double.parseDouble(crs.getElement("unit").getAttribute("factor").getValue()));
        if (crs.getElement("unit").getAttribute("type").getValue().equals("linear")) {
            setType(CRS.UNIT_LINEAR);
        } else {
            setType(CRS.UNIT_ANGULAR);
        }
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getAxis1() {
        return axis1;
    }

    public void setAxis1(String axis1) {
        this.axis1 = axis1;
    }

    public String getAxis2() {
        return axis2;
    }

    public void setAxis2(String axis2) {
        this.axis2 = axis2;
    }

    public int getType() {
        return type;
    }

    public void setType(int type) {
        this.type = type;
    }

    public double getConversionFactor() {
        return conversionFactor;
    }

    public void setConversionFactor(double conversionFactor) {
        this.conversionFactor = conversionFactor;
    }

    public String getUnitName() {
        return unitName;
    }

    public void setUnitName(String unitName) {
        this.unitName = unitName;
    }
}
