/*
 * Created on 6 de agosto de 2007, 05:40 PM
 */
package org.atlas.mobile.data;

import org.atlas.mobile.data.BBox;
import java.util.Vector;
import org.kxml.kdom.Element;

public class Layer {

    private String name;
    private String title;
    private String summary;
    private Vector keywordList; 
    private CRS CRS;
    private Ex_BoundingBox exBoundingBox;
    private BBox boundigBox;
    private String atribution;
    private double minscaledeno;
    private double maxscaledeno;
    private boolean queryable;
    private Project project;

    public Layer() {

    }

    public Layer(Element layer, Project project) {

        setName(layer.getElement("Name").getText());
        setTitle(layer.getElement("Title").getText());
        setSummary(layer.getElement("Abstract").getText());
        
        System.out.println(getTitle());
        keywordList = new Vector();
        Element wordlist = layer.getElement("KeywordList");
        for (int i = 0; i < wordlist.getChildCount(); i++) {
            Object ele = wordlist.getChild(i);
            if (ele instanceof Element) {
                Element keyword = (Element) ele;
                if (keyword.getName().equals("Keyword")) { //for each keyword 
                    getKeywordList().addElement(keyword.getText());
                }
            }
        }

        setCRS(project.getCrs());
        setEx_BoundingBox(new Ex_BoundingBox(layer.getElement("EX_GeographicBoundingBox")));
        setBoundigBox(new BBox(layer.getElement("BoundingBox")));
        
        try {
            setAtribution(layer.getElement("Attribution").getElement("Title").getText());
        } catch (Exception ex) {
           setAtribution("");
        }

        try {
            setMinscaledeno(Double.parseDouble(layer.getElement("MinScaleDenominator").getText()));
        } catch (Exception ex) {           
           setMinscaledeno(Double.NaN);
        }
        
        try {
            setMaxscaledeno(Double.parseDouble(layer.getElement("MaxScaleDenominator").getText()));            
        } catch (Exception ex) {                      
           setMaxscaledeno(Double.NaN);
        }
        
        if (layer.getAttribute("queryable").getValue().equals("1")) {
            setQueryable(true);
        } else {
            setQueryable(false);
        }
        
        setProject(project);
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getSummary() {
        return summary;
    }

    public void setSummary(String summary) {
        this.summary = summary;
    }

    public Vector getKeywordList() {
        return keywordList;
    }

    public void setKeywordList(Vector keywordList) {
        this.keywordList = keywordList;
    }

    public CRS getCRS() {
        return CRS;
    }

    public void setCRS(CRS CRS) {
        this.CRS = CRS;
    }

    public Ex_BoundingBox getEx_BoundingBox() {
        return exBoundingBox;
    }

    public void setEx_BoundingBox(Ex_BoundingBox exBoundingBox) {
        this.exBoundingBox = exBoundingBox;
    }

    public BBox getBoundigBox() {
        return boundigBox;
    }

    public void setBoundigBox(BBox boundigBox) {
        this.boundigBox = boundigBox;
    }

    public String getAtribution() {
        return atribution;
    }

    public void setAtribution(String atribution) {
        this.atribution = atribution;
    }

    public double getMinscaledeno() {
        return minscaledeno;
    }

    public void setMinscaledeno(double minscaledeno) {
        this.minscaledeno = minscaledeno;
    }

    public double getMaxscaledeno() {
        return maxscaledeno;
    }

    public void setMaxscaledeno(double maxscaledeno) {
        this.maxscaledeno = maxscaledeno;
    }

    public boolean isQueryable() {
        return queryable;
    }

    public void setQueryable(boolean queryable) {
        this.queryable = queryable;
    }

    public Project getProject() {
        return project;
    }

    public void setProject(Project project) {
        this.project = project;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String toString() {
        return this.getTitle();
    }

    public class Ex_BoundingBox {

        private double westBoundLongitude;
        private double eastBoundLongitude;
        private double southBoundLatitude;
        private double northBoundLatitude;

        public Ex_BoundingBox() {
        }

        public Ex_BoundingBox(Element exBoundingBox) {
            setWestBoundLongitude(Double.parseDouble(exBoundingBox.getElement("westBoundLongitude").getText()));
            setEastBoundLongitude(Double.parseDouble(exBoundingBox.getElement("eastBoundLongitude").getText()));
            setSouthBoundLatitude(Double.parseDouble(exBoundingBox.getElement("southBoundLatitude").getText()));
            setNorthBoundLatitude(Double.parseDouble(exBoundingBox.getElement("northBoundLatitude").getText()));
        }

        public double getWestBoundLongitude() {
            return westBoundLongitude;
        }

        public void setWestBoundLongitude(double westBoundLongitude) {
            this.westBoundLongitude = westBoundLongitude;
        }

        public double getEastBoundLongitude() {
            return eastBoundLongitude;
        }

        public void setEastBoundLongitude(double eastBoundLongitude) {
            this.eastBoundLongitude = eastBoundLongitude;
        }

        public double getSouthBoundLatitude() {
            return southBoundLatitude;
        }

        public void setSouthBoundLatitude(double southBoundLatitude) {
            this.southBoundLatitude = southBoundLatitude;
        }

        public double getNorthBoundLatitude() {
            return northBoundLatitude;
        }

        public void setNorthBoundLatitude(double northBoundLatitude) {
            this.northBoundLatitude = northBoundLatitude;
        }
    }
}
