/*
 * Created on 6 de agosto de 2007, 05:26 PM
 */
package org.atlas.mobile.data;

import org.atlas.mobile.data.BBox;
import java.io.IOException;
import java.util.Vector;
import org.kxml.kdom.Element;

public class Project {

    private String name;
    private String title;
    private CRS crs;
    private BBox bbox;
    private Vector layers;

    public Project() {
    }

    public Project(Element project, String urlService) throws IOException {
        setName(project.getElement("Name").getText());
        setTile(project.getElement("Title").getText());
        setCrs(new CRS(project.getElement("CRS").getText(), urlService));
        setBbox(new BBox(project.getElement("BoundingBox")));
  
        layers = new Vector();
        for (int i = 0; i < project.getChildCount(); i++) {
            Object ele = project.getChild(i);
            if (ele instanceof Element) {
                Element layer = (Element) ele;
                
                if (layer.getName().equals("Layer")) { //for each layer 
                    getLayers().addElement(new Layer(layer, this));
                }
            }
        }

    }

    public String getTitle() {
        return title;
    }

    public void setTile(String title) {
        this.title = title;
    }

    public BBox getBbox() {
        return bbox;
    }

    public void setBbox(BBox bbox) {
        this.bbox = bbox;
    }

    public Vector getLayers() {
        return layers;
    }

    public void setLayers(Vector layers) {
        this.layers = layers;
    }

    public CRS getCrs() {
        return crs;
    }

    public void setCrs(CRS crs) {
        this.crs = crs;
    }

    public String toString() {
        return this.getTitle();
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }
}
