package org.atlas.mobile.events;

import org.atlas.mobile.gui.MapPanel;
import org.atlas.mobile.mashup.Marker;
import org.atlas.mobile.util.Point;

/**
 * Evento que dispara cuando usuario hace un toque sobre un marcador y 
 * el modo está fijado en MODEGETCOORD. 
 */
public class MarkerTapEvent {

    private Point screen;
    private Point map;
    private Marker marker;
    private MapPanel mappanel;
    
    /**     
     * @param mapPanel
     * @param screen
     * @param map
     * @param marker
     */
    
    public MarkerTapEvent(MapPanel mapPanel, Point screen, Point map, Marker marker) {        
        setMap(map);
        setScreen(screen);
        setMarker(marker);
        setMappanel(mapPanel);
    }

    public Point getScreen() {
        return screen;
    }

    public void setScreen(Point screen) {
        this.screen = screen;
    }

    public Point getMap() {
        return map;
    }

    public void setMap(Point map) {
        this.map = map;
    }

    public Marker getMarker() {
        return marker;
    }

    public void setMarker(Marker marker) {
        this.marker = marker;
    }

    public MapPanel getMappanel() {
        return mappanel;
    }

    public void setMappanel(MapPanel mappanel) {
        this.mappanel = mappanel;
    }

}
