package org.atlas.mobile.util;

import org.atlas.mobile.data.BBox;
import java.util.Vector;

public class Cache {

    private int currentsize;
    private int maxSize;
    private Vector cache;

    public Cache(int maxSize) {
        cache = new Vector();
        setMaxSize(maxSize);
        currentsize = 0;
    }

    public byte[] findImage(Square square) {
        if (cache != null) {
            BBox sb = square.getBbox();
            for (int i = 0; i < cache.size(); i++) {
                Bimage cbi = (Bimage) cache.elementAt(i);
                if (cbi.getBbox().equals(sb)) {
                    return cbi.getBytes();
                }
            }
        }
        return null;
    }

    public void add(byte[] bytes, BBox bbox) {
        if (cache != null) {            
            if ((bytes.length + currentsize) <= getMaxSize()) {
                cache.addElement(new Bimage(bytes, bbox));
                currentsize += bytes.length;
            } else {
                this.remove();
                if (bytes.length <= getMaxSize()) {
                    this.add(bytes, bbox);
                }
            }
        }
    }

    private void remove() {
        Bimage b = (Bimage) cache.elementAt(0);
        cache.removeElementAt(0);
        currentsize -= b.getBytes().length;
    }
    
    public void clear(){
        cache.removeAllElements();
        currentsize = 0;
    }

    public double getMaxSize() {
        return maxSize;
    }

    public void setMaxSize(int maxSize) {
        this.maxSize = maxSize;
    }

    private class Bimage {

        private byte[] bytes;
        private BBox bbox;

        public Bimage(byte[] bytes, BBox bbox) {
            setBytes(bytes);
            setBbox(bbox);
        }

        public byte[] getBytes() {
            return bytes;
        }

        public void setBytes(byte[] bytes) {
            this.bytes = bytes;
        }

        public BBox getBbox() {
            return bbox;
        }

        public void setBbox(BBox bbox) {
            this.bbox = bbox;
        }
    }
}


