package org.atlas.mobile.util;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import javax.microedition.io.Connector;
import javax.microedition.io.HttpConnection;

public class IO {

    private static ByteArrayOutputStream readFromStream(InputStream inStream) throws IOException {
        ByteArrayOutputStream outStream = new ByteArrayOutputStream();
        int dat = 0;
        while ((dat = inStream.read()) != -1) {
            outStream.write(dat);
        }
        outStream.close();
        inStream.close();
        return outStream;
    }
    
    public static byte[] readFromURL(String url) throws IOException {
        HttpConnection con = (HttpConnection) Connector.open(url, Connector.READ, true);
        con.setRequestMethod(HttpConnection.GET);
        return readFromStream(con.openInputStream()).toByteArray();
    }
    
    public static byte[] readFromClassPath(String classpath) throws IOException {        
        return readFromStream(System.class.getResourceAsStream(classpath)).toByteArray();
    }
}
