package org.atlas.mobile.util;

public class Mathe {

    final static public double LOGdiv2 = -0.6931471805599453094;
    
    public static double pow(double base, int exponent) {
        double res = 1;
        while (exponent > 0) {
            res *= base;
            exponent--;
        }
        return res;
    }

    public static double log(double x) {
        if (!(x > 0.)) {
            return Double.NaN;
        }

        if (x == 1.0) {
            return 0.0;
        }

        if (x > 1.) {
            x = 1 / x;
            return -_log(x);
        }

        return _log(x);
    }

    private static double _log(double x) {
        if (!(x > 0.)) {
            return Double.NaN;
        }
        
        double f = 0.0;
        int appendix = 0;
        while (x > 0.0 && x <= 1.0) {
            x *= 2.0;
            appendix++;
        }
        
        x /= 2.0;
        appendix--;
        
        double y1 = x - 1.;
        double y2 = x + 1.;
        double y = y1 / y2;
        
        double k = y;
        y2 = k * y;
        
        for (long i = 1; i < 50; i += 2) {
            f += k / i;
            k *= y2;
        }
        
        f *= 2.0;
        for (int i = 0; i < appendix; i++) {
            f += LOGdiv2;
        }
        
        return f;
    }
}

