/*
 * WMSExceptionUtil.java
 *
 * Created on 16 de julio de 2007, 12:41 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package exceptions;

/**
 * Clase de utilidad, permite generar el documento XML de una excepción WMS.
 * @author zaitsev
 */
public class WMSExceptionUtil {
    
    public static final String InvalidFormat   = "InvalidFormat";
    public static final String InvalidCRS      = "InvalidCRS";
    public static final String LayerNotDefined = "LayerNotDefined";
    public static final String StyleNotDefined = "StyleNotDefined";
    public static final String LayerNotQueryable = "LayerNotQueryable";
    public static final String InvalidPoint = "InvalidPoint";
    public static final String CurrentUpdateSequence = "CurrentUpdateSequence";
    public static final String InvalidUpdateSequence = "InvalidUpdateSequence";
    public static final String MissingDimensionValue = "MissingDimensionValue";
    public static final String InvalidDimensionValue = "InvalidDimensionValue";
    public static final String OperationNotSupported = "OperationNotSupported";
    
    /**
     * Retorna un documento XML que contiene información sobre una excepción 
     * en el servicio WMS según lo especifica el estándar.
     * @param code
     * @return
     */
    public static String getXMLException(String code){
        String doc;
        doc =  "<?xml version='1.0' encoding=\"UTF-8\"?>";
        doc += "\n<ServiceExceptionReport version=\"1.3.0\"";
        doc += "\n  xmlns=\"http://www.opengis.net/ogc\"";
        doc += "\n  xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"";
        doc += "\n  xsi:schemaLocation=\"http://www.opengis.net/ogc http://schemas.opengis.net/wms/1.3.0/exceptions_1_3_0.xsd\">";
        doc += ("\n<ServiceException code=\""+code+"\">");
        doc += "\n</ServiceException>";
        doc += "\n</ServiceExceptionReport>";
        return doc;
    }
}
